#pragma once

#include "..\PartFile.h"
#include "..\MuleListCtrl.h"
#include "..\resource.h"

// CFDParts dialog

enum EnumFDPartsStatus
{
	FDPARTS_STAT_DOWNLOADING = 0,
	FDPARTS_STAT_CORRUPTED,
	FDPARTS_STAT_NONE,
	FDPARTS_STAT_NOTAVAILABLE,
	FDPARTS_STAT_COMPLETE,

	FDPARTS_STAT_COUNT
};

typedef struct
{
	unsigned	uiCompleteSz;
	unsigned	uiSrcNum1;
	unsigned	uiSrcNum2;
	unsigned	uiStatus;
} PartInfoType;

class CFDParts : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDParts)

// Construction
public:
	CFDParts();
	~CFDParts();

	void Update();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDParts)
	enum { IDD = IDD_FDPPG_PARTS };
	//}}AFX_DATA

	afx_msg void OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnFilterChange();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CFDParts)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

private:
	CMuleListCtrl	m_PartsListCtrl;
	bool			m_bSortAscending[FDPARTSCOL_NUMCOLUMNS + 1];
	static std::vector<PartInfoType>	s_aPartInfo;
	CBitmap			m_bmpDownloadStatus;
	CBitmap			m_bmpUploadStatus;
	CBitmap			m_bmpCompletionStatus;

	void Localize();
	void SortInit(int iSortCode);
};
