// Ini2.h: Ini-File-Interface by bond006 <rene.landgrebe@gmx.de>
// ****************************************************************
// This new interface replaces the old interface which was too slow

#pragma once
#include "types.h"

class CIni : public CFile
{
public:
	CIni(const CString& strFileName);
	~CIni();

	void		CloseWithoutSave(){CloseFile();}
	void		SaveAndClose();

	void		AddCategory(const CString& strCategoryName);
	void		SetDefaultCategory(const CString& strCategoryName);
	void		SetDefaultCategory(const TCHAR *pcCategoryName);
	void		DeleteCategory(const CString& strCategoryName);
	void		DeleteEntry(const CString& strCategoryName, const CString& strEntryName);

	CString		GetString(const TCHAR *pcEntryName, const CString& defValue);
	double		GetDouble(const TCHAR *pcEntryName, double defValue);
	float		GetFloat(const TCHAR *pcEntryName, float defValue);
	int			GetInt(const TCHAR *pcEntryName, int defValue);
	WORD		GetWORD(const TCHAR *pcEntryName, WORD defValue);
	uint32		GetUInt32(const TCHAR *pcEntryName, uint32 defValue);
	uint64		GetUInt64(const TCHAR *pcEntryName, uint64 defValue);
	bool		GetBool(const TCHAR *pcEntryName, bool defValue);
	void		SetString(const TCHAR *pcEntryName, const CString& strValue);
	void		SetDouble(const TCHAR *pcEntryName, double dValue);
	void		SetFloat(const TCHAR *pcEntryName, float fValue);
	void		SetInt(const TCHAR *pcEntryName, int nValue);
	void		SetWORD(const TCHAR *pcEntryName, WORD wValue);
	void		SetUInt32(const TCHAR *pcEntryName, uint32 nValue);
	void		SetUInt64(const TCHAR *pcEntryName, uint64 nValue);
	void		SetBool(const TCHAR *pcEntryName, bool bValue);

	void		GetArray(CString* pString, int nElements, const TCHAR *pcEntryName);
	void		GetArray(double* pDouble, int nElements, const TCHAR *pcEntryName);
	void		GetArray(float* pFloat, int nElements, const TCHAR *pcEntryName);
	void		GetArray(int* pInt, int nElements, const TCHAR *pcEntryName);
	void		GetArray(WORD* pWord, int nElements, const TCHAR *pcEntryName);
	void		GetArray(bool* pBool, int nElements, const TCHAR *pcEntryName);
	void		SetArray(CString* pString, int nElements, const TCHAR *pcEntryName);
	void		SetArray(double* pDouble, int nElements, const TCHAR *pcEntryName);
	void		SetArray(float* pFloat, int nElements, const TCHAR *pcEntryName);
	void		SetArray(int* pInt, int nElements, const TCHAR *pcEntryName);
	void		SetArray(WORD* pWord, int nElements, const TCHAR *pcEntryName);
	void		SetArray(bool* pBool, int nElements, const TCHAR *pcEntryName);

	bool		CategoryExist(const CString& strCategoryName);
	bool		EntryExist(const CString &strCategoryName, const TCHAR *pcEntryName);
	bool		ValueExist(const CString& strCategoryName, const CString& strEntryName);

private:
	void		OpenFile(const CString& strFileName);
	void		CloseFile();
	void		ReadData();

	void		SetValue(const TCHAR *pcEntryName, const CString &strValue);
	CString		GetValue(const TCHAR *pcEntryName);

	CString m_strDefCategory;
	CString m_strFileBuffer;
};
