#include "stdafx.h"
#include "emule.h"
#include "WebServer.h"
#include "ED2KLink.h"
#include "MD5Sum.h"
#include "Smtp.h"
#include "ini2.h"
#include "QArray.h"
#include <stdlib.h>
#include "HTRichEditCtrl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define HTTPInit _T("Server: eMule\r\nConnection: close\r\nContent-Type: text/html\r\n")
#define HTTPInitGZ _T("Server: eMule\r\nConnection: close\r\nContent-Type: text/html\r\nContent-Encoding: gzip\r\n")

#define WEB_SERVER_TEMPLATES_VERSION	1006

//SyruS CQArray-Sorting operators
bool operator > (QueueUsers & first, QueueUsers & second)
{
	return (first.sIndex.CompareNoCase(second.sIndex) > 0);
}

bool operator < (QueueUsers & first, QueueUsers & second)
{
	return (first.sIndex.CompareNoCase(second.sIndex) < 0);
}

static dwThread = 0;
static bool	WSdownloadColumnHidden[9];
static bool	WSuploadColumnHidden[5];
static bool	WSqueueColumnHidden[4];
static bool	WSsharedColumnHidden[7];
static bool	WSserverColumnHidden[10];
static bool	WSsearchColumnHidden[5];

CWebServer::CWebServer(void)
{
	m_Params.bShowUploadQueue = false;
	m_Params.bShowUploadQueueBanned = false;
	m_Params.bShowUploadQueueFriend = false;
	m_Params.bShowUploadQueueCredit = false;

	m_Params.DownloadSort = DOWN_SORT_NAME;
	m_Params.bDownloadSortReverse = true;
	m_Params.UploadSort = UP_SORT_FILENAME;
	m_Params.bUploadSortReverse = true;
	m_Params.QueueSort = QU_SORT_FILENAME;
	m_Params.bQueueSortReverse = true;
	m_Params.ServerSort = SERVER_SORT_NAME;
	m_Params.bServerSortReverse = true;
	m_Params.SharedSort = SHARED_SORT_NAME;
	m_Params.bSharedSortReverse = true;

	m_Params.sLastModified.Empty();
	m_Params.sETag.Empty();
	m_iSearchSortby=3;
	m_bSearchAsc = false;

	dwThread = GetCurrentThreadId();
	m_bServerWorking = false;

	m_nIntruderDetect = 0;
	m_nStartTempDisabledTime = 0;
	m_bIsTempDisabled = false;
}

void CWebServer::ReloadTemplates()
{
	EMULE_TRY

	byte	abyteDigest[16];
	CString	sPrevLocale(setlocale(LC_TIME, NULL));

	_tsetlocale(LC_TIME, _T("English"));
	CTime t = CTime::GetCurrentTime();
	m_Params.sLastModified = t.FormatGmt("%a, %d %b %Y %H:%M:%S GMT");
	m_Params.sETag = HashToString(MD5Sum(m_Params.sLastModified, abyteDigest));
	_tsetlocale(LC_TIME, sPrevLocale);

	CString sFile;
	if (g_eMuleApp.m_pGlobPrefs->GetTemplate().IsEmpty() || g_eMuleApp.m_pGlobPrefs->GetTemplate().MakeLower()=="emulexp.tmpl")
		sFile= g_eMuleApp.m_pGlobPrefs->GetAppDir() + CString("eMuleXP.tmpl");
	else
		sFile=g_eMuleApp.m_pGlobPrefs->GetTemplate();

	CStdioFile file;
	if (file.Open(sFile, CFile::modeRead|CFile::shareDenyWrite|CFile::typeText))
	{
		CString sAll, sLine;
		for(;;)
		{
			if(!file.ReadString(sLine))
				break;

			sAll += sLine;
			sAll += _T('\n');
		}
		file.Close();

		CString sVersion = _LoadTemplate(sAll,_T("TMPL_VERSION"));
		long lVersion = _tstol(sVersion);
		if(lVersion < WEB_SERVER_TEMPLATES_VERSION)
		{
			if(g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled() || m_bServerWorking)
				AddLogLine(true,RGB_LOG_ERROR + GetResString(IDS_WS_ERR_LOADTEMPLATE), sFile);
			if (m_bServerWorking)
				StopSockets();
            m_bServerWorking = false;
			g_eMuleApp.m_pGlobPrefs->SetWSIsEnabled(false);
		}
		else
		{
			m_Templates.sHeader = _LoadTemplate(sAll,_T("TMPL_HEADER"));
			m_Templates.sHeaderStylesheet = _LoadTemplate(sAll,_T("TMPL_HEADER_STYLESHEET"));
			m_Templates.sFooter = _LoadTemplate(sAll,_T("TMPL_FOOTER"));
			m_Templates.sServerList = _LoadTemplate(sAll,_T("TMPL_SERVER_LIST"));
			m_Templates.sServerLine = _LoadTemplate(sAll,_T("TMPL_SERVER_LINE"));
			m_Templates.sTransferImages = _LoadTemplate(sAll,_T("TMPL_TRANSFER_IMAGES"));
			m_Templates.sTransferList = _LoadTemplate(sAll,_T("TMPL_TRANSFER_LIST"));
			m_Templates.sTransferDownHeader = _LoadTemplate(sAll,_T("TMPL_TRANSFER_DOWN_HEADER"));
			m_Templates.sTransferDownFooter = _LoadTemplate(sAll,_T("TMPL_TRANSFER_DOWN_FOOTER"));
			m_Templates.sTransferDownLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_DOWN_LINE"));
			m_Templates.sTransferUpHeader = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_HEADER"));
			m_Templates.sTransferUpFooter = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_FOOTER"));
			m_Templates.sTransferUpLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_LINE"));
			m_Templates.sTransferUpQueueShow = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_SHOW"));
			m_Templates.sTransferUpQueueHide = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_HIDE"));
			m_Templates.sTransferUpQueueLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_LINE"));
			m_Templates.sTransferUpQueueBannedShow = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_BANNED_SHOW"));
			m_Templates.sTransferUpQueueBannedHide = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_BANNED_HIDE"));
			m_Templates.sTransferUpQueueBannedLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_BANNED_LINE"));
			m_Templates.sTransferUpQueueFriendShow = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_FRIEND_SHOW"));
			m_Templates.sTransferUpQueueFriendHide = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_FRIEND_HIDE"));
			m_Templates.sTransferUpQueueFriendLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_FRIEND_LINE"));
			m_Templates.sTransferUpQueueCreditShow = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_CREDIT_SHOW"));
			m_Templates.sTransferUpQueueCreditHide = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_CREDIT_HIDE"));
			m_Templates.sTransferUpQueueCreditLine = _LoadTemplate(sAll,_T("TMPL_TRANSFER_UP_QUEUE_CREDIT_LINE"));
			m_Templates.sSharedList = _LoadTemplate(sAll,_T("TMPL_SHARED_LIST"));
			m_Templates.sSharedLine = _LoadTemplate(sAll,_T("TMPL_SHARED_LINE"));
			m_Templates.sGraphs = _LoadTemplate(sAll,_T("TMPL_GRAPHS"));
			m_Templates.sLog = _LoadTemplate(sAll,_T("TMPL_LOG"));
			m_Templates.sServerInfo = _LoadTemplate(sAll,_T("TMPL_SERVERINFO"));
			m_Templates.sDebugLog = _LoadTemplate(sAll,_T("TMPL_DEBUGLOG"));
			m_Templates.sStats = _LoadTemplate(sAll,_T("TMPL_STATS"));
			m_Templates.sPreferences = _LoadTemplate(sAll,_T("TMPL_PREFERENCES"));
			m_Templates.sLogin = _LoadTemplate(sAll,_T("TMPL_LOGIN"));
			m_Templates.sAddServerBox = _LoadTemplate(sAll,_T("TMPL_ADDSERVERBOX"));
			m_Templates.sSearch = _LoadTemplate(sAll,_T("TMPL_SEARCH"));
			m_Templates.iProgressbarWidth = _tstoi(_LoadTemplate(sAll,_T("PROGRESSBARWIDTH")));
			m_Templates.sSearchHeader = _LoadTemplate(sAll,_T("TMPL_SEARCH_RESULT_HEADER"));
			m_Templates.sSearchResultLine = _LoadTemplate(sAll,_T("TMPL_SEARCH_RESULT_LINE"));
			m_Templates.sProgressbarImgs = _LoadTemplate(sAll,_T("PROGRESSBARIMGS"));
			m_Templates.sProgressbarImgsPercent = _LoadTemplate(sAll,_T("PROGRESSBARPERCENTIMG"));
			m_Templates.sCatArrow= _LoadTemplate(sAll,"TMPL_CATARROW");
			m_Templates.sDownArrow= _LoadTemplate(sAll,"TMPL_DOWNARROW");
			m_Templates.sUpArrow= _LoadTemplate(sAll,"TMPL_UPARROW");
			m_Templates.strDownDoubleArrow = _LoadTemplate(sAll,"TMPL_DNDOUBLEARROW");
			m_Templates.strUpDoubleArrow = _LoadTemplate(sAll,"TMPL_UPDOUBLEARROW");

			m_Templates.sProgressbarImgsPercent.Replace(_T("[PROGRESSGIFNAME]"),_T("%s"));
			m_Templates.sProgressbarImgsPercent.Replace(_T("[PROGRESSGIFINTERNAL]"),_T("%i"));
			m_Templates.sProgressbarImgs.Replace(_T("[PROGRESSGIFNAME]"),_T("%s"));
			m_Templates.sProgressbarImgs.Replace(_T("[PROGRESSGIFINTERNAL]"),_T("%i"));
		}
	}
	else
        if(m_bServerWorking)
		{
			AddLogLine(true, RGB_LOG_ERROR + GetResString(IDS_WEB_ERR_CANTLOAD), sFile);
			StopSockets();
            m_bServerWorking = false;
			g_eMuleApp.m_pGlobPrefs->SetWSIsEnabled(false);
		}

	EMULE_CATCH
}

CWebServer::~CWebServer(void)
{
	if (m_bServerWorking) StopSockets();
}

CString CWebServer::_LoadTemplate(CString sAll, CString sTemplateName)
{
	EMULE_TRY

	CString fullpath;
	fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
	CIni ini( fullpath );

	ini.SetDefaultCategory(_T("WebServer"));
	ini.GetArray(WSdownloadColumnHidden, ELEMENT_COUNT(WSdownloadColumnHidden), _T("downloadColumnHidden"));
	ini.GetArray(WSuploadColumnHidden, ELEMENT_COUNT(WSuploadColumnHidden), _T("uploadColumnHidden"));
	ini.GetArray(WSqueueColumnHidden, ELEMENT_COUNT(WSqueueColumnHidden), _T("queueColumnHidden"));
	ini.GetArray(WSsearchColumnHidden, ELEMENT_COUNT(WSsearchColumnHidden), _T("searchColumnHidden"));
	ini.GetArray(WSsharedColumnHidden, ELEMENT_COUNT(WSsharedColumnHidden), _T("sharedColumnHidden"));
	ini.GetArray(WSserverColumnHidden, ELEMENT_COUNT(WSserverColumnHidden), _T("serverColumnHidden"));
	ini.SaveAndClose();
	CString sRet;
	int nStart = sAll.Find(_T("<--") + sTemplateName + _T("-->"));
	int nEnd = sAll.Find(_T("<--") + sTemplateName + _T("_END-->"));
	if(nStart != -1 && nEnd != -1 && nStart<nEnd)
	{
		nStart += sTemplateName.GetLength() + 7;
		sRet = sAll.Mid(nStart, nEnd - nStart - 1);
	}
	else
	{
		if (sTemplateName=="TMPL_VERSION")
			AddLogLine(true, RGB_LOG_ERROR + GetResString(IDS_WS_ERR_LOADTEMPLATE), sTemplateName);
		if (nStart==-1)
			AddLogLine(false, RGB_LOG_ERROR + GetResString(IDS_WEB_ERR_CANTLOAD), sTemplateName);
	}
	return sRet;

	EMULE_CATCH

	return _T("");
}

void CWebServer::RestartServer()
{	//Cax2 - restarts the server with the new port settings
	StopSockets();
	if (m_bServerWorking)
		StartSockets(this);
}

void CWebServer::StartServer(void)
{
	EMULE_TRY
	if(m_bServerWorking != g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled())
		m_bServerWorking = g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled();
	else
		return;

	if (m_bServerWorking)
	{
		ReloadTemplates();
		StartSockets(this);
		m_nIntruderDetect = 0;
		m_nStartTempDisabledTime = 0;
		m_bIsTempDisabled = false;
	}
	else
		StopSockets();

	if(g_eMuleApp.m_pGlobPrefs->GetWSIsEnabled() && m_bServerWorking)
		AddLogLine(false, _T("%s: %s"),_GetPlainResString(IDS_PW_HTTPD), _GetPlainResString(IDS_ENABLED).MakeLower());
	else
		AddLogLine(false, _T("%s: %s"),_GetPlainResString(IDS_PW_HTTPD), _GetPlainResString(IDS_DISABLED).MakeLower());

	EMULE_CATCH
}

void CWebServer::_RemoveServer(CString sIP, int nPort)
{
	EMULE_TRY

	CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
	if (server!=NULL) g_eMuleApp.m_pdlgEmule->SendMessage(WEB_REMOVE_SERVER, (WPARAM)server, NULL);

	EMULE_CATCH
}

void CWebServer::_AddToStatic(CString sIP, int nPort)
{
	EMULE_TRY

	CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
	if (server!=NULL) g_eMuleApp.m_pdlgEmule->SendMessage(WEB_ADD_TO_STATIC, (WPARAM)server, NULL);

	EMULE_CATCH
}

void CWebServer::_RemoveFromStatic(CString sIP, int nPort)
{
	EMULE_TRY

	CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
	if (server!=NULL) g_eMuleApp.m_pdlgEmule->SendMessage(WEB_REMOVE_FROM_STATIC, (WPARAM)server, NULL);

	EMULE_CATCH
}

void CWebServer::_SetSharedFileJumpstart(CString hash)
{
	EMULE_TRY

	CKnownFile* cur_file;
	uchar fileid[16];
	if (hash.GetLength()!=32 || !DecodeBase16(hash.GetBuffer(),hash.GetLength(),fileid,ARRSIZE(fileid)))
		return;

	cur_file=g_eMuleApp.m_pSharedFilesList->GetFileByID(fileid);

	if (cur_file==0)
 		return;

#ifdef OLD_SOCKETS_ENABLED
//	Don't allow to enable JumpStart for small files
	if (cur_file->GetFileSize() > PARTSIZE)
		cur_file->SetJumpstartEnabled(true);
#endif //OLD_SOCKETS_ENABLED

	g_eMuleApp.m_pSharedFilesList->UpdateItem(cur_file);

	EMULE_CATCH
}

void CWebServer::_SetSharedFileNoJumpstart(CString hash)
{
	EMULE_TRY

	CKnownFile* cur_file;
	uchar fileid[16];

	if (hash.GetLength()!=32 || !DecodeBase16(hash.GetBuffer(),hash.GetLength(),fileid,ARRSIZE(fileid)))
		return;

	cur_file=g_eMuleApp.m_pSharedFilesList->GetFileByID(fileid);

	if (cur_file==0)
 		return;

#ifdef OLD_SOCKETS_ENABLED
	cur_file->SetJumpstartEnabled(false);
#endif //OLD_SOCKETS_ENABLED

	g_eMuleApp.m_pSharedFilesList->UpdateItem(cur_file);

	EMULE_CATCH
}

void CWebServer::AddStatsLine(UpDown line)
{
	EMULE_TRY

	m_Params.PointsForWeb.Add(line);
	if(m_Params.PointsForWeb.GetCount() > WEB_GRAPH_WIDTH)
		m_Params.PointsForWeb.RemoveAt(0);

	EMULE_CATCH
}

CString CWebServer::_SpecialChars(CString str, bool noquote /*=false*/)
{
	EMULE_TRY

	str.Replace(_T("&"),_T("&amp;"));
	str.Replace(_T("<"),_T("&lt;"));
	str.Replace(_T(">"),_T("&gt;"));
	str.Replace(_T("\""),_T("&quot;"));
	if(noquote)
	{
		str.Replace(_T("'"), _T("&#8217;"));
		str.Replace(_T("\n"), _T("\\n"));
	}
	return str;

	EMULE_CATCH

	return _T("");
}

void CWebServer::_ConnectToServer(CString sIP, int nPort)
{
	EMULE_TRY

	CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
	if (server!=NULL) g_eMuleApp.m_pdlgEmule->SendMessage(WEB_CONNECT_TO_SERVER, (WPARAM)server, NULL);

	EMULE_CATCH
}

void CWebServer::ProcessImgFileReq(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return;

	CString filename=Data.sURL;
	CString contenttype;

	if (filename.Right(4).MakeLower()==".gif") contenttype="Content-Type: image/gif\r\n";
	else if (filename.Right(4).MakeLower()==".jpg"  || filename.Right(5).MakeLower()==".jpeg")
		contenttype="Content-Type: image/jpg\r\n";
	else if (filename.Right(4).MakeLower()==".bmp")
		contenttype="Content-Type: image/bmp\r\n";
	else if (filename.Right(4).MakeLower()==".png")
		contenttype="Content-Type: image/png\r\n";
	else if (filename.Right(4).MakeLower()==".ico")
		contenttype="Content-Type: image/x-icon\r\n";
	else if (filename.Right(4).MakeLower()==".css")
		contenttype="Content-Type: text/css\r\n";
	else if (filename.Right(3).MakeLower()==".js")
		contenttype="Content-Type: text/javascript\r\n";

	contenttype += _T("Last-Modified: ") + pThis->m_Params.sLastModified + _T("\r\n") + _T("ETag: ") + pThis->m_Params.sETag + _T("\r\n");

	// DonGato: expire images after 30 days (can be override by browser)
	CString sPrevLocale(setlocale(LC_TIME, NULL));
	_tsetlocale(LC_TIME, _T("English"));
	CTime t = CTime::GetCurrentTime();
	t += 60*60*24*30;
	CString expires = t.FormatGmt("%a, %d %b %Y %H:%M:%S GMT");
	_tsetlocale(LC_TIME, sPrevLocale);
	contenttype += _T("Expires: ") + expires + _T("\r\n");

	filename.Delete(0);
	filename.Replace('/','\\');
	filename=CString(g_eMuleApp.m_pGlobPrefs->GetAppDir())+_T("WebServer\\")+filename;
	CFile file;
	if(file.Open(filename, CFile::modeRead|CFile::shareDenyWrite|CFile::typeBinary))
	{
		TCHAR* buffer=new TCHAR[file.GetLength()];
		int size=file.Read(buffer,file.GetLength());
		file.Close();
		Data.pSocket->SendContent(contenttype, buffer, size);
		delete[] buffer;
	}

	EMULE_CATCH
}

void CWebServer::ProcessURL(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return;

	SetThreadLocale(g_eMuleApp.m_pGlobPrefs->GetLanguageID());

	//(0.29b)//////////////////////////////////////////////////////////////////
	// Here we are in real trouble! We are accessing the entire emule main thread
	// data without any syncronization!! Either we use the message pump for m_pdlgEmule
	// or use some hundreds of critical sections... For now, an exception handler
	// shoul avoid the worse things.
	//////////////////////////////////////////////////////////////////////////
	CoInitialize(NULL);

	EMULE_TRY
	bool isUseGzip = g_eMuleApp.m_pGlobPrefs->GetWebUseGzip();
	CString Out;
	CString OutE;	// List Entry Templates
	CString OutS;	// ServerStatus Templates
	TCHAR *gzipOut = NULL;
	long gzipLen=0;

	CString HTTPProcessData;
	srand ( time(NULL) );
	DWORD dwCurTick = ::GetTickCount();

	long lSession = 0;
	if(!_ParseURL(Data.sURL, _T("ses")).IsEmpty())
		lSession = _tstol(_ParseURL(Data.sURL, _T("ses")));

	if(pThis->GetIsTempDisabled() &&
	((dwCurTick - pThis->m_nStartTempDisabledTime) > (g_eMuleApp.m_pGlobPrefs->GetWSTempDisableLogin() * 60000)))
	{
		pThis->m_bIsTempDisabled = false;
		pThis->m_nStartTempDisabledTime = 0;
		AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_INTRBLOCKEND));
	}

	if ((_ParseURL(Data.sURL, _T("w")) == "password") && !pThis->GetIsTempDisabled())
	{
		byte	abyteDigest[16], abyteWSPass[16];
		CString	t_ulCurIP;
		t_ulCurIP.Format(_T("%u.%u.%u.%u"),(byte)pThis->m_ulCurIP,(byte)(pThis->m_ulCurIP>>8),(byte)(pThis->m_ulCurIP>>16),(byte)(pThis->m_ulCurIP>>24));

		if (md4cmp(MD5Sum(_ParseURL(Data.sURL, _T("p")), abyteDigest), g_eMuleApp.m_pGlobPrefs->GetWSPass(abyteWSPass)) == 0)
		{
			Session ses;
			ses.admin=true;
			ses.startTime = CTime::GetCurrentTime();
			ses.lSession = lSession = rand() * 10000L + rand();
			pThis->m_Params.Sessions.Add(ses);
			AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_ADMINLOGIN), t_ulCurIP);
			pThis->m_nIntruderDetect = 0;
		}
		else if ( g_eMuleApp.m_pGlobPrefs->GetWSIsLowUserEnabled() &&
			(md4cmp(abyteDigest, g_eMuleApp.m_pGlobPrefs->GetWSLowPass(abyteWSPass)) == 0) )
		{
			Session ses;
			ses.admin=false;
			ses.startTime = CTime::GetCurrentTime();
			ses.lSession = lSession = rand() * 10000L + rand();
			pThis->m_Params.Sessions.Add(ses);
			AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_GUESTLOGIN), t_ulCurIP);
			pThis->m_nIntruderDetect = 0;
		}
		else if(g_eMuleApp.m_pGlobPrefs->IsWSIntruderDetectionEnabled())
		{
				pThis->m_nIntruderDetect++;
				AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_INTRTRIESLEFT), t_ulCurIP, g_eMuleApp.m_pGlobPrefs->GetWSLoginAttemptsAllowed()-(pThis->m_nIntruderDetect));
				if (pThis->m_nIntruderDetect == g_eMuleApp.m_pGlobPrefs->GetWSLoginAttemptsAllowed())
				{
					AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_INTRDETECTION), pThis->m_nIntruderDetect);
				if (g_eMuleApp.m_pGlobPrefs->GetWSTempDisableLogin() > 0)
				{
					pThis->m_nStartTempDisabledTime = ::GetTickCount();
					pThis->m_bIsTempDisabled = true;
					pThis->AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_INTRBLOCKTIME), g_eMuleApp.m_pGlobPrefs->GetWSTempDisableLogin());
					pThis->m_nIntruderDetect = 0;
					CString MessageText;
					MessageText.Format(GetResString(IDS_WEB_INTRBLOCKTIME), g_eMuleApp.m_pGlobPrefs->GetWSTempDisableLogin());
					g_eMuleApp.m_pSMTPConnection->SendMail(MessageText, g_eMuleApp.m_pGlobPrefs->GetNotifierPopOnWebServerError(), g_eMuleApp.m_pGlobPrefs->IsSMTPWarningEnabled());
	                g_eMuleApp.m_pdlgEmule->ShowNotifier(MessageText, TBN_WEBSERVER, false, g_eMuleApp.m_pGlobPrefs->GetNotifierPopOnWebServerError());
				}
				else
				{
					g_eMuleApp.m_pGlobPrefs->SetWSIsEnabled(false);
		            pThis->m_bServerWorking = false;
					StopSockets();
					AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_INTRWEBDISABLE));
					pThis->m_nIntruderDetect = 0;
					CString MessageText;
					MessageText.Format(GetResString(IDS_WEB_INTRWEBDISABLE));
					g_eMuleApp.m_pSMTPConnection->SendMail(MessageText, g_eMuleApp.m_pGlobPrefs->GetNotifierPopOnWebServerError(), g_eMuleApp.m_pGlobPrefs->IsSMTPWarningEnabled());
	                g_eMuleApp.m_pdlgEmule->ShowNotifier(MessageText, TBN_WEBSERVER, false, g_eMuleApp.m_pGlobPrefs->GetNotifierPopOnWebServerError());
				}
			}
		}
		else
			AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_BADLOGINATTEMPT));
		isUseGzip = false;
	}

	CString sSession; sSession.Format(_T("%ld"), lSession);

	if (_ParseURL(Data.sURL, _T("w")) == "logout")
		_RemoveSession(Data, lSession);

	if(_IsLoggedIn(Data, lSession))
	{
		if (_ParseURL(Data.sURL, _T("w")) == "close")
		{
			g_eMuleApp.m_app_state = g_eMuleApp.APP_STATE_SHUTINGDOWN;
			SendMessage(g_eMuleApp.m_pdlgEmule->m_hWnd,WM_CLOSE,0,0);
		}
		else if (_ParseURL(Data.sURL, _T("w")) == "shutdown")
		{
			HANDLE hToken;
			TOKEN_PRIVILEGES tkp;	// Get a token for this process.
			try
			{
				if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
					throw;
				LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid);
				tkp.PrivilegeCount = 1;  // one privilege to set
				tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;	// Get the shutdown privilege for this process.
				AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
				ExitWindowsEx(EWX_SHUTDOWN | EWX_FORCE, 0);
			}
			catch(...)
			{
				AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_SHUTDOWN) + _T(' ') + GetResString(IDS_FAILED));
			}
		}
		else if (_ParseURL(Data.sURL, _T("w")) == "reboot")
		{
			HANDLE hToken;
			TOKEN_PRIVILEGES tkp;	// Get a token for this process.
			try
			{
				if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
					throw;
				LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid);
				tkp.PrivilegeCount = 1;  // one privilege to set
				tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;	// Get the shutdown privilege for this process.
				AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
				ExitWindowsEx(EWX_REBOOT | EWX_FORCE, 0);
			}
			catch(...)
			{
				AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_REBOOT) + _T(' ') + GetResString(IDS_FAILED));
			}
		}

		Out += _GetHeader(Data, lSession);
		CString sPage = _ParseURL(Data.sURL, _T("w"));
		if (sPage == "server")
			Out += _GetServerList(Data);
		else if (sPage == "shared")
			Out += _GetSharedFilesList(Data);
		else if (sPage == "transfer")
			Out += _GetTransferList(Data);
		else if (sPage == "search")
			Out += _GetSearch(Data);
		else if (sPage == "graphs")
			Out += _GetGraphs(Data);
		else if (sPage == "log")
			Out += _GetLog(Data);
		if (sPage == "sinfo")
			Out += _GetServerInfo(Data);
		if (sPage == "debuglog")
			Out += _GetDebugLog(Data);
		if (sPage == "stats")
			Out += _GetStats(Data);
		if (sPage == "options")
		{
			isUseGzip = false;
			Out += _GetPreferences(Data);
		}
		Out += _GetFooter(Data);

		if (sPage.IsEmpty())
			isUseGzip = false;

		if(isUseGzip)
		{
			bool bOk = false;
			try
			{
				uLongf destLen = Out.GetLength() + 1024;
				gzipOut = new TCHAR[destLen];
				if(_GzipCompress((Bytef*)gzipOut, &destLen, (const Bytef*)(TCHAR*)Out.GetBuffer(0), Out.GetLength(), Z_DEFAULT_COMPRESSION) == Z_OK)
				{
					bOk = true;
					gzipLen = destLen;
				}
			}
			catch(...)
			{
			}
			if(!bOk)
			{
				isUseGzip = false;
				if(gzipOut != NULL)
				{
					delete[] gzipOut;
					gzipOut = NULL;
				}
			}
		}
	}
	else
	{
		isUseGzip = false;
		Out += _GetLoginScreen(Data);
	}

	// send answer ...
	if(!isUseGzip)
		Data.pSocket->SendContent(HTTPInit, Out, Out.GetLength());
	else
		Data.pSocket->SendContent(HTTPInitGZ, gzipOut, gzipLen);
	if(gzipOut != NULL)
		delete[] gzipOut;

	EMULE_CATCH
	CoUninitialize();

	EMULE_CATCH
}

CString CWebServer::_ParseURLArray(CString URL, CString fieldname)
{
	EMULE_TRY

	CString res,temp;

	while (URL.GetLength()>0)
	{
		int pos=URL.MakeLower().Find(fieldname.MakeLower() + _T('='));
		if (pos >= 0)
		{
			temp=_ParseURL(URL,fieldname);
			if (temp.IsEmpty())
				break;
			res += temp;
			res += _T('|');
			URL.Delete(pos,10);
		}
		else
			break;
	}
	return res;

	EMULE_CATCH
	return _T("");
}

CString CWebServer::_ParseURL(const CString &URL, const TCHAR *pcFieldName)
{
	EMULE_TRY

	CString value;
	int i, findPos, findLength = 0;

	if ((findPos = URL.Find(_T('?'))) >= 0)
	{
		CString	fieldname(pcFieldName);
		CString	Parameter = URL.Mid(findPos + 1, URL.GetLength() - findPos - 1);

	// Search the fieldname beginning / middle and strip the rest...
		fieldname += _T('=');
		findPos = -1;
		if (Parameter.Find(fieldname) == 0)
		{
			findPos = 0;
			findLength = fieldname.GetLength();
		}
		if ((i = Parameter.Find(_T('&') + fieldname)) >= 0)
		{
			findPos = i;
			findLength = fieldname.GetLength() + 1;
		}
		if (findPos >= 0)
		{
			TCHAR fromReplace[4] = { _T('%') };	// decode URL
			TCHAR toReplace[2] = _T("\0");	// decode URL

			Parameter = Parameter.Mid(findPos + findLength, Parameter.GetLength());
			if ((findPos = Parameter.Find(_T('&'))) >= 0)
				Parameter = Parameter.Mid(0, findPos);

			value = Parameter;

			// decode value ...
			value.Replace(_T('+'), _T(' '));
			for (i = 0; i <= 255; i++)
			{
				_stprintf(&fromReplace[1], _T("%02x"), i);
				toReplace[0] = static_cast<TCHAR>(i);
				value.Replace(fromReplace, toReplace);
				_stprintf(&fromReplace[1], _T("%02X"), i);
				value.Replace(fromReplace, toReplace);
			}
		}
	}

	return value;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetHeader(ThreadData Data, long lSession)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	CString sSession; sSession.Format(_T("%ld"), lSession);

	CString Out = pThis->m_Templates.sHeader;

	Out.Replace(_T("[CharSet]"), _GetWebCharSet());

//	Auto-refresh code
	CString sRefresh, strDummyNumber, strCat;
	CString sPage = _ParseURL(Data.sURL, _T("w"));
	bool bAdmin = IsSessionAdmin(Data,sSession);

	strCat="&cat="+_ParseURL(Data.sURL, "cat");

	if (sPage == "options" || sPage == "stats" || sPage == "password")
		sRefresh.Format(_T("0"));
	else
		sRefresh.Format(_T("%d"), g_eMuleApp.m_pGlobPrefs->GetWebPageRefresh()*1000);

	strDummyNumber.Format(_T("%d"), rand());

	CString strVersionCheck;

	strVersionCheck.Format(_T("http://emuleplus.info/version_check.php?version=%i&language=%i"),CURRENT_PLUS_VERSION,g_eMuleApp.m_pGlobPrefs->GetLanguageID());

	int cat=atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("&cat=%i", cat);

	Out.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[RefreshVal]"), sRefresh);
	Out.Replace(_T("[wCommand]"), _ParseURL(Data.sURL, _T("w")) + strCat + _T("&dummy=") + strDummyNumber);
	Out.Replace(_T("[eMuleAppName]"), CLIENT_NAME);
	Out.Replace(_T("[version]"), CURRENT_VERSION_LONG);
	Out.Replace(_T("[StyleSheet]"), pThis->m_Templates.sHeaderStylesheet);
	Out.Replace(_T("[WebControl]"), _GetPlainResString(IDS_WEB_CONTROL));
	Out.Replace(_T("[Transfer]"), _GetPlainResString(IDS_CD_TRANS));
	Out.Replace(_T("[Server]"), _GetPlainResString(IDS_SV_SERVERLIST));
	Out.Replace(_T("[Shared]"), _GetPlainResString(IDS_SHAREDFILES));
	Out.Replace(_T("[Graphs]"), _GetPlainResString(IDS_GRAPHS));
	Out.Replace(_T("[Log]"), _GetPlainResString(IDS_SV_LOG));
	Out.Replace(_T("[ServerInfo]"), _GetPlainResString(IDS_SV_SERVERINFO));
	Out.Replace(_T("[DebugLog]"), _GetPlainResString(IDS_SV_DEBUGLOG));
	Out.Replace(_T("[Stats]"), _GetPlainResString(IDS_SF_STATISTICS));
	Out.Replace(_T("[Options]"), GetResString(IDS_EM_PREFS));
	Out.Replace(_T("[Ed2klink]"), _GetPlainResString(IDS_SW_LINK));
	Out.Replace(_T("[Close]"), _GetPlainResString(IDS_WEB_CLOSE));
	Out.Replace(_T("[Reboot]"), _GetPlainResString(IDS_WEB_REBOOT));
	Out.Replace(_T("[Shutdown]"), _GetPlainResString(IDS_WEB_SHUTDOWN));
	Out.Replace(_T("[Logout]"), _GetPlainResString(IDS_WEB_LOGOUT));
	Out.Replace(_T("[WebOptions]"), _GetPlainResString(IDS_WEB_OPTIONS));
	Out.Replace(_T("[Search]"), _GetPlainResString(IDS_SW_SEARCHBOX));
	Out.Replace(_T("[Download]"), _GetPlainResString(IDS_SW_DOWNLOAD));
	Out.Replace(_T("[Start]"), _GetPlainResString(IDS_SW_START));
	Out.Replace(_T("[Version]"), _GetPlainResString(IDS_SERVER_VERSION));
	Out.Replace(_T("[VersionCheck]"), strVersionCheck);
	if (CCat::GetNumCats() > 1)
		InsertCatBox(Out, 0, pThis->m_Templates.sCatArrow, false, false, sSession, "");
	else
		Out.Replace("[CATBOX]",_T(""));

	Out.Replace(_T("[FileIsHashing]"), _GetPlainResString(IDS_HASHING, true));
	Out.Replace(_T("[FileIsErroneous]"), _GetPlainResString(IDS_ERRORLIKE, true));
	Out.Replace(_T("[FileIsCompleting]"), _GetPlainResString(IDS_COMPLETING, true));
	Out.Replace(_T("[FileDetails]"), _GetPlainResString(IDS_FD_TITLE, true));
	Out.Replace(_T("[ClearCompleted]"), _GetPlainResString(IDS_DL_CLEAR, true));
	Out.Replace(_T("[A4AF]"), _GetPlainResString(IDS_ALL_A4AF_TO_HERE, true));
	Out.Replace(_T("[A4AFSameCat]"), _GetPlainResString(IDS_ALL_A4AF_SAMECAT, true));
	Out.Replace(_T("[AUTOA4AF]"), _GetPlainResString(IDS_ALL_A4AF_TO_HERE, true) + _T(" (") + _GetPlainResString(IDS_PRIOAUTO, true).MakeLower() + _T(")"));
	Out.Replace(_T("[Resume]"), _GetPlainResString(IDS_DL_RESUME, true));
	Out.Replace(_T("[Stop]"), _GetPlainResString(IDS_DL_STOP, true));
	Out.Replace(_T("[Pause]"), _GetPlainResString(IDS_DL_PAUSE, true));
	Out.Replace(_T("[ConfirmCancel]"), _GetPlainResString(IDS_Q_CANCELDL2, true));
	Out.Replace(_T("[Cancel]"), GetResString(IDS_MAIN_BTN_CANCEL));
	Out.Replace(_T("[GetFLC]"), _GetPlainResString(IDS_MOVIE, true));
	Out.Replace(_T("[Rename]"), _GetPlainResString(IDS_RENAME, true));
	Out.Replace(_T("[Connect]"), _GetPlainResString(IDS_IRC_CONNECT, true));
	Out.Replace(_T("[ConfirmRemove]"), _GetPlainResString(IDS_WEB_CONFIRM_REMOVE_SERVER, true));
	Out.Replace(_T("[ConfirmClose]"), _GetPlainResString(IDS_MAIN_CLOSE, true));
	Out.Replace(_T("[ConfirmReboot]"), _GetPlainResString(IDS_MAIN_REBOOT, true));
	Out.Replace(_T("[ConfirmShutdown]"), _GetPlainResString(IDS_MAIN_SHUTDOWN, true));
	Out.Replace(_T("[RemoveServer]"), _GetPlainResString(IDS_REMOVETHIS, true));
	Out.Replace(_T("[StaticServer]"), _GetPlainResString(IDS_STATICSERVER, true));
	Out.Replace(_T("[ConfirmJumpstart]"), _GetPlainResString(IDS_JS_DISABLE, true) + _T("\\n"));
	Out.Replace(_T("[Friend]"), _GetPlainResString(IDS_FRIEND, true));
	Out.Replace(_T("[CatSel]"), sCat);

	Out.Replace(_T("[PriorityVeryLow]"), _GetPlainResString(IDS_PRIOVERYLOW, true));
	Out.Replace(_T("[PriorityLow]"), _GetPlainResString(IDS_PRIOLOW, true));
	Out.Replace(_T("[PriorityNormal]"), _GetPlainResString(IDS_PRIONORMAL, true));
	Out.Replace(_T("[PriorityHigh]"), _GetPlainResString(IDS_PRIOHIGH, true));
	Out.Replace(_T("[PriorityRelease]"), _GetPlainResString(IDS_PRIORELEASE, true));
	Out.Replace(_T("[PriorityAuto]"), _GetPlainResString(IDS_PRIOAUTO, true));

	CString HTTPConState,HTTPConText,HTTPHelp;
	CString HTTPHelpU = _T("0");
	CString HTTPHelpM = _T("0");
	CString HTTPHelpV = _T("0");
	CString HTTPHelpF = _T("0");
	TCHAR HTTPHeader[100] = _T("");
#ifdef OLD_SOCKETS_ENABLED

	CString sCmd = _ParseURL(Data.sURL, _T("c"));
	bool disconnectissued = (sCmd.CompareNoCase(_T("disconnect")) == 0);
	bool connectissued = (sCmd.CompareNoCase(_T("connect")) == 0);

	if ((g_eMuleApp.m_pServerConnect->IsConnecting() && !disconnectissued) || connectissued)
	{
		HTTPConState = "connecting";
		HTTPConText = _GetPlainResString(IDS_CONNECTING);
	}
	else if (g_eMuleApp.m_pServerConnect->IsConnected() && !disconnectissued)
	{
		if(!g_eMuleApp.m_pServerConnect->IsLowID())
			HTTPConState = "high";
		else
			HTTPConState = "low";
		CServer* cur_server = g_eMuleApp.m_pServerList->GetServerByAddress(
			g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetAddress(),
			g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetPort() );

		if(cur_server->GetListName().GetLength() > SHORT_LENGTH)
			HTTPConText = CString(cur_server->GetListName().Left(SHORT_LENGTH-3) + _T("..."));
		else
			HTTPConText = CString(cur_server->GetListName());
		_stprintf(HTTPHeader, _T("%s"), CastItoThousands(cur_server->GetNumUsers()));
		HTTPHelpU = CString(HTTPHeader);
		_stprintf(HTTPHeader, _T("%s"), CastItoThousands(cur_server->GetMaxUsers()));
		HTTPHelpM = CString(HTTPHeader);
		_stprintf(HTTPHeader, _T("%s"), CastItoThousands(cur_server->GetFiles()));
		HTTPHelpF = CString(HTTPHeader);
		if ( cur_server->GetMaxUsers() > 0 )
			_stprintf(HTTPHeader, _T("%.1f "), (static_cast<double>(cur_server->GetNumUsers()) / cur_server->GetMaxUsers()) * 100.0);
		else
			_stprintf(HTTPHeader, _T("%.1f "), 0.0);
		HTTPHelpV = CString(HTTPHeader);

	}
	else
#endif //OLD_SOCKETS_ENABLED
	{
		HTTPConState = "disconnected";
		HTTPConText = _GetPlainResString(IDS_DISCONNECTED);
		if (IsSessionAdmin(Data,sSession)) HTTPConText+=_T(" (<a href=\"/?ses=") + sSession + _T("&w=server&c=connect\">")+_GetPlainResString(IDS_CONNECTTOANYSERVER)+_T("</a>)");
	}
	int allUsers = 0;
	int allFiles = 0;
	for (uint32 sc=0;sc<g_eMuleApp.m_pServerList->GetServerCount();sc++)
	{
		CServer* cur_server = g_eMuleApp.m_pServerList->GetServerAt(sc);
	    allUsers += cur_server->GetNumUsers();
	    allFiles += cur_server->GetFiles();
	}
	Out.Replace(_T("[AllUsers]"), CastItoThousands(allUsers));
	Out.Replace(_T("[AllFiles]"), CastItoThousands(allFiles));
	Out.Replace(_T("[ConState]"), HTTPConState);
	Out.Replace(_T("[ConText]"), HTTPConText);
	if(g_eMuleApp.m_pGlobPrefs->GetMaxUpload() == UNLIMITED)
		_stprintf(HTTPHeader, "%.1f", static_cast<double>(100 * g_eMuleApp.m_pUploadQueue->GetDataRate()) / 102.4 / g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate());
	else
		_stprintf(HTTPHeader, "%.1f", static_cast<double>(100 * g_eMuleApp.m_pUploadQueue->GetDataRate()) / 102.4 / g_eMuleApp.m_pGlobPrefs->GetMaxUpload());
	Out.Replace(_T("[UploadValue]"), HTTPHeader);

	if(g_eMuleApp.m_pGlobPrefs->GetMaxDownload() == UNLIMITED)
		_stprintf(HTTPHeader, "%.1f", static_cast<double>(100 * g_eMuleApp.m_pDownloadQueue->GetDataRate()) / 102.4 / g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate());
	else
		_stprintf(HTTPHeader, "%.1f", static_cast<double>(100 * g_eMuleApp.m_pDownloadQueue->GetDataRate()) / 102.4 / g_eMuleApp.m_pGlobPrefs->GetMaxDownload());
	Out.Replace(_T("[DownloadValue]"), HTTPHeader);
#ifdef OLD_SOCKETS_ENABLED
	_stprintf(HTTPHeader, "%.1f", (static_cast<double>(g_eMuleApp.m_pListenSocket->GetNumOpenSockets()))/(g_eMuleApp.m_pGlobPrefs->GetMaxConnections())*100.0);
	Out.Replace(_T("[ConnectionValue]"), HTTPHeader);
	_stprintf(HTTPHeader, "%.1f", (static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0));
	Out.Replace(_T("[CurUpload]"), HTTPHeader);
	_stprintf(HTTPHeader, "%.1f", (static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0));
	Out.Replace(_T("[CurDownload]"), HTTPHeader);
	_stprintf(HTTPHeader, "%.0f", (static_cast<double>(g_eMuleApp.m_pListenSocket->GetNumOpenSockets())));
	Out.Replace(_T("[CurConnection]"), HTTPHeader);
#endif //OLD_SOCKETS_ENABLED

	uint32		dwMax;

	dwMax = g_eMuleApp.m_pGlobPrefs->GetMaxUpload();
	if (dwMax == UNLIMITED)
		HTTPHelp = GetResString(IDS_PW_UNLIMITED);
	else
		FractionalRate2String(&HTTPHelp, dwMax);
	Out.Replace(_T("[MaxUpload]"), HTTPHelp);

	dwMax = g_eMuleApp.m_pGlobPrefs->GetMaxDownload();
	if (dwMax == UNLIMITED)
		HTTPHelp = GetResString(IDS_PW_UNLIMITED);
	else
		FractionalRate2String(&HTTPHelp, dwMax);
	Out.Replace(_T("[MaxDownload]"), HTTPHelp);

	dwMax = g_eMuleApp.m_pGlobPrefs->GetMaxConnections();
	if (dwMax == 65535)
		HTTPHelp = GetResString(IDS_PW_UNLIMITED);
	else
		HTTPHelp.Format(_T("%u"), dwMax);
	Out.Replace(_T("[MaxConnection]"), HTTPHelp);
	Out.Replace(_T("[UserValue]"), HTTPHelpV);
	Out.Replace(_T("[MaxUsers]"), HTTPHelpM);
	Out.Replace(_T("[CurUsers]"), HTTPHelpU);
	Out.Replace(_T("[CurFiles]"), HTTPHelpF);
	Out.Replace(_T("[Connection]"), _GetPlainResString(IDS_PW_CONNECTION));
	Out.Replace(_T("[QuickStats]"), _GetPlainResString(IDS_PW_QUICKSTATS));

	Out.Replace(_T("[Users]"), _GetPlainResString(IDS_UUSERS));
	Out.Replace(_T("[Files]"), _GetPlainResString(IDS_FILES));
	Out.Replace(_T("[Con]"), _GetPlainResString(IDS_ST_ACTIVECONNECTIONS));
	Out.Replace(_T("[Up]"), _GetPlainResString(IDS_UPLOAD_NOUN));
	Out.Replace(_T("[Down]"), _GetPlainResString(IDS_DOWNLOAD_NOUN));
	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetFooter(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	return pThis->m_Templates.sFooter;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetServerList(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString sSession = _ParseURL(Data.sURL, _T("ses"));
	bool bAdmin = IsSessionAdmin(Data,sSession);
	CString sAddServerBox = _GetAddServerBox(Data);

	CString sCmd = _ParseURL(Data.sURL, _T("c"));
	CString sIP = _ParseURL(Data.sURL, _T("ip"));
	int nPort = _tstoi(_ParseURL(Data.sURL, _T("port")));
	if (bAdmin &&  sCmd.CompareNoCase(_T("connect")) == 0)
	{
		if(sIP.IsEmpty())
			g_eMuleApp.m_pdlgEmule->SendMessage(WM_COMMAND, MP_CONNECT);
		else
			_ConnectToServer(sIP, nPort);
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("disconnect")) == 0)
	{
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			g_eMuleApp.m_pdlgEmule->ShowConnectionState(false);
		}
		else
#endif //OLD_SOCKETS_ENABLED
			g_eMuleApp.m_pdlgEmule->SendMessage(WM_COMMAND, MP_DISCONNECT);
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("remove")) == 0)
	{
		if(!sIP.IsEmpty())
			_RemoveServer(sIP, nPort);
	}
	else if (bAdmin && sCmd.CollateNoCase(_T("addtostatic")) == 0)
	{
		if(!sIP.IsEmpty())
			_AddToStatic(sIP, nPort);
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("removefromstatic")) == 0)
	{
		if(!sIP.IsEmpty())
			_RemoveFromStatic(sIP, nPort);
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("priolow")) == 0)
	{
		if(!sIP.IsEmpty())
		{
			CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
			server->SetPreference((CServer::EnumServerPriority)PR_LOW);
			if (g_eMuleApp.m_pdlgEmule->m_wndServer)
				g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*server);
		}
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("prionormal")) == 0)
	{
		if(!sIP.IsEmpty())
		{
			CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
			server->SetPreference((CServer::EnumServerPriority)PR_NORMAL);
			if (g_eMuleApp.m_pdlgEmule->m_wndServer)
				g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*server);
		}
	}
	else if (bAdmin && sCmd.CompareNoCase(_T("priohigh")) == 0)
	{
		if(!sIP.IsEmpty())
		{
			CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(sIP.GetBuffer(), nPort);
			server->SetPreference((CServer::EnumServerPriority)PR_HIGH);
			if (g_eMuleApp.m_pdlgEmule->m_wndServer)
				g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*server);
		}
	}
	else if (sCmd.CompareNoCase(_T("menu")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSserverColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSserverColumnHidden, ELEMENT_COUNT(WSserverColumnHidden), _T("serverColumnHidden"));
		ini.SaveAndClose();
	}

	CString strTmp = _ParseURL(Data.sURL, _T("sortreverse"));
	CString sSort = _ParseURL(Data.sURL, _T("sort"));

	if (!sSort.IsEmpty())
	{
		bool	bDirection = false;

		if(sSort == "state")
			pThis->m_Params.ServerSort = SERVER_SORT_STATE;
		else if(sSort == "name")
		{
			pThis->m_Params.ServerSort = SERVER_SORT_NAME;
			bDirection = true;
		}
		else if(sSort == "ip")
			pThis->m_Params.ServerSort = SERVER_SORT_IP;
		else if(sSort == "description")
		{
			pThis->m_Params.ServerSort = SERVER_SORT_DESCRIPTION;
			bDirection = true;
		}
		else if(sSort == "ping")
			pThis->m_Params.ServerSort = SERVER_SORT_PING;
		else if(sSort == "users")
			pThis->m_Params.ServerSort = SERVER_SORT_USERS;
		else if(sSort == "files")
			pThis->m_Params.ServerSort = SERVER_SORT_FILES;
		else if(sSort == "priority")
			pThis->m_Params.ServerSort = SERVER_SORT_PRIORITY;
		else if(sSort == "failed")
			pThis->m_Params.ServerSort = SERVER_SORT_FAILED;
		else if(sSort == "limit")
			pThis->m_Params.ServerSort = SERVER_SORT_LIMIT;
		else if(sSort == "version")
			pThis->m_Params.ServerSort = SERVER_SORT_VERSION;

		if (strTmp.IsEmpty())
			pThis->m_Params.bServerSortReverse = bDirection;
	}
	if (!strTmp.IsEmpty())
		pThis->m_Params.bServerSortReverse = (strTmp == "true");

	CString Out = pThis->m_Templates.sServerList;

	Out.Replace(_T("[AddServerBox]"), sAddServerBox);
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[CatSel]"), sCat);

	strTmp = (pThis->m_Params.bServerSortReverse) ? _T("&sortreverse=false") : _T("&sortreverse=true");

	if(pThis->m_Params.ServerSort == SERVER_SORT_STATE)
		Out.Replace(_T("[SortState]"), strTmp);
	else
		Out.Replace(_T("[SortState]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_NAME)
		Out.Replace(_T("[SortName]"), strTmp);
	else
		Out.Replace(_T("[SortName]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_IP)
		Out.Replace(_T("[SortIP]"), strTmp);
	else
		Out.Replace(_T("[SortIP]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_DESCRIPTION)
		Out.Replace(_T("[SortDescription]"), strTmp);
	else
		Out.Replace(_T("[SortDescription]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_PING)
		Out.Replace(_T("[SortPing]"), strTmp);
	else
		Out.Replace(_T("[SortPing]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_USERS)
		Out.Replace(_T("[SortUsers]"), strTmp);
	else
		Out.Replace(_T("[SortUsers]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_FILES)
		Out.Replace(_T("[SortFiles]"), strTmp);
	else
		Out.Replace(_T("[SortFiles]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_PRIORITY)
		Out.Replace(_T("[SortPriority]"), strTmp);
	else
		Out.Replace(_T("[SortPriority]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_FAILED)
		Out.Replace(_T("[SortFailed]"), strTmp);
	else
		Out.Replace(_T("[SortFailed]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_LIMIT)
		Out.Replace(_T("[SortLimit]"), strTmp);
	else
		Out.Replace(_T("[SortLimit]"), _T(""));
	if(pThis->m_Params.ServerSort == SERVER_SORT_VERSION)
		Out.Replace(_T("[SortVersion]"), strTmp);
	else
		Out.Replace(_T("[SortVersion]"), _T(""));
	Out.Replace(_T("[ServerList]"), _GetPlainResString(IDS_SV_SERVERLIST));

	const TCHAR *pcSortIcon = (pThis->m_Params.bServerSortReverse) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;

	_GetPlainResString(&strTmp, IDS_SL_SERVERNAME, true);
	if (!WSserverColumnHidden[0])
	{
		Out.Replace(_T("[ServernameI]"), (pThis->m_Params.ServerSort == SERVER_SORT_NAME) ? pcSortIcon : "");
		Out.Replace(_T("[ServernameH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[ServernameI]"), _T(""));
		Out.Replace(_T("[ServernameH]"), _T(""));
	}
	Out.Replace(_T("[ServernameM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_IP, true);
	if (!WSserverColumnHidden[1])
	{
		Out.Replace(_T("[AddressI]"), (pThis->m_Params.ServerSort == SERVER_SORT_IP) ? pcSortIcon : "");
		Out.Replace(_T("[AddressH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[AddressI]"), _T(""));
		Out.Replace(_T("[AddressH]"), _T(""));
	}
	Out.Replace(_T("[AddressM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DESCRIPTION, true);
	if (!WSserverColumnHidden[2])
	{
		Out.Replace(_T("[DescriptionI]"), (pThis->m_Params.ServerSort == SERVER_SORT_DESCRIPTION) ? pcSortIcon : "");
		Out.Replace(_T("[DescriptionH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DescriptionI]"), _T(""));
		Out.Replace(_T("[DescriptionH]"), _T(""));
	}
	Out.Replace(_T("[DescriptionM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_PING, true);
	if (!WSserverColumnHidden[3])
	{
		Out.Replace(_T("[PingI]"), (pThis->m_Params.ServerSort == SERVER_SORT_PING) ? pcSortIcon : "");
		Out.Replace(_T("[PingH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[PingI]"), _T(""));
		Out.Replace(_T("[PingH]"), _T(""));
	}
	Out.Replace(_T("[PingM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_UUSERS, true);
	if (!WSserverColumnHidden[4])
	{
		Out.Replace(_T("[UsersI]"), (pThis->m_Params.ServerSort == SERVER_SORT_USERS) ? pcSortIcon : "");
		Out.Replace(_T("[UsersH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UsersI]"), _T(""));
		Out.Replace(_T("[UsersH]"), _T(""));
	}
	Out.Replace(_T("[UsersM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_FILES, true);
	if (!WSserverColumnHidden[5])
	{
		Out.Replace(_T("[FilesI]"), (pThis->m_Params.ServerSort == SERVER_SORT_FILES) ? pcSortIcon : "");
		Out.Replace(_T("[FilesH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FilesI]"), _T(""));
		Out.Replace(_T("[FilesH]"), _T(""));
	}
	Out.Replace(_T("[FilesM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_PRIORITY, true);
	if (!WSserverColumnHidden[6])
	{
		Out.Replace(_T("[PriorityI]"), (pThis->m_Params.ServerSort == SERVER_SORT_PRIORITY) ? pcSortIcon : "");
		Out.Replace(_T("[PriorityH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[PriorityI]"), _T(""));
		Out.Replace(_T("[PriorityH]"), _T(""));
	}
	Out.Replace(_T("[PriorityM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_UFAILED, true);
	if (!WSserverColumnHidden[7])
	{
		Out.Replace(_T("[FailedI]"), (pThis->m_Params.ServerSort == SERVER_SORT_FAILED) ? pcSortIcon : "");
		Out.Replace(_T("[FailedH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FailedI]"), _T(""));
		Out.Replace(_T("[FailedH]"), _T(""));
	}
	Out.Replace(_T("[FailedM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SERVER_SOFTHARDLIMIT, true);
	if (!WSserverColumnHidden[8])
	{
		Out.Replace(_T("[LimitI]"), (pThis->m_Params.ServerSort == SERVER_SORT_LIMIT) ? pcSortIcon : "");
		Out.Replace(_T("[LimitH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[LimitI]"), _T(""));
		Out.Replace(_T("[LimitH]"), _T(""));
	}
	Out.Replace(_T("[LimitM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SERVER_VERSION, true);
	if (!WSserverColumnHidden[9])
	{
		Out.Replace(_T("[VersionI]"), (pThis->m_Params.ServerSort == SERVER_SORT_VERSION) ? pcSortIcon : "");
		Out.Replace(_T("[VersionH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[VersionI]"), _T(""));
		Out.Replace(_T("[VersionH]"), _T(""));
	}
	Out.Replace(_T("[VersionM]"), strTmp);

	Out.Replace(_T("[Actions]"), _GetPlainResString(IDS_WEB_ACTIONS));

	CArray<ServerEntry, ServerEntry> ServerArray;

#ifdef OLD_SOCKETS_ENABLED
	CServer		*tempServer;
#endif OLD_SOCKETS_ENABLED
	// Populating array
	for (uint32 sc=0;sc<g_eMuleApp.m_pServerList->GetServerCount();sc++)
	{
		CServer* cur_file = g_eMuleApp.m_pServerList->GetServerAt(sc);
		ServerEntry Entry;
		Entry.sServerName = _SpecialChars(cur_file->GetListName());
		Entry.sServerIP = cur_file->GetAddress();
		Entry.nServerPort = cur_file->GetPort();
		Entry.sServerDescription = _SpecialChars(cur_file->GetDescription());
		Entry.nServerPing = cur_file->GetPing();
		Entry.nServerUsers = cur_file->GetNumUsers();
		Entry.nServerMaxUsers = cur_file->GetMaxUsers();
		Entry.nServerFiles = cur_file->GetFiles();
		Entry.bServerStatic = cur_file->IsStaticMember();
		if(cur_file->GetPreferences()== CServer::SERVERPRIORITY_HIGH)
		{
			Entry.sServerPriority = _GetPlainResString(IDS_PRIOHIGH);
			Entry.nServerPriority = 2;
		}
		else if(cur_file->GetPreferences()== CServer::SERVERPRIORITY_NORMAL)
		{
			Entry.sServerPriority = _GetPlainResString(IDS_PRIONORMAL);
			Entry.nServerPriority = 1;
		}
		else if(cur_file->GetPreferences()== CServer::SERVERPRIORITY_LOW)
		{
			Entry.sServerPriority = _GetPlainResString(IDS_PRIOLOW);
			Entry.nServerPriority = 0;
		}
		Entry.nServerFailed = cur_file->GetFailedCount();
		Entry.nServerSoftLimit = cur_file->GetSoftMaxFiles();
		Entry.nServerHardLimit = cur_file->GetHardMaxFiles();
		Entry.sServerVersion = cur_file->GetVersion();
		int counter=0;
		CString temp,newip;
		for(int j=0; j<4; j++)
		{
			temp = Entry.sServerIP.Tokenize(_T("."),counter);
			if (temp.GetLength() == 1)
				newip.AppendFormat("00" + temp);
			else if (temp.GetLength() == 2)
				newip.AppendFormat("0" + temp);
			else if (temp.GetLength() == 3)
				newip.AppendFormat("" + temp);
        }
		Entry.sServerFullIP = newip;

		if (cur_file->GetFailedCount() > 0)
			Entry.sServerState = "failed";
		else
			Entry.sServerState = "disconnected";
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			tempServer = g_eMuleApp.m_pServerConnect->GetConnectingServer();
			if (tempServer->GetFullIP() == cur_file->GetFullIP())
				Entry.sServerState = "connecting";
		}
		else if (g_eMuleApp.m_pServerConnect->IsConnected())
		{
			tempServer = g_eMuleApp.m_pServerConnect->GetCurrentServer();
			if (tempServer->GetFullIP() == cur_file->GetFullIP())
			{
				if (!g_eMuleApp.m_pServerConnect->IsLowID())
					Entry.sServerState = "high";
				else
					Entry.sServerState = "low";
			}
		}
#endif //OLD_SOCKETS_ENABLED
		ServerArray.Add(Entry);
	}
	// Sorting (simple bubble sort, we don't have tons of data here)
	bool bSorted = true;
	for(int nMax = 0;bSorted && nMax < ServerArray.GetCount()*2; nMax++)
	{
		bSorted = false;
		for(int i = 0; i < ServerArray.GetCount() - 1; i++)
		{
			bool bSwap = false;
			switch(pThis->m_Params.ServerSort)
			{
			case SERVER_SORT_STATE:
				bSwap = ServerArray[i].sServerState.CompareNoCase(ServerArray[i+1].sServerState) > 0;
				break;
			case SERVER_SORT_NAME:
				bSwap = ServerArray[i].sServerName.CompareNoCase(ServerArray[i+1].sServerName) < 0;
				break;
			case SERVER_SORT_IP:
				bSwap = ServerArray[i].sServerFullIP < ServerArray[i+1].sServerFullIP;
				break;
			case SERVER_SORT_DESCRIPTION:
				bSwap = ServerArray[i].sServerDescription.CompareNoCase(ServerArray[i+1].sServerDescription) < 0;
				break;
			case SERVER_SORT_PING:
				bSwap = ServerArray[i].nServerPing < ServerArray[i+1].nServerPing;
				break;
			case SERVER_SORT_USERS:
				bSwap = ServerArray[i].nServerUsers < ServerArray[i+1].nServerUsers;
				break;
			case SERVER_SORT_FILES:
				bSwap = ServerArray[i].nServerFiles < ServerArray[i+1].nServerFiles;
				break;
			case SERVER_SORT_PRIORITY:
				bSwap = ServerArray[i].nServerPriority < ServerArray[i+1].nServerPriority;
				break;
			case SERVER_SORT_FAILED:
				bSwap = ServerArray[i].nServerFailed < ServerArray[i+1].nServerFailed;
				break;
			case SERVER_SORT_LIMIT:
				bSwap = ServerArray[i].nServerSoftLimit < ServerArray[i+1].nServerSoftLimit;
				break;
			case SERVER_SORT_VERSION:
				bSwap = ServerArray[i].sServerVersion < ServerArray[i+1].sServerVersion;
				break;
			}
			if(pThis->m_Params.bServerSortReverse)
				bSwap = !bSwap;
			if(bSwap)
			{
				bSorted = true;
				ServerEntry TmpEntry = ServerArray[i];
				ServerArray[i] = ServerArray[i+1];
				ServerArray[i+1] = TmpEntry;
			}
		}
	}

	// Displaying
	const TCHAR	*pcTmp, *pcTmp2;
	CString sList, HTTPProcessData, sServerPort, ed2k;
	CString OutE = pThis->m_Templates.sServerLine;

	OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));
	OutE.Replace(_T("[session]"), sSession);

	for(int i = 0; i < ServerArray.GetCount(); i++)
	{
		HTTPProcessData = OutE;	// Copy Entry Line to Temp

		sServerPort.Format(_T("%u"), ServerArray[i].nServerPort);
		ed2k.Format(_T("ed2k://|server|%s|%s|/"), ServerArray[i].sServerIP, sServerPort);

		if (ServerArray[i].sServerIP == _ParseURL(Data.sURL,_T("ip")) && sServerPort == _ParseURL(Data.sURL,_T("port")))
			pcTmp = "checked";
		else
			pcTmp = "checked_no";
		HTTPProcessData.Replace(_T("[LastChangedDataset]"), pcTmp);

		if (ServerArray[i].bServerStatic)
		{
			pcTmp = _T("staticsrv");
			pcTmp2 = _T("static");
		}
		else
		{
			pcTmp = _T("");
			pcTmp2 = _T("none");
		}
		HTTPProcessData.Replace(_T("[isstatic]"), pcTmp);
		HTTPProcessData.Replace(_T("[ServerType]"), pcTmp2);

		const TCHAR *pcSrvPriority = _T("");

		switch(ServerArray[i].nServerPriority)
		{
			case 0:
				pcSrvPriority = _T("Low");
				break;
			case 1:
				pcSrvPriority = _T("Normal");
				break;
			case 2:
				pcSrvPriority = _T("High");
				break;
		}

		HTTPProcessData.Replace(_T("[ed2k]"), ed2k);
		HTTPProcessData.Replace(_T("[ip]"), ServerArray[i].sServerIP);
		HTTPProcessData.Replace(_T("[port]"), sServerPort);
		HTTPProcessData.Replace(_T("[server-priority]"), pcSrvPriority);

		// DonGato: reduced large servernames or descriptions
		if (!WSserverColumnHidden[0])
		{
			if(ServerArray[i].sServerName.GetLength() > SHORT_LENGTH)
				HTTPProcessData.Replace(_T("[Servername]"), _T("<acronym title=\"") + ServerArray[i].sServerName + _T("\">") + ServerArray[i].sServerName.Left(SHORT_LENGTH-3) + _T("...") + _T("</acronym>"));
			else
				HTTPProcessData.Replace(_T("[Servername]"), ServerArray[i].sServerName);
		}
		else
			HTTPProcessData.Replace(_T("[Servername]"), _T(""));
		if (!WSserverColumnHidden[1])
		{
			CString sPort; sPort.Format(_T(":%d"), ServerArray[i].nServerPort);
			HTTPProcessData.Replace(_T("[Address]"), ServerArray[i].sServerIP + sPort);
		}
		else
			HTTPProcessData.Replace(_T("[Address]"), _T(""));
		if (!WSserverColumnHidden[2])
		{
			if(ServerArray[i].sServerDescription.GetLength() > SHORT_LENGTH)
				HTTPProcessData.Replace(_T("[Description]"), _T("<acronym title=\"") + ServerArray[i].sServerDescription + _T("\">") + ServerArray[i].sServerDescription.Left(SHORT_LENGTH-3) + _T("...") + _T("</acronym>"));
			else
				HTTPProcessData.Replace(_T("[Description]"), ServerArray[i].sServerDescription);
		}
		else
			HTTPProcessData.Replace(_T("[Description]"), _T(""));
		if (!WSserverColumnHidden[3])
		{
			CString sPing; sPing.Format(_T("%d"), ServerArray[i].nServerPing);
			HTTPProcessData.Replace(_T("[Ping]"), sPing);
		}
		else
			HTTPProcessData.Replace(_T("[Ping]"), _T(""));
		CString sT;
		if (!WSserverColumnHidden[4])
		{
			if(ServerArray[i].nServerUsers > 0)
			{
				if(ServerArray[i].nServerMaxUsers > 0)
					sT.Format(_T("%s (%s)"), CastItoThousands(ServerArray[i].nServerUsers), CastItoThousands(ServerArray[i].nServerMaxUsers));
				else
					sT.Format(_T("%s"), CastItoThousands(ServerArray[i].nServerUsers));
			}
			HTTPProcessData.Replace(_T("[Users]"), sT);
		}
		else
			HTTPProcessData.Replace(_T("[Users]"), _T(""));
		if (!WSserverColumnHidden[5] && (ServerArray[i].nServerFiles > 0))
		{
			HTTPProcessData.Replace(_T("[Files]"), CastItoThousands(ServerArray[i].nServerFiles));
		}
		else
			HTTPProcessData.Replace(_T("[Files]"), _T(""));
		if (!WSserverColumnHidden[6])
			HTTPProcessData.Replace(_T("[Priority]"), ServerArray[i].sServerPriority);
		else
			HTTPProcessData.Replace(_T("[Priority]"), _T(""));
		if (!WSserverColumnHidden[7])
		{
			CString sFailed; sFailed.Format(_T("%d"), ServerArray[i].nServerFailed);
			HTTPProcessData.Replace(_T("[Failed]"), sFailed);
		}
		else
			HTTPProcessData.Replace(_T("[Failed]"), _T(""));
		if (!WSserverColumnHidden[8])
		{
			CString		strTemp;

			strTemp.Format( _T("%s (%s)"), CastItoThousands(ServerArray[i].nServerSoftLimit),
				CastItoThousands(ServerArray[i].nServerHardLimit) );
			HTTPProcessData.Replace(_T("[Limit]"), strTemp);
		}
		else
			HTTPProcessData.Replace(_T("[Limit]"), _T(""));
		if (!WSserverColumnHidden[9])
		{
			if(ServerArray[i].sServerVersion.GetLength() > SHORT_LENGTH_MIN)
				HTTPProcessData.Replace(_T("[Version]"), _T("<acronym title=\"") + ServerArray[i].sServerVersion + _T("\">") + ServerArray[i].sServerVersion.Left(SHORT_LENGTH-3) + _T("...") + _T("</acronym>"));
			else
				HTTPProcessData.Replace(_T("[Version]"), ServerArray[i].sServerVersion);
		}
		else
			HTTPProcessData.Replace(_T("[Version]"), _T(""));
		HTTPProcessData.Replace(_T("[ServerState]"), ServerArray[i].sServerState);
		sList += HTTPProcessData;
	}
	Out.Replace(_T("[ServersList]"), sList);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetTransferList(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("&cat=%i", cat);

	CString HTTPTemp;
	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	bool bAdmin = IsSessionAdmin(Data,sSession);

	CString Out;

	CString sClear(_ParseURL(Data.sURL, _T("clearcompleted")));
	if (bAdmin && !sClear.IsEmpty())
	{
		if (sClear.CompareNoCase(_T("all")) == 0)
		{
			EnumCategories eCatID = (cat == 0) ? CAT_ALL : CCat::GetCatIDByUserIndex(cat);

			_EnumCategories eCatIDforMessage = eCatID;

			g_eMuleApp.m_pdlgEmule->SendMessage(WEB_CLEAR_COMPLETED, (WPARAM)0, static_cast<LPARAM>(eCatIDforMessage));

			cat = cat == 0 ? 0 : CCat::UserCatIndexToCatIndex(cat);
		}
		else
		{
			uchar	FileHash[16];

			if (md4cmp0(StringToHash(sClear, FileHash)) != 0)
			{
				uchar* pFileHash = new uchar[16];

				md4cpy(pFileHash, FileHash);
				g_eMuleApp.m_pdlgEmule->SendMessage(WEB_CLEAR_COMPLETED, (WPARAM)1, reinterpret_cast<LPARAM>(pFileHash));
			}
		}
	}

	HTTPTemp = _ParseURL(Data.sURL, _T("ed2k"));

	if (bAdmin && !HTTPTemp.IsEmpty())
	{
		EnumCategories	eCatID = cat == 0 ? CAT_NONE : CCat::GetCatIDByUserIndex(cat);
		g_eMuleApp.m_pdlgEmule->m_dlgSearch.AddEd2kLinksToDownload(HTTPTemp,eCatID);
		cat = cat == 0 ? 0 : CCat::UserCatIndexToCatIndex(cat);
	}

	HTTPTemp = _ParseURL(Data.sURL, _T("c"));

	if (HTTPTemp.CompareNoCase(_T("menudown")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSdownloadColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSdownloadColumnHidden, ELEMENT_COUNT(WSdownloadColumnHidden), _T("downloadColumnHidden"));
		ini.SaveAndClose();
	}
	else if (HTTPTemp.CompareNoCase(_T("menuup")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSuploadColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSuploadColumnHidden, ELEMENT_COUNT(WSuploadColumnHidden), _T("uploadColumnHidden"));
		ini.SaveAndClose();
	}
	else if (HTTPTemp.CompareNoCase(_T("menuqueue")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSqueueColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSqueueColumnHidden, ELEMENT_COUNT(WSqueueColumnHidden), _T("queueColumnHidden"));
		ini.SaveAndClose();
	}
	else if (HTTPTemp.CompareNoCase(_T("menuprio")) == 0)
	{
		if(bAdmin)
		{
			CString sPrio(_ParseURL(Data.sURL, _T("p")));
			int prio = PR_NORMAL;

			if(sPrio.CompareNoCase(_T("low")) == 0)
				prio = PR_LOW;
			else if(sPrio.CompareNoCase(_T("normal")) == 0)
				prio = PR_NORMAL;
			else if(sPrio.CompareNoCase(_T("high")) == 0)
				prio = PR_HIGH;
			else if(sPrio.CompareNoCase(_T("auto")) == 0)
				prio = PR_AUTO;

			if(cat != 0)
				g_eMuleApp.m_pDownloadQueue->SetCatPrio(cat,prio);
			else
				g_eMuleApp.m_pDownloadQueue->SetCatPrio(0,prio);
		}
	}

	if (bAdmin)
	{
		CString sOp(_ParseURL(Data.sURL, _T("op")));

		if (!sOp.IsEmpty())
		{
			CString sFile(_ParseURL(Data.sURL, _T("file")));
			uchar FileHash[16], UserHash[16];

			if (!sFile.IsEmpty())
			{
				CPartFile *found_file = g_eMuleApp.m_pDownloadQueue->GetFileByID(StringToHash(sFile, FileHash));
				if(found_file)
				{	// SyruS all actions require a found file (removed double-check inside)
					if (sOp.CompareNoCase(_T("a4af")) == 0)
						found_file->DownloadAllA4AF();
					else if (sOp.CompareNoCase(_T("a4afsamecat")) == 0)
						found_file->DownloadAllA4AF(true);
					else if (sOp.CompareNoCase(_T("autoa4af")) == 0)
						g_eMuleApp.m_pDownloadQueue->SetA4AFAutoFile(found_file);
					else if (sOp.CompareNoCase(_T("noautoa4af")) == 0)
						g_eMuleApp.m_pDownloadQueue->SetA4AFAutoFile(NULL);
					else if (sOp.CompareNoCase(_T("stop")) == 0)
						found_file->StopFile();
					else if (sOp.CompareNoCase(_T("pause")) == 0)
						found_file->PauseFile();
					else if (sOp.CompareNoCase(_T("resume")) == 0)
						found_file->ResumeFile();
					else if (sOp.CompareNoCase(_T("cancel")) == 0)
					{
						found_file->DeleteFile();
						g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateCatTabTitles();
					}
					else if (sOp.CompareNoCase(_T("getflc")) == 0)
						found_file->GetFirstLastChunk4Preview();
					else if (sOp.CompareNoCase(_T("rename")) == 0)
					{
						CString sNewName(_ParseURL(Data.sURL, _T("name")));
						g_eMuleApp.m_pdlgEmule->SendMessage(WEB_FILE_RENAME, (WPARAM)found_file, (LPARAM)(LPCTSTR)sNewName);
					}
					else if (sOp.CompareNoCase(_T("priolow")) == 0)
					{
						found_file->SetAutoPriority(false);
						found_file->SetPriority(PR_LOW);
					}
					else if (sOp.CompareNoCase(_T("prionormal")) == 0)
					{
						found_file->SetAutoPriority(false);
						found_file->SetPriority(PR_NORMAL);
					}
					else if (sOp.CompareNoCase(_T("priohigh")) == 0)
					{
						found_file->SetAutoPriority(false);
						found_file->SetPriority(PR_HIGH);
					}
					else if (sOp.CompareNoCase(_T("prioauto")) == 0)
					{
						found_file->SetAutoPriority(true);
						found_file->SetPriority(PR_HIGH);
					}
					else if (sOp.CompareNoCase(_T("setcat")) == 0)
					{
						int iMenu = atoi(_ParseURL(Data.sURL, _T("filecat")));
						if (iMenu != 0)
						{
							byte iCatIndex = CCat::UserCatIndexToCatIndex(iMenu);
							found_file->SetCatID(CCat::GetCatIDByIndex(iCatIndex));
						}
						else
							found_file->SetCatID(CAT_NONE);
					}
				}
			}
			else
			{
				CString sUser(_ParseURL(Data.sURL, _T("userhash")));

				if (md4cmp0(StringToHash(sUser, UserHash)) != 0)
				{
					CUpDownClient* cur_client = g_eMuleApp.m_pClientList->FindClientByUserHash(UserHash);
					if(cur_client)
					{
						if (sOp.CompareNoCase(_T("addfriend")) == 0)
							g_eMuleApp.m_pFriendList->AddFriend(cur_client);
						else if (sOp.CompareNoCase(_T("removefriend")) == 0)
							g_eMuleApp.m_pFriendList->RemoveFriend(cur_client);
					}
				}
			}
		}
	}

	CString strTmp = _ParseURL(Data.sURL, _T("sortreverse"));
	CString sSort(_ParseURL(Data.sURL, _T("sort")));
	bool	bDirection;

	if (!sSort.IsEmpty())
	{
		bDirection = false;
		if(sSort.CompareNoCase(_T("dstate")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_STATE;
		else if(sSort.CompareNoCase(_T("dtype")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_TYPE;
		else if(sSort.CompareNoCase(_T("dname")) == 0)
		{
			pThis->m_Params.DownloadSort = DOWN_SORT_NAME;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("dsize")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_SIZE;
		else if(sSort.CompareNoCase(_T("dtransferred")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_TRANSFERRED;
		else if(sSort.CompareNoCase(_T("dspeed")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_SPEED;
		else if(sSort.CompareNoCase(_T("dprogress")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_PROGRESS;
		else if(sSort.CompareNoCase(_T("dsources")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_SOURCES;
		else if(sSort.CompareNoCase(_T("dpriority")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_PRIORITY;
		else if(sSort.CompareNoCase(_T("dcategory")) == 0)
		{
			pThis->m_Params.DownloadSort = DOWN_SORT_CATEGORY;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("dfakecheck")) == 0)
			pThis->m_Params.DownloadSort = DOWN_SORT_FAKECHECK;
		else if(sSort.CompareNoCase(_T("uuser")) == 0)
		{
			pThis->m_Params.UploadSort = UP_SORT_USER;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("uclient")) == 0)
			pThis->m_Params.UploadSort = UP_SORT_CLIENT;
		else if(sSort.CompareNoCase(_T("uversion")) == 0)
			pThis->m_Params.UploadSort = UP_SORT_VERSION;
		else if(sSort.CompareNoCase(_T("ufilename")) == 0)
		{
			pThis->m_Params.UploadSort = UP_SORT_FILENAME;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("utransferred")) == 0)
			pThis->m_Params.UploadSort = UP_SORT_TRANSFERRED;
		else if(sSort.CompareNoCase(_T("uspeed")) == 0)
			pThis->m_Params.UploadSort = UP_SORT_SPEED;
		else if(sSort.CompareNoCase(_T("qclient")) == 0)
			pThis->m_Params.QueueSort = QU_SORT_CLIENT;
		else if(sSort.CompareNoCase(_T("quser")) == 0)
		{
			pThis->m_Params.QueueSort = QU_SORT_USER;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("qversion")) == 0)
			pThis->m_Params.QueueSort = QU_SORT_VERSION;
		else if(sSort.CompareNoCase(_T("qfilename")) == 0)
		{
			pThis->m_Params.QueueSort = QU_SORT_FILENAME;
			bDirection = true;
		}
		else if(sSort.CompareNoCase(_T("qscore")) == 0)
			pThis->m_Params.QueueSort = QU_SORT_SCORE;

		if (strTmp.IsEmpty())
		{
			if (sSort.GetAt(0) == 'd')
				pThis->m_Params.bDownloadSortReverse = bDirection;
			else if (sSort.GetAt(0) == 'u')
				pThis->m_Params.bUploadSortReverse = bDirection;
			else if (sSort.GetAt(0) == 'q')
				pThis->m_Params.bQueueSortReverse = bDirection;
		}
	}

	if (!strTmp.IsEmpty())
	{
		bDirection = (strTmp == "true");
		if (sSort.GetAt(0) == 'd')
			pThis->m_Params.bDownloadSortReverse = bDirection;
		else if (sSort.GetAt(0) == 'u')
			pThis->m_Params.bUploadSortReverse = bDirection;
		else if (sSort.GetAt(0) == 'q')
			pThis->m_Params.bQueueSortReverse = bDirection;
	}

	HTTPTemp.SetString(_ParseURL(Data.sURL, _T("showuploadqueue")));
	if (HTTPTemp.CompareNoCase(_T("true")) == 0)
		pThis->m_Params.bShowUploadQueue = true;
	else if (HTTPTemp.CompareNoCase(_T("false")) == 0)
		pThis->m_Params.bShowUploadQueue = false;

	HTTPTemp.SetString(_ParseURL(Data.sURL, _T("showuploadqueuebanned")));
	if (HTTPTemp.CompareNoCase(_T("true")) == 0)
		pThis->m_Params.bShowUploadQueueBanned = true;
	else if (HTTPTemp.CompareNoCase(_T("false")) == 0)
		pThis->m_Params.bShowUploadQueueBanned = false;

	HTTPTemp.SetString(_ParseURL(Data.sURL, _T("showuploadqueuefriend")));
	if (HTTPTemp.CompareNoCase(_T("true")) == 0)
		pThis->m_Params.bShowUploadQueueFriend = true;
	else if (HTTPTemp.CompareNoCase(_T("false")) == 0)
		pThis->m_Params.bShowUploadQueueFriend = false;

	HTTPTemp.SetString(_ParseURL(Data.sURL, _T("showuploadqueuecredit")));
	if (HTTPTemp.CompareNoCase(_T("true")) == 0)
		pThis->m_Params.bShowUploadQueueCredit = true;
	else if (HTTPTemp.CompareNoCase(_T("false")) == 0)
		pThis->m_Params.bShowUploadQueueCredit = false;

	Out += pThis->m_Templates.sTransferImages;
	Out += pThis->m_Templates.sTransferList;
	Out.Replace(_T("[DownloadHeader]"), pThis->m_Templates.sTransferDownHeader);
	Out.Replace(_T("[DownloadFooter]"), pThis->m_Templates.sTransferDownFooter);
	Out.Replace(_T("[UploadHeader]"), pThis->m_Templates.sTransferUpHeader);
	Out.Replace(_T("[UploadFooter]"), pThis->m_Templates.sTransferUpFooter);
	Out.Replace(_T("[Session]"), sSession);

	InsertCatBox(Out,cat,"",true,true,sSession,"");

	strTmp = (pThis->m_Params.bDownloadSortReverse) ? _T("&sortreverse=false") : _T("&sortreverse=true");

	if(pThis->m_Params.DownloadSort == DOWN_SORT_STATE)
		Out.Replace(_T("[SortDState]"), strTmp);
	else
		Out.Replace(_T("[SortDState]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_TYPE)
		Out.Replace(_T("[SortDType]"), strTmp);
	else
		Out.Replace(_T("[SortDType]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_NAME)
		Out.Replace(_T("[SortDName]"), strTmp);
	else
		Out.Replace(_T("[SortDName]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_SIZE)
		Out.Replace(_T("[SortDSize]"), strTmp);
	else
		Out.Replace(_T("[SortDSize]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_TRANSFERRED)
		Out.Replace(_T("[SortDTransferred]"), strTmp);
	else
		Out.Replace(_T("[SortDTransferred]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_SPEED)
		Out.Replace(_T("[SortDSpeed]"), strTmp);
	else
		Out.Replace(_T("[SortDSpeed]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_PROGRESS)
		Out.Replace(_T("[SortDProgress]"), strTmp);
	else
		Out.Replace(_T("[SortDProgress]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_SOURCES)
		Out.Replace(_T("[SortDSources]"), strTmp);
	else
		Out.Replace(_T("[SortDSources]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_PRIORITY)
		Out.Replace(_T("[SortDPriority]"), strTmp);
	else
		Out.Replace(_T("[SortDPriority]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_CATEGORY)
		Out.Replace(_T("[SortDCategory]"), strTmp);
	else
		Out.Replace(_T("[SortDCategory]"), _T(""));
	if(pThis->m_Params.DownloadSort == DOWN_SORT_FAKECHECK)
		Out.Replace(_T("[SortDFakeCheck]"), strTmp);
	else
		Out.Replace(_T("[SortDFakeCheck]"), _T(""));

	strTmp = (pThis->m_Params.bUploadSortReverse) ? _T("&sortreverse=false") : _T("&sortreverse=true");

	if(pThis->m_Params.UploadSort == UP_SORT_CLIENT)
		Out.Replace(_T("[SortUClient]"), strTmp);
	else
		Out.Replace(_T("[SortUClient]"), _T(""));
	if(pThis->m_Params.UploadSort == UP_SORT_USER)
		Out.Replace(_T("[SortUUser]"), strTmp);
	else
		Out.Replace(_T("[SortUUser]"), _T(""));
	if(pThis->m_Params.UploadSort == UP_SORT_VERSION)
		Out.Replace(_T("[SortUVersion]"), strTmp);
	else
		Out.Replace(_T("[SortUVersion]"), _T(""));
	if(pThis->m_Params.UploadSort == UP_SORT_FILENAME)
		Out.Replace(_T("[SortUFilename]"), strTmp);
	else
		Out.Replace(_T("[SortUFilename]"), _T(""));
	if(pThis->m_Params.UploadSort == UP_SORT_TRANSFERRED)
		Out.Replace(_T("[SortUTransferred]"), strTmp);
	else
		Out.Replace(_T("[SortUTransferred]"), _T(""));
	if(pThis->m_Params.UploadSort == UP_SORT_SPEED)
		Out.Replace(_T("[SortUSpeed]"), strTmp);
	else
		Out.Replace(_T("[SortUSpeed]"), _T(""));

	const TCHAR *pcSortIcon = (pThis->m_Params.bDownloadSortReverse) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;

	_GetPlainResString(&strTmp, IDS_DL_FILENAME, true);
	if (!WSdownloadColumnHidden[0])
	{
		Out.Replace(_T("[DFilenameI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_NAME) ? pcSortIcon : "");
		Out.Replace(_T("[DFilename]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DFilenameI]"), _T(""));
		Out.Replace(_T("[DFilename]"), _T(""));
	}
	Out.Replace(_T("[DFilenameM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SIZE, true);
	if (!WSdownloadColumnHidden[1])
	{
		Out.Replace(_T("[DSizeI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_SIZE) ? pcSortIcon : "");
		Out.Replace(_T("[DSize]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DSizeI]"), _T(""));
		Out.Replace(_T("[DSize]"), _T(""));
	}
	Out.Replace(_T("[DSizeM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SF_COMPLETED, true);
	if (!WSdownloadColumnHidden[2])
	{
		Out.Replace(_T("[DTransferredI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_TRANSFERRED) ? pcSortIcon : "");
		Out.Replace(_T("[DTransferred]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DTransferredI]"), _T(""));
		Out.Replace(_T("[DTransferred]"), _T(""));
	}
	Out.Replace(_T("[DTransferredM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_PROGRESS, true);
	if (!WSdownloadColumnHidden[3])
	{
		Out.Replace(_T("[DProgressI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_PROGRESS) ? pcSortIcon : "");
		Out.Replace(_T("[DProgress]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DProgressI]"), _T(""));
		Out.Replace(_T("[DProgress]"), _T(""));
	}
	Out.Replace(_T("[DProgressM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SPEED, true);
	if (!WSdownloadColumnHidden[4])
	{
		Out.Replace(_T("[DSpeedI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_SPEED) ? pcSortIcon : "");
		Out.Replace(_T("[DSpeed]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DSpeedI]"), _T(""));
		Out.Replace(_T("[DSpeed]"), _T(""));
	}
	Out.Replace(_T("[DSpeedM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SOURCES, true);
	if (!WSdownloadColumnHidden[5])
	{
		Out.Replace(_T("[DSourcesI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_SOURCES) ? pcSortIcon : "");
		Out.Replace(_T("[DSources]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DSourcesI]"), _T(""));
		Out.Replace(_T("[DSources]"), _T(""));
	}
	Out.Replace(_T("[DSourcesM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_PRIORITY, true);
	if (!WSdownloadColumnHidden[6])
	{
		Out.Replace(_T("[DPriorityI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_PRIORITY) ? pcSortIcon : "");
		Out.Replace(_T("[DPriority]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DPriorityI]"), _T(""));
		Out.Replace(_T("[DPriority]"), _T(""));
	}
	Out.Replace(_T("[DPriorityM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_CAT, true);
	if (!WSdownloadColumnHidden[7])
	{
		Out.Replace(_T("[DCategoryI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_CATEGORY) ? pcSortIcon : "");
		Out.Replace(_T("[DCategory]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DCategoryI]"), _T(""));
		Out.Replace(_T("[DCategory]"), _T(""));
	}
	Out.Replace(_T("[DCategoryM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_FAKE_CHECK_HEADER, true);
	if (!WSdownloadColumnHidden[8])
	{
		Out.Replace(_T("[DFakeCheckI]"), (pThis->m_Params.DownloadSort == DOWN_SORT_FAKECHECK) ? pcSortIcon : "");
		Out.Replace(_T("[DFakeCheck]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[DFakeCheckI]"), _T(""));
		Out.Replace(_T("[DFakeCheck]"), _T(""));
	}
	Out.Replace(_T("[DFakeCheckM]"), strTmp);

	pcSortIcon = (pThis->m_Params.bUploadSortReverse) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;

	_GetPlainResString(&strTmp, IDS_QL_USERNAME, true);
	if (!WSuploadColumnHidden[0])
	{
		Out.Replace(_T("[UUserI]"), (pThis->m_Params.UploadSort == UP_SORT_USER) ? pcSortIcon : "");
		Out.Replace(_T("[UUser]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UUserI]"), _T(""));
		Out.Replace(_T("[UUser]"), _T(""));
	}
	Out.Replace(_T("[UUserM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_INFLST_USER_CLIENTVERSION, true);
	if (!WSuploadColumnHidden[1])
	{
		Out.Replace(_T("[UVersionI]"), (pThis->m_Params.UploadSort == UP_SORT_VERSION) ? pcSortIcon : "");
		Out.Replace(_T("[UVersion]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UVersionI]"), _T(""));
		Out.Replace(_T("[UVersion]"), _T(""));
	}
	Out.Replace(_T("[UVersionM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_FILENAME, true);
	if (!WSuploadColumnHidden[2])
	{
		Out.Replace(_T("[UFilenameI]"), (pThis->m_Params.UploadSort == UP_SORT_FILENAME) ? pcSortIcon : "");
		Out.Replace(_T("[UFilename]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UFilenameI]"), _T(""));
		Out.Replace(_T("[UFilename]"), _T(""));
	}
	Out.Replace(_T("[UFilenameM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_ULDL, true);
	if (!WSuploadColumnHidden[3])
	{
		Out.Replace(_T("[UTransferredI]"), (pThis->m_Params.UploadSort == UP_SORT_TRANSFERRED) ? pcSortIcon : "");
		Out.Replace(_T("[UTransferred]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UTransferredI]"), _T(""));
		Out.Replace(_T("[UTransferred]"), _T(""));
	}
	Out.Replace(_T("[UTransferredM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SPEED, true);
	if (!WSuploadColumnHidden[4])
	{
		Out.Replace(_T("[USpeedI]"), (pThis->m_Params.UploadSort == UP_SORT_SPEED) ? pcSortIcon : "");
		Out.Replace(_T("[USpeed]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[USpeedI]"), _T(""));
		Out.Replace(_T("[USpeed]"), _T(""));
	}
	Out.Replace(_T("[USpeedM]"), strTmp);

	Out.Replace(_T("[DownloadList]"), _GetPlainResString(IDS_ST_ACTIVEDOWNLOAD));
	Out.Replace(_T("[UploadList]"), _GetPlainResString(IDS_ST_ACTIVEUPLOAD));
	Out.Replace(_T("[Actions]"), _GetPlainResString(IDS_WEB_ACTIONS));
	Out.Replace(_T("[TotalDown]"), _GetPlainResString(IDS_INFLST_USER_TOTALDOWNLOAD));
	Out.Replace(_T("[TotalUp]"), _GetPlainResString(IDS_INFLST_USER_TOTALUPLOAD));
	Out.Replace(_T("[CatSel]"), sCat);
	Out.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

	double fTotalSize = 0, fTotalTransferred = 0, fTotalSpeed = 0;
	CArray<DownloadFiles, DownloadFiles> FilesArray;
	bool							bLocalArray = false;
	CDownloadList::PartFileVector	*pvecPartFiles;
	CDownloadList::PartFileVector	vecPartFiles;
	if (!(pvecPartFiles = g_eMuleApp.m_pDownloadList->GetFiles()))
	{
		bLocalArray = true;
		pvecPartFiles = &vecPartFiles;
		vecPartFiles.erase(vecPartFiles.begin(),vecPartFiles.end());
	//	Populating array
		for (POSITION pos=g_eMuleApp.m_pDownloadQueue->m_partFileList.GetHeadPosition(); pos != NULL;)
		{
			CPartFile	*pPartFile = g_eMuleApp.m_pDownloadQueue->m_partFileList.GetNext(pos);

			if (pPartFile)
				vecPartFiles.push_back(pPartFile);
		}
	}
	for (unsigned int i = 0; i < pvecPartFiles->size(); i++)
	{
		CPartFile		*pPartFile = (*pvecPartFiles)[i];

		if (pPartFile)
		{

			if ( !CCat::FileBelongsToGivenCat( pPartFile, ( cat > CAT_PREDEFINED)
														 ? static_cast<_EnumCategories>(cat)
														 : CCat::GetCatIDByIndex(cat), true ) )
				continue;

			if(pPartFile->IsULAutoPrioritized())
				pPartFile->UpdateDownloadAutoPriority();

			DownloadFiles dFile;
			dFile.sFileName = _SpecialChars(pPartFile->GetFileName());
			dFile.sFileType = GetFileTypeForWebServer(dFile.sFileName);
			dFile.sFileNameJS = _SpecialChars(pPartFile->GetFileName(), true);	//for javascript
			dFile.m_qwFileSize = pPartFile->GetFileSize();
			dFile.m_qwFileTransferred = pPartFile->GetCompletedSize();
			dFile.m_dblCompleted = pPartFile->GetPercentCompleted();
			dFile.lFileSpeed = pPartFile->GetDataRate();

			if(pPartFile->GetDataRate() > 0)
			{
				dFile.sFileState = "downloading";
			}
			else
			{
				if (pPartFile != NULL && pPartFile->GetPartFileStatusID() == PS_STALLED)
					dFile.sFileState = "stalled";
				else
					dFile.sFileState = "waiting";
			}

			switch(pPartFile->GetStatus())
			{
				case PS_HASHING:
					dFile.sFileState = "hashing";
					break;
				case PS_WAITINGFORHASH:
					dFile.sFileState = "waitinghash";
					break;
				case PS_ERROR:
					dFile.sFileState = "error";
					break;
				case PS_COMPLETING:
					dFile.sFileState = "completing";
					break;
				case PS_COMPLETE:
					dFile.sFileState = "complete";
					break;
				case PS_STOPPED:
					dFile.sFileState = "stopped";
					break;
				case PS_PAUSED:
					dFile.sFileState = "paused";
					break;
				default:
					break;
			}

			dFile.bFileAutoPrio = pPartFile->IsAutoPrioritized();
			dFile.nFilePrio = pPartFile->GetPriority();
			CCat		*pCat = CCat::GetCatByID(pPartFile->GetCatID());
			CString		strCategory = (pCat != NULL) ? pCat->GetTitle() : GetResString(IDS_CAT_UNCATEGORIZED);
			strCategory.Replace(_T("'"),_T("\'"));
			dFile.sCategory = strCategory;
			dFile.sFileHash = HashToString(pPartFile->GetFileHash());
			dFile.lSourceCount = pPartFile->GetSourceCount();
			dFile.lNotCurrentSourceCount = pPartFile->GetNotCurrentSourcesCount();
			dFile.lTransferringSourceCount = pPartFile->GetTransferringSrcCount();
			dFile.bIsComplete = !pPartFile->IsPartFile();
			dFile.bIsPreview = pPartFile->PreviewAvailable();
			dFile.bIsGetFLC = (pPartFile->GetMovieMode() != 0);

#ifdef OLD_SOCKETS_ENABLED
			if (g_eMuleApp.m_pServerConnect->IsConnected() && !g_eMuleApp.m_pServerConnect->IsLowID())
				dFile.sED2kLink = pPartFile->CreateED2kSourceLink();
			else
#endif //OLD_SOCKETS_ENABLED
				dFile.sED2kLink = pPartFile->CreateED2kLink();
			dFile.sFileInfo = _SpecialChars(pPartFile->GetDownloadFileInfo());
			dFile.sFakeCheck = g_eMuleApp.m_pFakeCheck->GetFakeCheckComment(HashToString(pPartFile->GetFileHash()),pPartFile->GetFileSize());
			FilesArray.Add(dFile);
		}
	}

	if (!bLocalArray)
	{
		delete pvecPartFiles;
		pvecPartFiles = NULL;
	}

	// Sorting (simple bubble sort, we don't have tons of data here)
	bool bSorted = true;
	for(int nMax = 0;bSorted && nMax < FilesArray.GetCount()*2; nMax++)
	{
		bSorted = false;
		for(int i = 0; i < FilesArray.GetCount() - 1; i++)
		{
			bool bSwap = false;
			switch(pThis->m_Params.DownloadSort)
			{
			case DOWN_SORT_STATE:
				bSwap = FilesArray[i].sFileState.CompareNoCase(FilesArray[i+1].sFileState) < 0;
				break;
			case DOWN_SORT_TYPE:
				bSwap = FilesArray[i].sFileType.CompareNoCase(FilesArray[i+1].sFileType) < 0;
				break;
			case DOWN_SORT_NAME:
				bSwap = FilesArray[i].sFileName.CompareNoCase(FilesArray[i+1].sFileName) < 0;
				break;
			case DOWN_SORT_SIZE:
				bSwap = FilesArray[i].m_qwFileSize < FilesArray[i+1].m_qwFileSize;
				break;
			case DOWN_SORT_TRANSFERRED:
				bSwap = FilesArray[i].m_qwFileTransferred < FilesArray[i+1].m_qwFileTransferred;
				break;
			case DOWN_SORT_SPEED:
				bSwap = FilesArray[i].lFileSpeed < FilesArray[i+1].lFileSpeed;
				break;
			case DOWN_SORT_PROGRESS:
				bSwap = FilesArray[i].m_dblCompleted  < FilesArray[i+1].m_dblCompleted ;
				break;
			case DOWN_SORT_SOURCES:
				bSwap = FilesArray[i].lSourceCount  < FilesArray[i+1].lSourceCount ;
				break;
			case DOWN_SORT_PRIORITY:
				bSwap = FilesArray[i].nFilePrio < FilesArray[i+1].nFilePrio ;
				break;
			case DOWN_SORT_CATEGORY:
				bSwap = FilesArray[i].sCategory.CompareNoCase(FilesArray[i+1].sCategory) < 0;
				break;
			case DOWN_SORT_FAKECHECK:
				bSwap = FilesArray[i].sFakeCheck.CompareNoCase(FilesArray[i+1].sFakeCheck) < 0;
				break;
			}
			if(pThis->m_Params.bDownloadSortReverse)
				bSwap = !bSwap;
			if(bSwap)
			{
				bSorted = true;
				DownloadFiles TmpFile = FilesArray[i];
				FilesArray[i] = FilesArray[i+1];
				FilesArray[i+1] = TmpFile;
			}
		}
	}

	uint32	dwClientSoft;

	CArray<UploadUsers, UploadUsers> UploadArray;
	for (POSITION pos = g_eMuleApp.m_pUploadQueue->uploadinglist.GetHeadPosition(); pos != NULL;)
	{
		CUpDownClient* cur_client = g_eMuleApp.m_pUploadQueue->uploadinglist.GetNext(pos);
		UploadUsers dUser;
		CString sTemp;
		dUser.sUserHash = HashToString(cur_client->GetUserHash());
		if (cur_client->GetDataRate() > 0)
		{
			dUser.sActive = _T("downloading");
			dUser.sClientState = _T("uploading");
		}
		else
		{
			dUser.sActive = _T("waiting");
			dUser.sClientState = _T("connecting");
		}
		sTemp = _SpecialChars(cur_client->GetUploadFileInfo());
		sTemp.Replace(_T("\n"), _T("<br>"));
		sTemp.Replace(_T("'"), _T("&#8217;"));
		dUser.sFileInfo = sTemp;

		dwClientSoft = cur_client->GetClientSoft();
		if ( ((dwClientSoft == SO_EMULE) || (dwClientSoft == SO_PLUS)) &&
			(cur_client->m_pCredits->GetCurrentIdentState(cur_client->GetIP()) != IS_IDENTIFIED) )
		{
			dwClientSoft = SO_OLDEMULE;
		}
		sTemp.Format(_T("%u"), dwClientSoft);
		dUser.sClientSoft = sTemp;
		dUser.sClientSoftSpecial = sTemp;
		if (cur_client->IsBanned())
			dUser.sClientExtra = _T("banned");
		else if (cur_client->IsFriend())
			dUser.sClientExtra = _T("friend");
		else if (cur_client->m_pCredits->GetScoreRatio(cur_client->GetIP()) > 1)
			dUser.sClientExtra = _T("credit");
		else
			dUser.sClientExtra = _T("none");
		if(cur_client->GetUserName().GetLength() > SHORT_LENGTH_MIN)
			dUser.sUserName = _SpecialChars(cur_client->GetUserName().Left(SHORT_LENGTH_MIN-3)) + _T("...");
		else
			dUser.sUserName = _SpecialChars(cur_client->GetUserName());
		CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(cur_client->m_reqFileHash);
		if (file)
			dUser.sFileName = _SpecialChars(CString(file->GetFileName()));
		else
			dUser.sFileName = _GetPlainResString(IDS_REQ_UNKNOWNFILE);
		dUser.nTransferredDown = cur_client->GetTransferredDown();
		dUser.nTransferredUp = cur_client->GetTransferredUp();
		sint32 iDataRate = cur_client->GetDataRate();
		dUser.nDataRate = ((iDataRate == -1) ? 0 : iDataRate);
		dUser.sClientNameVersion = cur_client->GetClientNameAndVersionString();
		UploadArray.Add(dUser);
	}

	// Sorting (simple bubble sort, we don't have tons of data here)
	bSorted = true;
	for(int nMax = 0;bSorted && nMax < UploadArray.GetCount()*2; nMax++)
	{
		bSorted = false;
		for(int i = 0; i < UploadArray.GetCount() - 1; i++)
		{
			bool bSwap = false;
			switch(pThis->m_Params.UploadSort)
			{
			case UP_SORT_CLIENT:
				bSwap = UploadArray[i].sClientSoftSpecial.CompareNoCase(UploadArray[i+1].sClientSoftSpecial) < 0;
				break;
			case UP_SORT_USER:
				bSwap = UploadArray[i].sUserName.CompareNoCase(UploadArray[i+1].sUserName) < 0;
				break;
			case UP_SORT_VERSION:
				bSwap = UploadArray[i].sClientNameVersion.CompareNoCase(UploadArray[i+1].sClientNameVersion) < 0;
				break;
			case UP_SORT_FILENAME:
				bSwap = UploadArray[i].sFileName.CompareNoCase(UploadArray[i+1].sFileName) < 0;
				break;
			case UP_SORT_TRANSFERRED:
				bSwap = UploadArray[i].nTransferredUp < UploadArray[i+1].nTransferredUp;
				break;
			case UP_SORT_SPEED:
				bSwap = UploadArray[i].nDataRate < UploadArray[i+1].nDataRate;
				break;
			}
			if(pThis->m_Params.bUploadSortReverse)
				bSwap = !bSwap;
			if(bSwap)
			{
				bSorted = true;
				UploadUsers TmpUser = UploadArray[i];
				UploadArray[i] = UploadArray[i+1];
				UploadArray[i+1] = TmpUser;
			}
		}
	}

	int nCountQueue = 0;
	int nCountQueueBanned = 0;
	int nCountQueueFriend = 0;
	int nCountQueueCredit = 0;
	int nCountQueueSecure = 0;
	int nCountQueueBannedSecure = 0;
	int nCountQueueFriendSecure = 0;
	int nCountQueueCreditSecure = 0;

	CQArray<QueueUsers, QueueUsers> QueueArray;
	for (POSITION pos = g_eMuleApp.m_pUploadQueue->waitinglist.GetHeadPosition(); pos != NULL;)
	{
		CUpDownClient* cur_client = g_eMuleApp.m_pUploadQueue->waitinglist.GetNext(pos);
		QueueUsers dUser;
		CString sTemp;

		bool bSecure = (cur_client->m_pCredits->GetCurrentIdentState(cur_client->GetIP()) == IS_IDENTIFIED);
		if (cur_client->IsBanned())
		{
			dUser.sClientExtra = _T("banned");
			nCountQueueBanned++;
			if (bSecure) nCountQueueBannedSecure++;
		}
		else if (cur_client->IsFriend())
		{
			dUser.sClientExtra = _T("friend");
			nCountQueueFriend++;
			if (bSecure) nCountQueueFriendSecure++;
		}
		else if (cur_client->m_pCredits->GetScoreRatio(cur_client->GetIP()) > 1)
		{
			dUser.sClientExtra = _T("credit");
			nCountQueueCredit++;
			if (bSecure) nCountQueueCreditSecure++;
		}
		else
		{
			dUser.sClientExtra = _T("none");
			nCountQueue++;
			if (bSecure) nCountQueueSecure++;
		}

		if(cur_client->GetUserName().GetLength() > SHORT_LENGTH_MIN)
			dUser.sUserName = _SpecialChars(cur_client->GetUserName().Left(SHORT_LENGTH_MIN-3)) + _T("...");
		else
			dUser.sUserName = _SpecialChars(cur_client->GetUserName());
		dUser.sClientNameVersion = cur_client->GetClientNameAndVersionString();
		CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(cur_client->m_reqFileHash);
		if (file)
			dUser.sFileName = _SpecialChars(CString(file->GetFileName()));
		else
			dUser.sFileName = _GetPlainResString(IDS_REQ_UNKNOWNFILE);
		dUser.sClientState = dUser.sClientExtra;
		dUser.sClientStateSpecial = _T("connecting");
		dUser.nScore = cur_client->GetScore(false);

		dwClientSoft = cur_client->GetClientSoft();
		if ( ((dwClientSoft == SO_EMULE) || (dwClientSoft == SO_PLUS)) &&
			(cur_client->m_pCredits->GetCurrentIdentState(cur_client->GetIP()) != IS_IDENTIFIED) )
		{
			dwClientSoft = SO_OLDEMULE;
		}
		sTemp.Format(_T("%u"), dwClientSoft);
		dUser.sClientSoft = sTemp;
		dUser.sClientSoftSpecial = sTemp;
		dUser.sUserHash = HashToString(cur_client->GetUserHash());
		//SyruS CQArray-Sorting setting sIndex according to param
		switch(pThis->m_Params.QueueSort)
		{
		case QU_SORT_CLIENT:
			dUser.sIndex = dUser.sClientSoftSpecial;
			break;
		case QU_SORT_USER:
			dUser.sIndex = dUser.sUserName;
			break;
		case QU_SORT_VERSION:
			dUser.sIndex = dUser.sClientNameVersion;
			break;
		case QU_SORT_FILENAME:
			dUser.sIndex = dUser.sFileName;
			break;
		case QU_SORT_SCORE:
			dUser.sIndex.Format(_T("%09u"), dUser.nScore);
			break;
		default:
			dUser.sIndex.Empty();
		}
		QueueArray.Add(dUser);
	}

	int nNextPos = 0;	// position in queue of the user with the highest score -> next upload user
	uint32 nNextScore = 0;	// highest score -> next upload user
	for(int i = 0; i < QueueArray.GetCount(); i++)
	{
		if (QueueArray[i].nScore > nNextScore)
		{
			nNextPos = i;
			nNextScore = QueueArray[i].nScore;
		}
	}
	if (g_eMuleApp.m_pUploadQueue->waitinglist.GetHeadPosition() != 0)
	{
		QueueArray[nNextPos].sClientState = _T("next");
		QueueArray[nNextPos].sClientStateSpecial = QueueArray[nNextPos].sClientState;
	}

	if ((nCountQueue > 0 &&	pThis->m_Params.bShowUploadQueue) ||
		(nCountQueueBanned > 0 && pThis->m_Params.bShowUploadQueueBanned) ||
		(nCountQueueFriend > 0 && pThis->m_Params.bShowUploadQueueFriend) ||
		(nCountQueueCredit > 0 && pThis->m_Params.bShowUploadQueueCredit))
	{
#ifdef _DEBUG
	DWORD dwStart = ::GetTickCount();
#endif
	QueueArray.QuickSort(pThis->m_Params.bQueueSortReverse);
#ifdef _DEBUG
	AddDebugLogLine(_T("WebServer: Waitingqueue with %u elements sorted in %u ms"), QueueArray.GetSize(), ::GetTickCount()-dwStart);
#endif
	}

	uchar FileHashA4AF[16];

	// Displaying
	CString sDownList, HTTPProcessData;
	CString OutE = pThis->m_Templates.sTransferDownLine;

	for(int i = 0; i < FilesArray.GetCount(); i++)
	{
		HTTPProcessData = OutE;

		if (FilesArray[i].sFileHash == _ParseURL(Data.sURL,_T("file")) )
            HTTPProcessData.Replace(_T("[LastChangedDataset]"), "checked");
		else
            HTTPProcessData.Replace(_T("[LastChangedDataset]"), "checked_no");

		CString ed2k;			//ed2klink
		CString state;			//state
		CString autoa4af;		//autoa4af
		CString isgetflc;		//getflc
		CString fname;			//filename
		CString fsize;			//filesize
		CString session;		//session
		CString filehash;		//filehash
		CString downpriority;	//priority

		CPartFile *found_file = g_eMuleApp.m_pDownloadQueue->GetFileByID(StringToHash(FilesArray[i].sFileHash, FileHashA4AF));

		CString strFInfo = FilesArray[i].sFileInfo;

		strFInfo.Replace(_T("\\"),_T("\\\\"));
		strFInfo.Replace(_T("\n"),_T("\\n"));
		strFInfo.Replace(_T("'"),_T("&#8217;"));

		CString JSED2kLink=FilesArray[i].sED2kLink;
		JSED2kLink.Replace(_T("'"),_T("&#8217;"));

		ed2k = JSED2kLink;
		fname = FilesArray[i].sFileNameJS;
		state = FilesArray[i].sFileState;
		fsize.Format(_T("%d"),FilesArray[i].m_qwFileSize);
		session = sSession;
		filehash = FilesArray[i].sFileHash;

		if (g_eMuleApp.m_pDownloadQueue->GetA4AFAutoFile() == found_file && !FilesArray[i].bIsComplete)
			autoa4af = _T("autoa4af");

		if (FilesArray[i].bIsPreview)
			isgetflc = _T("");
		else if(FilesArray[i].bIsGetFLC)
			isgetflc = _T("enabled");
		else
			isgetflc = _T("disabled");

		if(FilesArray[i].bFileAutoPrio)
			downpriority = _T("Auto");
		else
		{
			switch(FilesArray[i].nFilePrio)
			{
				case 0:
					downpriority = _T("Low");
					break;
				case 1:
					downpriority = _T("Normal");
					break;
				case 2:
					downpriority = _T("High");
					break;
			}
		}

		HTTPProcessData.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));
		HTTPProcessData.Replace(_T("[finfo]"), strFInfo);
		HTTPProcessData.Replace(_T("[ed2k]"), ed2k);
		HTTPProcessData.Replace(_T("[DownState]"), state);
		HTTPProcessData.Replace(_T("[autoa4af]"), autoa4af);
		HTTPProcessData.Replace(_T("[isgetflc]"), isgetflc);
		HTTPProcessData.Replace(_T("[fname]"), fname);
		HTTPProcessData.Replace(_T("[fsize]"), fsize);
		HTTPProcessData.Replace(_T("[session]"), session);
		HTTPProcessData.Replace(_T("[filehash]"), filehash);
		HTTPProcessData.Replace(_T("[CatSel]"), sCat);
		HTTPProcessData.Replace(_T("[down-priority]"), downpriority);

		HTTPProcessData.Replace(_T("[FileType]"), FilesArray[i].sFileType);

		if (g_eMuleApp.m_pDownloadQueue->GetA4AFAutoFile() == found_file && !FilesArray[i].bIsComplete)
			HTTPProcessData.Replace(_T("[FileIsA4AF]"), _T("a4af"));
		else
			HTTPProcessData.Replace(_T("[FileIsA4AF]"), _T("halfnone"));

		if (!FilesArray[i].bIsPreview && FilesArray[i].bIsGetFLC)
			HTTPProcessData.Replace(_T("[FileIsGetFLC]"), _T("getflc"));
		else
			HTTPProcessData.Replace(_T("[FileIsGetFLC]"), _T("halfnone"));

		if (!WSdownloadColumnHidden[0])
		{
			if(FilesArray[i].sFileName.GetLength() > (SHORT_LENGTH_MAX))
				HTTPProcessData.Replace(_T("[ShortFileName]"), FilesArray[i].sFileName.Left(SHORT_LENGTH_MAX-3) + _T("..."));
			else
				HTTPProcessData.Replace(_T("[ShortFileName]"), FilesArray[i].sFileName);
		}
		else
			HTTPProcessData.Replace(_T("[ShortFileName]"), _T(""));

		CString sTooltip = FilesArray[i].sFileInfo;
		sTooltip.Replace(_T("\n"), _T("<br>"));
		sTooltip.Replace(_T("'"), _T("&#8217;"));
		HTTPProcessData.Replace(_T("[FileInfo]"), sTooltip);

		fTotalSize += FilesArray[i].m_qwFileSize;

		if (!WSdownloadColumnHidden[1])
			HTTPProcessData.Replace(_T("[2]"), CastItoXBytes(FilesArray[i].m_qwFileSize));
		else
			HTTPProcessData.Replace(_T("[2]"), _T(""));

		if (!WSdownloadColumnHidden[2])
		{
			if(FilesArray[i].m_qwFileTransferred > 0)
			{
				fTotalTransferred += FilesArray[i].m_qwFileTransferred;
				HTTPProcessData.Replace(_T("[3]"), CastItoXBytes(FilesArray[i].m_qwFileTransferred));
			}
			else
				HTTPProcessData.Replace(_T("[3]"), _T("-"));
		}
		else
			HTTPProcessData.Replace(_T("[3]"), _T(""));

		if (!WSdownloadColumnHidden[3])
			HTTPProcessData.Replace(_T("[DownloadBar]"), _GetDownloadGraph(Data,FilesArray[i].sFileHash));
		else
			HTTPProcessData.Replace(_T("[DownloadBar]"), _T(""));

		HTTPTemp.Empty();

		if (!WSdownloadColumnHidden[4])
		{
			if(FilesArray[i].lFileSpeed > 0.0f)
			{
				fTotalSpeed += FilesArray[i].lFileSpeed;
				HTTPTemp.Format(_T("%8.2f"), FilesArray[i].lFileSpeed/1024.0);
				HTTPProcessData.Replace(_T("[4]"), HTTPTemp);
			}
			else
				HTTPProcessData.Replace(_T("[4]"), _T("-"));
		}
		else
			HTTPProcessData.Replace(_T("[4]"), _T(""));

		if (!WSdownloadColumnHidden[5])
		{
			if(FilesArray[i].lSourceCount > 0)
			{
				HTTPTemp.Format(_T("%i&nbsp;/&nbsp;%8i&nbsp;(%i)"),
			    FilesArray[i].lSourceCount-FilesArray[i].lNotCurrentSourceCount,
			    FilesArray[i].lSourceCount,
			    FilesArray[i].lTransferringSourceCount);
				HTTPProcessData.Replace(_T("[5]"), HTTPTemp);
			}
			else
				HTTPProcessData.Replace(_T("[5]"), _T("-"));
		}
		else
			HTTPProcessData.Replace(_T("[5]"), _T(""));

		if (!WSdownloadColumnHidden[6])
		{
			if(FilesArray[i].bFileAutoPrio)
			{
				switch(FilesArray[i].nFilePrio)
				{
					case 0: HTTPTemp=GetResString(IDS_PRIOAUTOLOW); break;
					case 1: HTTPTemp=GetResString(IDS_PRIOAUTONORMAL); break;
					case 2: HTTPTemp=GetResString(IDS_PRIOAUTOHIGH); break;
				}
			}
			else
			{
				switch(FilesArray[i].nFilePrio)
				{
					case  0: HTTPTemp=GetResString(IDS_PRIOLOW); break;
					case  1: HTTPTemp=GetResString(IDS_PRIONORMAL); break;
					case  2: HTTPTemp=GetResString(IDS_PRIOHIGH); break;
				}
			}
			HTTPProcessData.Replace(_T("[PrioVal]"), HTTPTemp);
		}
		else
			HTTPProcessData.Replace(_T("[PrioVal]"), _T(""));

		if (!WSdownloadColumnHidden[7])
			HTTPProcessData.Replace(_T("[Category]"), FilesArray[i].sCategory);
		else
			HTTPProcessData.Replace(_T("[Category]"), _T(""));

		if (!WSdownloadColumnHidden[8])
			HTTPProcessData.Replace(_T("[FakeCheck]"), FilesArray[i].sFakeCheck);
		else
			HTTPProcessData.Replace(_T("[FakeCheck]"), _T(""));

		InsertCatBox(HTTPProcessData,0,"",false,false,sSession,FilesArray[i].sFileHash);

		sDownList += HTTPProcessData;
	}

	Out.Replace(_T("[DownloadFilesList]"), sDownList);
	Out.Replace(_T("[TotalDownSize]"), CastItoXBytes(fTotalSize));

	Out.Replace(_T("[TotalDownTransferred]"), CastItoXBytes(fTotalTransferred));

	HTTPTemp.Format(_T("%8.2f"), fTotalSpeed/1024.0);
	Out.Replace(_T("[TotalDownSpeed]"), HTTPTemp);

	HTTPTemp.Format(_T("%s: %i"), GetResString(IDS_SF_FILE), g_eMuleApp.m_pDownloadQueue->GetFileCount());
	Out.Replace(_T("[TotalFiles]"), HTTPTemp);

	HTTPTemp.Format(_T("%i"),pThis->m_Templates.iProgressbarWidth);
	Out.Replace(_T("[PROGRESSBARWIDTHVAL]"),HTTPTemp);

	fTotalSize = 0;
	fTotalTransferred = 0;
	fTotalSpeed = 0;

	CString sUpList;
	const TCHAR	*pcTmp;

	OutE = pThis->m_Templates.sTransferUpLine;
	OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

	for(int i = 0; i < UploadArray.GetCount(); i++)
	{
		HTTPProcessData = OutE;

		HTTPProcessData.Replace(_T("[UserHash]"), UploadArray[i].sUserHash);
		HTTPProcessData.Replace(_T("[UpState]"), UploadArray[i].sActive);
		HTTPProcessData.Replace(_T("[FileInfo]"), UploadArray[i].sFileInfo);
		HTTPProcessData.Replace(_T("[ClientState]"), UploadArray[i].sClientState);
		HTTPProcessData.Replace(_T("[ClientSoft]"), UploadArray[i].sClientSoft);
		HTTPProcessData.Replace(_T("[ClientSoftSpecial]"), UploadArray[i].sClientSoftSpecial);
		HTTPProcessData.Replace(_T("[ClientExtra]"), UploadArray[i].sClientExtra);

		pcTmp = (!WSuploadColumnHidden[0]) ? UploadArray[i].sUserName.GetString() : _T("");
		HTTPProcessData.Replace(_T("[1]"), pcTmp);

		pcTmp = (!WSuploadColumnHidden[1]) ? UploadArray[i].sClientNameVersion.GetString() : _T("");
		HTTPProcessData.Replace(_T("[ClientSoftV]"), pcTmp);

		pcTmp = (!WSuploadColumnHidden[2]) ? UploadArray[i].sFileName.GetString() : _T("");
		HTTPProcessData.Replace(_T("[2]"), pcTmp);

		pcTmp = _T("");
		if (!WSuploadColumnHidden[3])
		{
			fTotalSize += UploadArray[i].nTransferredDown;
			fTotalTransferred += UploadArray[i].nTransferredUp;
			HTTPTemp.Format(_T("%s / %s"), CastItoXBytes(UploadArray[i].nTransferredDown),CastItoXBytes(UploadArray[i].nTransferredUp));
			pcTmp = HTTPTemp;
		}
		HTTPProcessData.Replace(_T("[3]"), pcTmp);

		pcTmp = _T("");
		if (!WSuploadColumnHidden[4])
		{
			fTotalSpeed += UploadArray[i].nDataRate;
			HTTPTemp.Format(_T("%8.2f "), max((double)UploadArray[i].nDataRate/1024, 0.0));
			pcTmp = HTTPTemp;
		}
		HTTPProcessData.Replace(_T("[4]"), pcTmp);

		sUpList += HTTPProcessData;
	}
	Out.Replace(_T("[UploadFilesList]"), sUpList);
	HTTPTemp.Format(_T("%s / %s"), CastItoXBytes(fTotalSize), CastItoXBytes(fTotalTransferred));
	Out.Replace(_T("[TotalUpTransferred]"), HTTPTemp);
	HTTPTemp.Format(_T("%8.2f "), max(fTotalSpeed/1024, 0.0));
	Out.Replace(_T("[TotalUpSpeed]"), HTTPTemp);

	if(pThis->m_Params.bShowUploadQueue)
	{
		Out.Replace(_T("[UploadQueue]"), pThis->m_Templates.sTransferUpQueueShow);
		Out.Replace(_T("[UploadQueueList]"), _GetPlainResString(IDS_ONQUEUE));

		CString sQueue;

		OutE = pThis->m_Templates.sTransferUpQueueLine;
		OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

		for(int i = 0; i < QueueArray.GetCount(); i++)
		{
            TCHAR HTTPTempC[100] = _T("");
			if (QueueArray[i].sClientExtra == "none")
			{
				HTTPProcessData = OutE;
				pcTmp = (!WSqueueColumnHidden[0]) ? QueueArray[i].sUserName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[UserName]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[1]) ? QueueArray[i].sClientNameVersion.GetString() : _T("");
				HTTPProcessData.Replace(_T("[ClientSoftV]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[2]) ? QueueArray[i].sFileName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[FileName]"), pcTmp);

				pcTmp = _T("");
				if (!WSqueueColumnHidden[3])
				{
					_stprintf(HTTPTempC, _T("%i") , QueueArray[i].nScore);
					pcTmp = HTTPTempC;
				}
				HTTPProcessData.Replace(_T("[Score]"), pcTmp);
				HTTPProcessData.Replace(_T("[ClientState]"), QueueArray[i].sClientState);
				HTTPProcessData.Replace(_T("[ClientStateSpecial]"), QueueArray[i].sClientStateSpecial);
				HTTPProcessData.Replace(_T("[ClientSoft]"), QueueArray[i].sClientSoft);
				HTTPProcessData.Replace(_T("[ClientSoftSpecial]"), QueueArray[i].sClientSoftSpecial);
				HTTPProcessData.Replace(_T("[ClientExtra]"), QueueArray[i].sClientExtra);
				HTTPProcessData.Replace(_T("[UserHash]"), QueueArray[i].sUserHash);

				sQueue += HTTPProcessData;
			}
		}
		Out.Replace(_T("[QueueList]"), sQueue);
	}
	else
		Out.Replace(_T("[UploadQueue]"), pThis->m_Templates.sTransferUpQueueHide);

	if(pThis->m_Params.bShowUploadQueueBanned)
	{
		Out.Replace(_T("[UploadQueueBanned]"), pThis->m_Templates.sTransferUpQueueBannedShow);
		Out.Replace(_T("[UploadQueueBannedList]"), _GetPlainResString(IDS_ONQUEUEBANNED));

		CString sQueueBanned;
		
		OutE = pThis->m_Templates.sTransferUpQueueBannedLine;
		OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

		for(int i = 0; i < QueueArray.GetCount(); i++)
		{
            TCHAR HTTPTempC[100] = _T("");
			if (QueueArray[i].sClientExtra == "banned")
			{
				HTTPProcessData = OutE;
				pcTmp = (!WSqueueColumnHidden[0]) ? QueueArray[i].sUserName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[UserName]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[1]) ? QueueArray[i].sClientNameVersion.GetString() : _T("");
				HTTPProcessData.Replace(_T("[ClientSoftV]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[2]) ? QueueArray[i].sFileName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[FileName]"), pcTmp);

				pcTmp = _T("");
				if (!WSqueueColumnHidden[3])
				{
					_stprintf(HTTPTempC, _T("%i") , QueueArray[i].nScore);
					pcTmp = HTTPTempC;
				}
				HTTPProcessData.Replace(_T("[Score]"), pcTmp);

				HTTPProcessData.Replace(_T("[ClientState]"), QueueArray[i].sClientState);
				HTTPProcessData.Replace(_T("[ClientStateSpecial]"), QueueArray[i].sClientStateSpecial);
				HTTPProcessData.Replace(_T("[ClientSoft]"), QueueArray[i].sClientSoft);
				HTTPProcessData.Replace(_T("[ClientSoftSpecial]"), QueueArray[i].sClientSoftSpecial);
				HTTPProcessData.Replace(_T("[ClientExtra]"), QueueArray[i].sClientExtra);
				HTTPProcessData.Replace(_T("[UserHash]"), QueueArray[i].sUserHash);

				sQueueBanned += HTTPProcessData;
			}
		}
		Out.Replace(_T("[QueueListBanned]"), sQueueBanned);
	}
	else
		Out.Replace(_T("[UploadQueueBanned]"), pThis->m_Templates.sTransferUpQueueBannedHide);

	if(pThis->m_Params.bShowUploadQueueFriend)
	{
		Out.Replace(_T("[UploadQueueFriend]"), pThis->m_Templates.sTransferUpQueueFriendShow);
		Out.Replace(_T("[UploadQueueFriendList]"), _GetPlainResString(IDS_ONQUEUEFRIEND));

		CString sQueueFriend;
		
		OutE = pThis->m_Templates.sTransferUpQueueFriendLine;
		OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

		for(int i = 0; i < QueueArray.GetCount(); i++)
		{
            TCHAR HTTPTempC[100] = _T("");
			if (QueueArray[i].sClientExtra == "friend")
			{
				HTTPProcessData = OutE;
				pcTmp = (!WSqueueColumnHidden[0]) ? QueueArray[i].sUserName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[UserName]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[1]) ? QueueArray[i].sClientNameVersion.GetString() : _T("");
				HTTPProcessData.Replace(_T("[ClientSoftV]"), pcTmp);

				pcTmp = (!WSqueueColumnHidden[2]) ? QueueArray[i].sFileName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[FileName]"), pcTmp);

				pcTmp = _T("");
				if (!WSqueueColumnHidden[3])
				{
					_stprintf(HTTPTempC, _T("%i") , QueueArray[i].nScore);
					pcTmp = HTTPTempC;
				}
				HTTPProcessData.Replace(_T("[Score]"), pcTmp);

				HTTPProcessData.Replace(_T("[ClientState]"), QueueArray[i].sClientState);
				HTTPProcessData.Replace(_T("[ClientStateSpecial]"), QueueArray[i].sClientStateSpecial);
				HTTPProcessData.Replace(_T("[ClientSoft]"), QueueArray[i].sClientSoft);
				HTTPProcessData.Replace(_T("[ClientSoftSpecial]"), QueueArray[i].sClientSoftSpecial);
				HTTPProcessData.Replace(_T("[ClientExtra]"), QueueArray[i].sClientExtra);
				HTTPProcessData.Replace(_T("[UserHash]"), QueueArray[i].sUserHash);

				sQueueFriend += HTTPProcessData;
			}
		}
		Out.Replace(_T("[QueueListFriend]"), sQueueFriend);
	}
	else
		Out.Replace(_T("[UploadQueueFriend]"), pThis->m_Templates.sTransferUpQueueFriendHide);

	if(pThis->m_Params.bShowUploadQueueCredit)
	{
		Out.Replace(_T("[UploadQueueCredit]"), pThis->m_Templates.sTransferUpQueueCreditShow);
		Out.Replace(_T("[UploadQueueCreditList]"), _GetPlainResString(IDS_ONQUEUECREDIT));

		CString sQueueCredit;

		OutE = pThis->m_Templates.sTransferUpQueueCreditLine;
		OutE.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));

		for(int i = 0; i < QueueArray.GetCount(); i++)
		{
            TCHAR HTTPTempC[100] = _T("");
			if (QueueArray[i].sClientExtra == "credit")
			{
				HTTPProcessData = OutE;
				pcTmp = (!WSqueueColumnHidden[0]) ? QueueArray[i].sUserName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[UserName]"), pcTmp);

				pcTmp =  (!WSqueueColumnHidden[1]) ? QueueArray[i].sClientNameVersion.GetString() : _T("");
				HTTPProcessData.Replace(_T("[ClientSoftV]"), pcTmp);

				pcTmp =  (!WSqueueColumnHidden[2]) ? QueueArray[i].sFileName.GetString() : _T("");
				HTTPProcessData.Replace(_T("[FileName]"), pcTmp);

				pcTmp = _T("");
				if (!WSqueueColumnHidden[3])
				{
					_stprintf(HTTPTempC, _T("%i") , QueueArray[i].nScore);
					pcTmp =  HTTPTempC;
				}
				HTTPProcessData.Replace(_T("[Score]"), pcTmp);

				HTTPProcessData.Replace(_T("[ClientState]"), QueueArray[i].sClientState);
				HTTPProcessData.Replace(_T("[ClientStateSpecial]"), QueueArray[i].sClientStateSpecial);
				HTTPProcessData.Replace(_T("[ClientSoft]"), QueueArray[i].sClientSoft);
				HTTPProcessData.Replace(_T("[ClientSoftSpecial]"), QueueArray[i].sClientSoftSpecial);
				HTTPProcessData.Replace(_T("[ClientExtra]"), QueueArray[i].sClientExtra);
				HTTPProcessData.Replace(_T("[UserHash]"), QueueArray[i].sUserHash);

				sQueueCredit += HTTPProcessData;
			}
		}
		Out.Replace(_T("[QueueListCredit]"), sQueueCredit);
	}
	else
		Out.Replace(_T("[UploadQueueCredit]"), pThis->m_Templates.sTransferUpQueueCreditHide);
	CString mCounter;
	mCounter.Format(_T("%i"),nCountQueue);
	Out.Replace(_T("[CounterQueue]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueBanned);
	Out.Replace(_T("[CounterQueueBanned]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueFriend);
	Out.Replace(_T("[CounterQueueFriend]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueCredit);
	Out.Replace(_T("[CounterQueueCredit]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueSecure);
	Out.Replace(_T("[CounterQueueSecure]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueBannedSecure);
	Out.Replace(_T("[CounterQueueBannedSecure]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueFriendSecure);
	Out.Replace(_T("[CounterQueueFriendSecure]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueCreditSecure);
	Out.Replace(_T("[CounterQueueCreditSecure]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueue+nCountQueueBanned+nCountQueueFriend+nCountQueueCredit);
	Out.Replace(_T("[CounterAll]"), mCounter);
	mCounter.Format(_T("%i"),nCountQueueSecure+nCountQueueBannedSecure+nCountQueueFriendSecure+nCountQueueCreditSecure);
	Out.Replace(_T("[CounterAllSecure]"), mCounter);
	Out.Replace(_T("[CatSel]"), sCat);
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[ShowUploadQueue]"), _GetPlainResString(IDS_VIEWQUEUE));
	Out.Replace(_T("[ShowUploadQueueList]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE, true));
	Out.Replace(_T("[ShowUploadQueueListBanned]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_BANNED, true));
	Out.Replace(_T("[ShowUploadQueueListFriend]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_FRIEND, true));
	Out.Replace(_T("[ShowUploadQueueListCredit]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_CREDIT, true));

	strTmp = (pThis->m_Params.bQueueSortReverse) ? _T("&sortreverse=false") : _T("&sortreverse=true");

	if(pThis->m_Params.QueueSort == QU_SORT_CLIENT)
		Out.Replace(_T("[SortQClient]"), strTmp);
	else
		Out.Replace(_T("[SortQClient]"), _T(""));
	if(pThis->m_Params.QueueSort == QU_SORT_USER)
		Out.Replace(_T("[SortQUser]"), strTmp);
	else
		Out.Replace(_T("[SortQUser]"), _T(""));
	if(pThis->m_Params.QueueSort == QU_SORT_VERSION)
		Out.Replace(_T("[SortQVersion]"), strTmp);
	else
		Out.Replace(_T("[SortQVersion]"), _T(""));
	if(pThis->m_Params.QueueSort == QU_SORT_FILENAME)
		Out.Replace(_T("[SortQFilename]"), strTmp);
	else
		Out.Replace(_T("[SortQFilename]"), _T(""));
	if(pThis->m_Params.QueueSort == QU_SORT_SCORE)
		Out.Replace(_T("[SortQScore]"), strTmp);
	else
		Out.Replace(_T("[SortQScore]"), _T(""));

	pcSortIcon = (pThis->m_Params.bQueueSortReverse) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;

	_GetPlainResString(&strTmp, IDS_QL_USERNAME, true);
	if (!WSqueueColumnHidden[0])
	{
		Out.Replace(_T("[UserNameTitleI]"), (pThis->m_Params.QueueSort == QU_SORT_USER) ? pcSortIcon : "");
		Out.Replace(_T("[UserNameTitle]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[UserNameTitleI]"), _T(""));
		Out.Replace(_T("[UserNameTitle]"), _T(""));
	}
	Out.Replace(_T("[UserNameTitleM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_INFLST_USER_CLIENTVERSION, true);
	if (!WSqueueColumnHidden[1])
	{
		Out.Replace(_T("[VersionI]"), (pThis->m_Params.QueueSort == QU_SORT_VERSION) ? pcSortIcon : "");
		Out.Replace(_T("[Version]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[VersionI]"), _T(""));
		Out.Replace(_T("[Version]"), _T(""));
	}
	Out.Replace(_T("[VersionM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_FILENAME, true);
	if (!WSqueueColumnHidden[2])
	{
		Out.Replace(_T("[FileNameTitleI]"), (pThis->m_Params.QueueSort == QU_SORT_FILENAME) ? pcSortIcon : "");
		Out.Replace(_T("[FileNameTitle]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FileNameTitleI]"), _T(""));
		Out.Replace(_T("[FileNameTitle]"), _T(""));
	}
	Out.Replace(_T("[FileNameTitleM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SCORE, true);
	if (!WSqueueColumnHidden[3])
	{
		Out.Replace(_T("[ScoreTitleI]"), (pThis->m_Params.QueueSort == QU_SORT_SCORE) ? pcSortIcon : "");
		Out.Replace(_T("[ScoreTitle]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[ScoreTitleI]"), _T(""));
		Out.Replace(_T("[ScoreTitle]"), _T(""));
	}
	Out.Replace(_T("[ScoreTitleM]"), strTmp);
	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetSharedFilesList(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte	cat = atoi(_ParseURL(Data.sURL, "cat"));
	CString	strTmp, sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString	sSession = _ParseURL(Data.sURL, _T("ses"));
	bool	bAdmin = IsSessionAdmin(Data,sSession);
	CString	strSort = _ParseURL(Data.sURL, _T("sort"));

	strTmp = _ParseURL(Data.sURL, _T("sortreverse"));
	if (!strSort.IsEmpty())
	{
		bool	bDirection = false;

		if (strSort == "state")
			pThis->m_Params.SharedSort = SHARED_SORT_STATE;
		else if (strSort == "type")
			pThis->m_Params.SharedSort = SHARED_SORT_TYPE;
		else if (strSort == "name")
		{
			pThis->m_Params.SharedSort = SHARED_SORT_NAME;
			bDirection = true;
		}
		else if (strSort == "size")
			pThis->m_Params.SharedSort = SHARED_SORT_SIZE;
		else if (strSort == "transferred")
			pThis->m_Params.SharedSort = SHARED_SORT_TRANSFERRED;
		else if (strSort == "alltimetransferred")
			pThis->m_Params.SharedSort = SHARED_SORT_ALL_TIME_TRANSFERRED;
		else if (strSort == "requests")
			pThis->m_Params.SharedSort = SHARED_SORT_REQUESTS;
		else if (strSort == "alltimerequests")
			pThis->m_Params.SharedSort = SHARED_SORT_ALL_TIME_REQUESTS;
		else if (strSort == "accepts")
			pThis->m_Params.SharedSort = SHARED_SORT_ACCEPTS;
		else if (strSort == "alltimeaccepts")
			pThis->m_Params.SharedSort = SHARED_SORT_ALL_TIME_ACCEPTS;
		else if (strSort == "completes")
			pThis->m_Params.SharedSort = SHARED_SORT_COMPLETES;
		else if (strSort == "priority")
			pThis->m_Params.SharedSort = SHARED_SORT_PRIORITY;

		if (strTmp.IsEmpty())
			pThis->m_Params.bSharedSortReverse = bDirection;
	}
	if (!strTmp.IsEmpty())
		pThis->m_Params.bSharedSortReverse = (strTmp == "true");

	if(!_ParseURL(Data.sURL, _T("hash")).IsEmpty() && !_ParseURL(Data.sURL, _T("prio")).IsEmpty() && IsSessionAdmin(Data,sSession))
	{
		CKnownFile* cur_file;
		uchar fileid[16];
		CString hash = _ParseURL(Data.sURL, _T("hash"));
		if (hash.GetLength()==32 && DecodeBase16(hash.GetBuffer(),hash.GetLength(),fileid,ARRSIZE(fileid)))
		{
			cur_file = g_eMuleApp.m_pSharedFilesList->GetFileByID(fileid);

			if (cur_file != 0)
			{
				cur_file->SetAutoULPriority(false);
				strTmp = _ParseURL(Data.sURL, _T("prio"));
				if (strTmp == "verylow")
					cur_file->SetULPriority(PR_VERYLOW);
				else if (strTmp == "low")
					cur_file->SetULPriority(PR_LOW);
				else if (strTmp == "normal")
					cur_file->SetULPriority(PR_NORMAL);
				else if (strTmp == "high")
					cur_file->SetULPriority(PR_HIGH);
				else if (strTmp == "release")
					cur_file->SetULPriority(PR_RELEASE);
				else if (strTmp == "auto")
				{
					cur_file->SetAutoULPriority(true);
					cur_file->UpdateUploadAutoPriority();
				}

				g_eMuleApp.m_pSharedFilesList->UpdateItem(cur_file); // refresh GUI on priority change
			}
		}
	}

	CString sCmd = _ParseURL(Data.sURL, _T("c"));
	if (sCmd.CompareNoCase(_T("menu")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSsharedColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSsharedColumnHidden, ELEMENT_COUNT(WSsharedColumnHidden), _T("sharedColumnHidden"));
		ini.SaveAndClose();
	}
	if (bAdmin)
	{
		if (_ParseURL(Data.sURL, _T("jumpstart")) == "true")
			_SetSharedFileJumpstart(_ParseURL(Data.sURL, _T("hash")));
		else if (_ParseURL(Data.sURL, _T("jumpstart")) == "false")
			_SetSharedFileNoJumpstart(_ParseURL(Data.sURL, _T("hash")));
	}
	if(_ParseURL(Data.sURL, _T("reload")) == "true")
		g_eMuleApp.m_pdlgEmule->SendMessage(WEB_SHARED_FILES_RELOAD);

	CString Out = pThis->m_Templates.sSharedList;

	strTmp = (pThis->m_Params.bSharedSortReverse) ? "false" : "true";

	//State sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_STATE)
		Out.Replace(_T("[SortState]"), _T("sort=state&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortState]"), _T("sort=state"));
    //Type sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_TYPE)
		Out.Replace(_T("[SortType]"), _T("sort=type&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortType]"), _T("sort=type"));
    //Name sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_NAME)
		Out.Replace(_T("[SortName]"), _T("sort=name&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortName]"), _T("sort=name"));
	//Size sorting Link
	if(pThis->m_Params.SharedSort == SHARED_SORT_SIZE)
		Out.Replace(_T("[SortSize]"), _T("sort=size&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortSize]"), _T("sort=size"));
	//Complete Sources sorting Link
	if(pThis->m_Params.SharedSort == SHARED_SORT_COMPLETES)
		Out.Replace(_T("[SortCompletes]"), _T("sort=completes&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortCompletes]"), _T("sort=completes"));
	//Priority sorting Link
	if(pThis->m_Params.SharedSort == SHARED_SORT_PRIORITY)
		Out.Replace(_T("[SortPriority]"), _T("sort=priority&sortreverse=") + strTmp);
	else
		Out.Replace(_T("[SortPriority]"), _T("sort=priority"));
    //Transferred sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_TRANSFERRED)
	{
		if(pThis->m_Params.bSharedSortReverse)
			Out.Replace(_T("[SortTransferred]"), _T("sort=alltimetransferred&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortTransferred]"), _T("sort=transferred&sortreverse=") + strTmp);
	}
	else
	if(pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_TRANSFERRED)
	{
		if(pThis->m_Params.bSharedSortReverse)
			Out.Replace(_T("[SortTransferred]"), _T("sort=transferred&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortTransferred]"), _T("sort=alltimetransferred&sortreverse=") + strTmp);
	}
	else
		Out.Replace(_T("[SortTransferred]"), _T("&sort=transferred&sortreverse=false"));
    //Request sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_REQUESTS)
	{
		if(pThis->m_Params.bSharedSortReverse)
			Out.Replace(_T("[SortRequests]"), _T("sort=alltimerequests&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortRequests]"), _T("sort=requests&sortreverse=") + strTmp);
	}
	else
	if(pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_REQUESTS)
	{
		if(pThis->m_Params.bSharedSortReverse)
			Out.Replace(_T("[SortRequests]"), _T("sort=requests&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortRequests]"), _T("sort=alltimerequests&sortreverse=") + strTmp);
	}
	else
        Out.Replace(_T("[SortRequests]"), _T("&sort=requests&sortreverse=false"));
    //Accepts sorting link
	if(pThis->m_Params.SharedSort == SHARED_SORT_ACCEPTS)
	{
		if(pThis->m_Params.bSharedSortReverse)
            Out.Replace(_T("[SortAccepts]"), _T("sort=alltimeaccepts&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortAccepts]"), _T("sort=accepts&sortreverse=") + strTmp);
	}
	else if(pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_ACCEPTS)
	{
		if(pThis->m_Params.bSharedSortReverse)
            Out.Replace(_T("[SortAccepts]"), _T("sort=accepts&sortreverse=") + strTmp);
		else
			Out.Replace(_T("[SortAccepts]"), _T("sort=alltimeaccepts&sortreverse=") + strTmp);
	}
	else
		Out.Replace(_T("[SortAccepts]"), _T("&sort=accepts&sortreverse=false"));

	if(_ParseURL(Data.sURL, _T("reload")) == "true")
	{
		CString strResultLog = _SpecialChars(g_eMuleApp.m_pdlgEmule->m_strLogText);	//Pick-up last line of the log
		strResultLog = strResultLog.TrimRight('\n');
		int iStringIndex = strResultLog.ReverseFind('\n');
		if (iStringIndex != -1)
			strResultLog = strResultLog.Mid(iStringIndex);
		Out.Replace(_T("[Message]"), strResultLog);
	}
	else
		Out.Replace(_T("[Message]"), _T(""));

	const TCHAR *pcSortIcon = (pThis->m_Params.bSharedSortReverse) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;
	const TCHAR *pcIconTmp;

	_GetPlainResString(&strTmp, IDS_DL_FILENAME, true);
	if (!WSsharedColumnHidden[0])
	{
		Out.Replace(_T("[FilenameI]"), (pThis->m_Params.SharedSort == SHARED_SORT_NAME) ? pcSortIcon : "");
		Out.Replace(_T("[Filename]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FilenameI]"), _T(""));
		Out.Replace(_T("[Filename]"), _T(""));
	}
	Out.Replace(_T("[FilenameM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SF_TRANSFERRED, true);
	if (!WSsharedColumnHidden[1])
	{
		pcIconTmp = (pThis->m_Params.SharedSort == SHARED_SORT_TRANSFERRED) ? pcSortIcon : "";
		if (pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_TRANSFERRED)
			pcIconTmp = (pThis->m_Params.bSharedSortReverse) ? pThis->m_Templates.strUpDoubleArrow : pThis->m_Templates.strDownDoubleArrow;
		Out.Replace(_T("[FileTransferredI]"), pcIconTmp);
		Out.Replace(_T("[FileTransferred]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FileTransferredI]"), _T(""));
		Out.Replace(_T("[FileTransferred]"),  _T(""));
	}
	Out.Replace(_T("[FileTransferredM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SF_REQUESTS, true);
	if (!WSsharedColumnHidden[2])
	{
		pcIconTmp = (pThis->m_Params.SharedSort == SHARED_SORT_REQUESTS) ? pcSortIcon : "";
		if (pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_REQUESTS)
			pcIconTmp = (pThis->m_Params.bSharedSortReverse) ? pThis->m_Templates.strUpDoubleArrow : pThis->m_Templates.strDownDoubleArrow;
		Out.Replace(_T("[FileRequestsI]"), pcIconTmp);
		Out.Replace(_T("[FileRequests]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FileRequestsI]"), _T(""));
		Out.Replace(_T("[FileRequests]"),  _T(""));
	}
	Out.Replace(_T("[FileRequestsM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SF_ACCEPTS, true);
	if (!WSsharedColumnHidden[3])
	{
		pcIconTmp = (pThis->m_Params.SharedSort == SHARED_SORT_ACCEPTS) ? pcSortIcon : "";
		if (pThis->m_Params.SharedSort == SHARED_SORT_ALL_TIME_ACCEPTS)
			pcIconTmp = (pThis->m_Params.bSharedSortReverse) ? pThis->m_Templates.strUpDoubleArrow : pThis->m_Templates.strDownDoubleArrow;
		Out.Replace(_T("[FileAcceptsI]"), pcIconTmp);
		Out.Replace(_T("[FileAccepts]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FileAcceptsI]"), _T(""));
		Out.Replace(_T("[FileAccepts]"),  _T(""));
	}
	Out.Replace(_T("[FileAcceptsM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SIZE, true);
	if (!WSsharedColumnHidden[4])
	{
		Out.Replace(_T("[SizeI]"), (pThis->m_Params.SharedSort == SHARED_SORT_SIZE) ? pcSortIcon : "");
		Out.Replace(_T("[Size]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[SizeI]"), _T(""));
		Out.Replace(_T("[Size]"), _T(""));
	}
	Out.Replace(_T("[SizeM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_SF_COMPLETESRC, true);
	if (!WSsharedColumnHidden[5])
	{
		Out.Replace(_T("[CompletesI]"), (pThis->m_Params.SharedSort == SHARED_SORT_COMPLETES) ? pcSortIcon : "");
		Out.Replace(_T("[Completes]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[CompletesI]"), _T(""));
		Out.Replace(_T("[Completes]"),  _T(""));
	}
	Out.Replace(_T("[CompletesM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_PRIORITY, true);
	if (!WSsharedColumnHidden[6])
	{
		Out.Replace(_T("[PriorityI]"), (pThis->m_Params.SharedSort == SHARED_SORT_PRIORITY) ? pcSortIcon : "");
		Out.Replace(_T("[Priority]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[PriorityI]"), _T(""));
		Out.Replace(_T("[Priority]"),  _T(""));
	}
	Out.Replace(_T("[PriorityM]"), strTmp);

	Out.Replace(_T("[Actions]"), _GetPlainResString(IDS_WEB_ACTIONS));
	Out.Replace(_T("[Reload]"), _GetPlainResString(IDS_SF_RELOAD));
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[SharedList]"), _GetPlainResString(IDS_SHAREDFILES));
	Out.Replace(_T("[CatSel]"), sCat);

	CString OutE = pThis->m_Templates.sSharedLine;

	CArray<SharedFiles, SharedFiles> SharedArray;
	// Populating array
	for (POSITION pos = g_eMuleApp.m_pSharedFilesList->m_mapSharedFiles.GetStartPosition(); pos != NULL;)
	{
		CCKey bufKey;
		CKnownFile* cur_file;
		uint16 nCountLo, nCountHi;
		uint32	dwResId;

		g_eMuleApp.m_pSharedFilesList->m_mapSharedFiles.GetNextAssoc(pos,bufKey,cur_file);

		bool bPartFile = cur_file->IsPartFile();

		SharedFiles dFile;
		//dFile.sFileName = _SpecialChars(cur_file->GetFileName());
		dFile.bIsPartFile = cur_file->IsPartFile();
		dFile.sFileName = cur_file->GetFileName();
		if(bPartFile)
			dFile.sFileState = _T("filedown");
		else
			dFile.sFileState = _T("file");
		dFile.sFileType = GetFileTypeForWebServer(_SpecialChars(dFile.sFileName));
		dFile.m_qwFileSize = cur_file->GetFileSize();
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnected())
			dFile.sED2kLink = cur_file->CreateED2kSourceLink();
		else
#endif //OLD_SOCKETS_ENABLED
		dFile.sED2kLink = cur_file->CreateED2kLink();
		dFile.nFileTransferred = cur_file->statistic.GetTransferred();
		dFile.nFileAllTimeTransferred = cur_file->statistic.GetAllTimeTransferred();
		dFile.nFileRequests = cur_file->statistic.GetRequests();
		dFile.nFileAllTimeRequests = cur_file->statistic.GetAllTimeRequests();
		dFile.nFileAccepts = cur_file->statistic.GetAccepts();
		dFile.nFileAllTimeAccepts = cur_file->statistic.GetAllTimeAccepts();
		dFile.sFileHash = HashToString(cur_file->GetFileHash());

		if (bPartFile)
		{
			((CPartFile*)cur_file)->GetCompleteSourcesRange(&nCountLo, &nCountHi);
			dFile.sFileCompletes.Format(_T("%u"), ((CPartFile*)cur_file)->GetCompleteSourcesCount());
		}
		else
		{
			cur_file->GetCompleteSourcesRange(&nCountLo, &nCountHi);
			if (nCountLo == 0)
			{
				if (nCountHi == 0)
					dFile.sFileCompletes.Empty();
				else
					dFile.sFileCompletes.Format(_T("< %u"), nCountHi);
			}
			else if (nCountLo == nCountHi)
				dFile.sFileCompletes.Format(_T("%u"), nCountLo);
			else
				dFile.sFileCompletes.Format(_T("%u - %u"), nCountLo, nCountHi);
		}
		dFile.dblFileCompletes = ((nCountLo == 0) ? ((nCountHi == 0) ? ((bPartFile) ? 2.0 : 0.0) : (2.0 - (1.0 / static_cast<double>(nCountHi)))) : static_cast<double>(nCountLo) + 3.0 - (1.0 / static_cast<double>(nCountHi)));

		if (cur_file->IsULAutoPrioritized())
		{
			if (cur_file->GetULPriority() == PR_NORMAL)
				dwResId = IDS_PRIOAUTONORMAL;
			else if (cur_file->GetULPriority() == PR_HIGH)
				dwResId = IDS_PRIOAUTOHIGH;
			else if (cur_file->GetULPriority() == PR_RELEASE)
				dwResId = IDS_PRIOAUTORELEASE;
			else	//PR_LOW
				dwResId = IDS_PRIOAUTOLOW;
		}
		else
		{
			if (cur_file->GetULPriority() == PR_LOW)
				dwResId = IDS_PRIOLOW;
			else if (cur_file->GetULPriority() == PR_NORMAL)
				dwResId = IDS_PRIONORMAL;
			else if (cur_file->GetULPriority() == PR_HIGH)
				dwResId = IDS_PRIOHIGH;
			else if (cur_file->GetULPriority() == PR_RELEASE)
				dwResId = IDS_PRIORELEASE;
			else	//PR_VERYLOW
				dwResId = IDS_PRIOVERYLOW;
		}
		if (cur_file->GetJumpstartEnabled())
			dFile.sFilePriority.Format(_T("JumpStart[%s]"), GetResString(dwResId));
		else
			GetResString(&dFile.sFilePriority, dwResId);
		dFile.nFilePriority = cur_file->GetULPriority();
		dFile.bFileAutoPriority = cur_file->IsULAutoPrioritized();
		SharedArray.Add(dFile);
	}

	// Sorting (simple bubble sort, we don't have tons of data here)
	bool bSorted = true;

	for(int nMax = 0;bSorted && nMax < SharedArray.GetCount()*2; nMax++)
	{
		bSorted = false;
		for(int i = 0; i < SharedArray.GetCount() - 1; i++)
		{
			bool bSwap = false;
			switch(pThis->m_Params.SharedSort)
			{
			case SHARED_SORT_STATE:
				bSwap = SharedArray[i].sFileState.CompareNoCase(SharedArray[i+1].sFileState) > 0;
				break;
			case SHARED_SORT_TYPE:
				bSwap = SharedArray[i].sFileType.CompareNoCase(SharedArray[i+1].sFileType) > 0;
				break;
			case SHARED_SORT_NAME:
				bSwap = SharedArray[i].sFileName.CompareNoCase(SharedArray[i+1].sFileName) < 0;
				break;
			case SHARED_SORT_SIZE:
				bSwap = SharedArray[i].m_qwFileSize < SharedArray[i+1].m_qwFileSize;
				break;
			case SHARED_SORT_TRANSFERRED:
				bSwap = SharedArray[i].nFileTransferred < SharedArray[i+1].nFileTransferred;
				break;
			case SHARED_SORT_ALL_TIME_TRANSFERRED:
				bSwap = SharedArray[i].nFileAllTimeTransferred < SharedArray[i+1].nFileAllTimeTransferred;
				break;
			case SHARED_SORT_REQUESTS:
				bSwap = SharedArray[i].nFileRequests < SharedArray[i+1].nFileRequests;
				break;
			case SHARED_SORT_ALL_TIME_REQUESTS:
				bSwap = SharedArray[i].nFileAllTimeRequests < SharedArray[i+1].nFileAllTimeRequests;
				break;
			case SHARED_SORT_ACCEPTS:
				bSwap = SharedArray[i].nFileAccepts < SharedArray[i+1].nFileAccepts;
				break;
			case SHARED_SORT_ALL_TIME_ACCEPTS:
				bSwap = SharedArray[i].nFileAllTimeAccepts < SharedArray[i+1].nFileAllTimeAccepts;
				break;
			case SHARED_SORT_COMPLETES:
				bSwap = SharedArray[i].dblFileCompletes < SharedArray[i+1].dblFileCompletes;
				break;
			case SHARED_SORT_PRIORITY:
				//Very low priority is define equal to 4 ! Must adapte sorting code
				if(SharedArray[i].nFilePriority == 4)
				{
					if(SharedArray[i+1].nFilePriority == 4)
						bSwap = false;
					else
						bSwap = true;
				}
				else if(SharedArray[i+1].nFilePriority == 4)
					{
						if(SharedArray[i].nFilePriority == 4)
							bSwap = true;
						else
							bSwap = false;
					}
					else
						bSwap = SharedArray[i].nFilePriority < SharedArray[i+1].nFilePriority;
				break;
			}
			if(pThis->m_Params.bSharedSortReverse)
				bSwap = !bSwap;
			if(bSwap)
			{
				bSorted = true;
				SharedFiles TmpFile = SharedArray[i];
				SharedArray[i] = SharedArray[i+1];
				SharedArray[i+1] = TmpFile;
			}
		}
	}
	// Displaying
	CString sSharedList, HTTPProcessData;
	for(int i = 0; i < SharedArray.GetCount(); i++)
	{
		TCHAR HTTPTempC[100] = _T("");
		HTTPProcessData = OutE;

		if (SharedArray[i].sFileHash == _ParseURL(Data.sURL,_T("hash")) )
            HTTPProcessData.Replace(_T("[LastChangedDataset]"), "checked");
		else
            HTTPProcessData.Replace(_T("[LastChangedDataset]"), "checked_no");

		CString ed2k;				//ed2klink
		CString session;			//session
		CString hash;				//hash
		CString fname;				//filename
		CString sharedpriority;		//priority
		CString isjumpstart;		//jumpstart

		switch(SharedArray[i].nFilePriority)
		{
			case PR_VERYLOW:
				sharedpriority = _T("VeryLow");
				break;
			case PR_LOW:
				sharedpriority = _T("Low");
				break;
			case PR_NORMAL:
				sharedpriority = _T("Normal");
				break;
			case PR_HIGH:
				sharedpriority = _T("High");
				break;
			case PR_RELEASE:
				sharedpriority = _T("Release");
				break;
		}
		if (SharedArray[i].bFileAutoPriority)
			sharedpriority = _T("Auto");

		CString JSED2kLink=SharedArray[i].sED2kLink;
		JSED2kLink.Replace(_T("'"),_T("&#8217;"));

		ed2k = JSED2kLink;
		session = sSession;
		hash = SharedArray[i].sFileHash;
		fname = SharedArray[i].sFileName;
		fname.Replace(_T("'"),_T("&#8217;"));

		CKnownFile* cur_file;
		uchar fileid[16];
		if (hash.GetLength()==32 && DecodeBase16(hash.GetBuffer(),hash.GetLength(),fileid,ARRSIZE(fileid)))
			HTTPProcessData.Replace(_T("[hash]"), hash);
		cur_file=g_eMuleApp.m_pSharedFilesList->GetFileByID(fileid);

#ifdef OLD_SOCKETS_ENABLED
		if (cur_file != NULL)
		{
 			if (cur_file->GetJumpstartEnabled())
			{
				isjumpstart = _T("jumpstart");
				HTTPProcessData.Replace(_T("[FileIsPriority]"), "jumpstart");
			}
			else if (cur_file->GetULPriority() == PR_RELEASE)
				HTTPProcessData.Replace(_T("[FileIsPriority]"), "release");
			else
				HTTPProcessData.Replace(_T("[FileIsPriority]"), "none");
		}
#endif //OLD_SOCKETS_ENABLED

		HTTPProcessData.Replace(_T("[admin]"), (bAdmin) ? _T("admin") : _T(""));
		HTTPProcessData.Replace(_T("[ed2k]"), ed2k);
		HTTPProcessData.Replace(_T("[fname]"), fname);
		HTTPProcessData.Replace(_T("[session]"), session);
		HTTPProcessData.Replace(_T("[shared-priority]"), sharedpriority); //DonGato: priority change
		HTTPProcessData.Replace(_T("[isjumpstart]"), isjumpstart);

		HTTPProcessData.Replace(_T("[FileName]"), _SpecialChars(SharedArray[i].sFileName));
		HTTPProcessData.Replace(_T("[FileType]"), SharedArray[i].sFileType);
		HTTPProcessData.Replace(_T("[FileState]"), SharedArray[i].sFileState);
		if (!WSsharedColumnHidden[0])
		{
			if(SharedArray[i].sFileName.GetLength() > SHORT_LENGTH)
				HTTPProcessData.Replace(_T("[ShortFileName]"), _SpecialChars(SharedArray[i].sFileName.Left(SHORT_LENGTH-3)) + _T("..."));
			else
				HTTPProcessData.Replace(_T("[ShortFileName]"), _SpecialChars(SharedArray[i].sFileName));
		}
		else
			HTTPProcessData.Replace(_T("[ShortFileName]"), _T(""));
		if (!WSsharedColumnHidden[1])
		{
			_stprintf(HTTPTempC, _T("%s"),CastItoXBytes(SharedArray[i].nFileTransferred));
			HTTPProcessData.Replace(_T("[FileTransferred]"), CString(HTTPTempC));
			_stprintf(HTTPTempC, _T("%s"),CastItoXBytes(SharedArray[i].nFileAllTimeTransferred));
			HTTPProcessData.Replace(_T("[FileAllTimeTransferred]"), " ("+CString(HTTPTempC)+")");
		}
		else
		{
			HTTPProcessData.Replace(_T("[FileTransferred]"), _T(""));
			HTTPProcessData.Replace(_T("[FileAllTimeTransferred]"), _T(""));
		}
		if (!WSsharedColumnHidden[2])
		{
			_stprintf(HTTPTempC, _T("%i"), SharedArray[i].nFileRequests);
			HTTPProcessData.Replace(_T("[FileRequests]"), CString(HTTPTempC));
			_stprintf(HTTPTempC, _T("%i"), SharedArray[i].nFileAllTimeRequests);
			HTTPProcessData.Replace(_T("[FileAllTimeRequests]"), " ("+CString(HTTPTempC)+")");
		}
		else
		{
			HTTPProcessData.Replace(_T("[FileRequests]"), _T(""));
			HTTPProcessData.Replace(_T("[FileAllTimeRequests]"), _T(""));
		}
		if (!WSsharedColumnHidden[3])
		{
			_stprintf(HTTPTempC, _T("%i"), SharedArray[i].nFileAccepts);
			HTTPProcessData.Replace(_T("[FileAccepts]"), CString(HTTPTempC));
			_stprintf(HTTPTempC, _T("%i"), SharedArray[i].nFileAllTimeAccepts);
			HTTPProcessData.Replace(_T("[FileAllTimeAccepts]"), " ("+CString(HTTPTempC)+")");
		}
		else
		{
			HTTPProcessData.Replace(_T("[FileAccepts]"), _T(""));
			HTTPProcessData.Replace(_T("[FileAllTimeAccepts]"), _T(""));
		}
		if (!WSsharedColumnHidden[4])
		{
			_stprintf(HTTPTempC, _T("%s"),CastItoXBytes(SharedArray[i].m_qwFileSize));
			HTTPProcessData.Replace(_T("[FileSize]"), CString(HTTPTempC));
		}
		else
			HTTPProcessData.Replace(_T("[FileSize]"), _T(""));
		if (!WSsharedColumnHidden[5])
			HTTPProcessData.Replace(_T("[Completes]"), SharedArray[i].sFileCompletes);
		else
			HTTPProcessData.Replace(_T("[Completes]"), _T(""));
		if (!WSsharedColumnHidden[6])
			HTTPProcessData.Replace(_T("[Priority]"), SharedArray[i].sFilePriority);
		else
			HTTPProcessData.Replace(_T("[Priority]"), _T(""));

		HTTPProcessData.Replace(_T("[FileHash]"), SharedArray[i].sFileHash);

		sSharedList += HTTPProcessData;
	}
	Out.Replace(_T("[SharedFilesList]"), sSharedList);
	Out.Replace(_T("[Session]"), sSession);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetGraphs(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	CString Out = pThis->m_Templates.sGraphs;

	CString strGraphDownload, strGraphUpload, strGraphCons;

	for(int i = 0; i < WEB_GRAPH_WIDTH; i++)
	{
		if(i < pThis->m_Params.PointsForWeb.GetCount())
		{
			if(i != 0)
			{
				strGraphDownload += _T(',');
				strGraphUpload += _T(',');
				strGraphCons += _T(',');
			}

			// download
			strGraphDownload.AppendFormat(_T("%u"), (uint32)(pThis->m_Params.PointsForWeb[i].download*1024));

			// upload
			strGraphUpload.AppendFormat(_T("%u"), (uint32)(pThis->m_Params.PointsForWeb[i].upload*1024));

			// connections
			strGraphCons.AppendFormat(_T("%u"), (uint32)(pThis->m_Params.PointsForWeb[i].connections));
		}
	}

	Out.Replace(_T("[GraphDownload]"), strGraphDownload);
	Out.Replace(_T("[GraphUpload]"), strGraphUpload);
	Out.Replace(_T("[GraphConnections]"), strGraphCons);

	Out.Replace(_T("[TxtDownload]"), _GetPlainResString(IDS_ST_ACTIVEDOWNLOAD));
	Out.Replace(_T("[TxtUpload]"), _GetPlainResString(IDS_ST_ACTIVEUPLOAD));
	Out.Replace(_T("[TxtTime]"), _GetPlainResString(IDS_TIME));
	Out.Replace(_T("[KByteSec]"), _GetPlainResString(IDS_KBYTESEC));
	Out.Replace(_T("[TxtConnections]"), _GetPlainResString(IDS_ST_ACTIVECONNECTIONS));

	Out.Replace(_T("[ScaleTime]"), CastSecondsToHM(g_eMuleApp.m_pGlobPrefs->GetTrafficOMeterInterval() * WEB_GRAPH_WIDTH));

	CString s1;
	s1.Format(_T("%u"), g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate() / 10);
	Out.Replace(_T("[MaxDownload]"), s1);
	s1.Format(_T("%u"), g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate() / 10);
	Out.Replace(_T("[MaxUpload]"), s1);
	s1.Format(_T("%u"), g_eMuleApp.m_pGlobPrefs->GetMaxConnections());
	Out.Replace(_T("[MaxConnections]"), s1);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetAddServerBox(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	if (!IsSessionAdmin(Data,sSession))
		return _T("");

	CString Out = pThis->m_Templates.sAddServerBox;
	if(_ParseURL(Data.sURL, _T("addserver")) == "true")
	{
		if (!_ParseURL(Data.sURL, _T("serveraddr")).IsEmpty() && !_ParseURL(Data.sURL, _T("serverport")).IsEmpty())
		{
			g_eMuleApp.m_pdlgEmule->m_wndServer.AddServer(_ParseURL(Data.sURL, _T("serveraddr")),_ParseURL(Data.sURL, _T("serverport")),_ParseURL(Data.sURL, _T("servername")));
			CString resultlog = _SpecialChars(g_eMuleApp.m_pdlgEmule->m_strLogText); //Pick-up last line of the log

			CServer* server=g_eMuleApp.m_pServerList->GetServerByAddress(_ParseURL(Data.sURL, _T("serveraddr")),atoi(_ParseURL(Data.sURL, _T("serverport"))));
			if (_ParseURL(Data.sURL, _T("priority")) == "low")
				server->SetPreference((CServer::EnumServerPriority)PR_LOW);
			else if (_ParseURL(Data.sURL, _T("priority")) == "normal")
				server->SetPreference((CServer::EnumServerPriority)PR_NORMAL);
			else if (_ParseURL(Data.sURL, _T("priority")) == "high")
				server->SetPreference((CServer::EnumServerPriority)PR_NORMAL);
			if (g_eMuleApp.m_pdlgEmule->m_wndServer)
				g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*server);

			if(_ParseURL(Data.sURL, _T("addtostatic")) == "true")
			{
				_AddToStatic(_ParseURL(Data.sURL, _T("serveraddr")),atoi(_ParseURL(Data.sURL, _T("serverport"))));
				resultlog += "<br>";
				resultlog += _SpecialChars(g_eMuleApp.m_pdlgEmule->m_strLogText); //Pick-up last line of the log
			}
			resultlog = resultlog.TrimRight('\n');
			resultlog = resultlog.Mid(resultlog.ReverseFind('\n'));
			Out.Replace(_T("[Message]"), resultlog);
			if(_ParseURL(Data.sURL, _T("connectnow")) == "true")
				_ConnectToServer(_ParseURL(Data.sURL, _T("serveraddr")),atoi(_ParseURL(Data.sURL, _T("serverport"))));
		}
		else
			Out.Replace(_T("[Message]"), _GetPlainResString(IDS_INVALIDSA));
	}
	else if(_ParseURL(Data.sURL, _T("updateservermetfromurl")) == "true")
	{
		g_eMuleApp.m_pdlgEmule->m_wndServer.UpdateServerMetFromURL(_ParseURL(Data.sURL, _T("servermeturl")));
		CString resultlog = _SpecialChars(g_eMuleApp.m_pdlgEmule->m_strLogText);
		resultlog = resultlog.TrimRight('\n');
		resultlog = resultlog.Mid(resultlog.ReverseFind('\n'));
		Out.Replace(_T("[Message]"),resultlog);
	}
	else
		Out.Replace(_T("[Message]"), _T(""));
    Out.Replace(_T("[AddServer]"), _GetPlainResString(IDS_SV_NEWSERVER));
	Out.Replace(_T("[IP]"), _GetPlainResString(IDS_SV_ADDRESS));
	Out.Replace(_T("[Port]"), _GetPlainResString(IDS_PORT));
	Out.Replace(_T("[Name]"), _GetPlainResString(IDS_SW_NAME));
	Out.Replace(_T("[Static]"), _GetPlainResString(IDS_STATICSERVER));
	Out.Replace(_T("[ConnectNow]"), _GetPlainResString(IDS_CONNECTNOW));
	Out.Replace(_T("[Priority]"), _GetPlainResString(IDS_PRIORITY));
	Out.Replace(_T("[Low]"), _GetPlainResString(IDS_PRIOLOW));
	Out.Replace(_T("[Normal]"), _GetPlainResString(IDS_PRIONORMAL));
	Out.Replace(_T("[High]"), _GetPlainResString(IDS_PRIOHIGH));
	Out.Replace(_T("[Add]"), _GetPlainResString(IDS_SV_ADD));
	Out.Replace(_T("[UpdateServerMetFromURL]"), _GetPlainResString(IDS_SV_MET));
	Out.Replace(_T("[URL]"), _GetPlainResString(IDS_SV_URL));
	Out.Replace(_T("[Apply]"), _GetPlainResString(IDS_PW_APPLY));
	Out.Replace(_T("[URL_Disconnect]"), IsSessionAdmin(Data,sSession)?CString(_T("/?ses=") + sSession + _T("&w=server&c=disconnect&cat=") + sCat):GetPermissionDenied());
	Out.Replace(_T("[URL_Connect]"), IsSessionAdmin(Data,sSession)?CString(_T("/?ses=") + sSession + _T("&w=server&c=connect&cat=") + sCat):GetPermissionDenied());
	Out.Replace(_T("[Disconnect]"), _GetPlainResString(IDS_IRC_DISCONNECT));
	Out.Replace(_T("[Connect]"), _GetPlainResString(IDS_CONNECTTOANYSERVER));
	Out.Replace(_T("[ServerOptions]"), CString(_GetPlainResString(IDS_FSTAT_CONNECTION)));
	Out.Replace(_T("[Execute]"), _GetPlainResString(IDS_IRC_PERFORM));
	Out.Replace(_T("[CatSel]"), sCat);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetLog(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);
	
	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	CString Out = pThis->m_Templates.sLog;

	if (_ParseURL(Data.sURL, _T("clear")) == "yes" && IsSessionAdmin(Data,sSession))
	{
		g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlLogBox->Reset();
		LRESULT pDummy;
		g_eMuleApp.m_pdlgEmule->m_wndServer.OnTcnSelchangeTab1(NULL, &pDummy);
	}
	Out.Replace(_T("[Clear]"), _GetPlainResString(IDS_PW_RESET));
	Out.Replace(_T("[Log]"), g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlLogBox->GetHtml()+"<br><a name=\"end\"></a>");
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[CatSel]"), sCat);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetServerInfo(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	CString Out = pThis->m_Templates.sServerInfo;

	if (_ParseURL(Data.sURL, _T("clear")) == "yes" && IsSessionAdmin(Data,sSession))
	{
		g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlServerMsgBox->Reset();
		LRESULT pDummy;
		g_eMuleApp.m_pdlgEmule->m_wndServer.OnTcnSelchangeTab1(NULL, &pDummy);
	}
	Out.Replace(_T("[Clear]"), _GetPlainResString(IDS_PW_RESET));
	Out.Replace(_T("[ServerInfo]"), g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlServerMsgBox->GetHtml()+"<br><a name=\"end\"></a>" );
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[CatSel]"), sCat);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetDebugLog(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);
	
	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	CString Out = pThis->m_Templates.sDebugLog;

	if (_ParseURL(Data.sURL, _T("clear")) == "yes" && IsSessionAdmin(Data,sSession))
	{
		g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlDebugBox->Reset();
		LRESULT pDummy;
		g_eMuleApp.m_pdlgEmule->m_wndServer.OnTcnSelchangeTab1(NULL, &pDummy);
	}
	Out.Replace(_T("[Clear]"), _GetPlainResString(IDS_PW_RESET));
	Out.Replace(_T("[DebugLog]"), g_eMuleApp.m_pdlgEmule->m_wndServer.m_pctlDebugBox->GetHtml()+"<br><a name=\"end\"></a>" );
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[CatSel]"), sCat);

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetStats(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	// refresh statistics
	g_eMuleApp.m_pdlgEmule->ShowStatistics();
	g_eMuleApp.m_pdlgEmule->m_dlgStatistics.ShowStatistics(true);

	CString Out = pThis->m_Templates.sStats;
	// eklmn: new stats
	Out.Replace(_T("[Stats]"), g_eMuleApp.m_pdlgEmule->m_dlgStatistics.stattree.GetHTMLForExport());

	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetPreferences(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte		cat = atoi(_ParseURL(Data.sURL,"cat"));

	CString sCat, strTmp;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	CString Out = pThis->m_Templates.sPreferences;
	Out.Replace(_T("[Session]"), sSession);

	if ((_ParseURL(Data.sURL, _T("saveprefs")) == "true") && IsSessionAdmin(Data,sSession) )
	{
		if(_ParseURL(Data.sURL, _T("gzip")) == "true" || _ParseURL(Data.sURL, _T("gzip")).MakeLower() == "on")
			g_eMuleApp.m_pGlobPrefs->SetWebUseGzip(true);
		if(_ParseURL(Data.sURL, _T("gzip")) == "false" || _ParseURL(Data.sURL, _T("gzip")).IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetWebUseGzip(false);
		if(_ParseURL(Data.sURL, _T("showuploadqueue")) == "true" || _ParseURL(Data.sURL, _T("showuploadqueue")).MakeLower() == "on" )
			pThis->m_Params.bShowUploadQueue = true;
		else
			pThis->m_Params.bShowUploadQueue = false;
		if(_ParseURL(Data.sURL, _T("showuploadqueuebanned")) == "true" || _ParseURL(Data.sURL, _T("showuploadqueuebanned")).MakeLower() == "on" )
			pThis->m_Params.bShowUploadQueueBanned = true;
		else
			pThis->m_Params.bShowUploadQueueBanned = false;
		if(_ParseURL(Data.sURL, _T("showuploadqueuefriend")) == "true" || _ParseURL(Data.sURL, _T("showuploadqueuefriend")).MakeLower() == "on" )
			pThis->m_Params.bShowUploadQueueFriend = true;
		else
			pThis->m_Params.bShowUploadQueueFriend = false;
		if(_ParseURL(Data.sURL, _T("showuploadqueuecredit")) == "true" || _ParseURL(Data.sURL, _T("showuploadqueuecredit")).MakeLower() == "on" )
			pThis->m_Params.bShowUploadQueueCredit = true;
		else
			pThis->m_Params.bShowUploadQueueCredit = false;
		if(!_ParseURL(Data.sURL, _T("refresh")).IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetWebPageRefresh(_tstoi(_ParseURL(Data.sURL, _T("refresh"))));

		strTmp = _ParseURL(Data.sURL, _T("maxcapdown"));
		if(!strTmp.IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetMaxGraphDownloadRate(ValidateDownCapability(10 * _tstoi(strTmp)));
		strTmp = _ParseURL(Data.sURL, _T("maxcapup"));
		if(!strTmp.IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetMaxGraphUploadRate(ValidateUpCapability(10 * _tstoi(strTmp)));

		uint32	dwSpeed;

		strTmp = _ParseURL(Data.sURL, _T("maxdown"));
		if (!strTmp.IsEmpty())
		{
			dwSpeed = String2FranctionalRate(strTmp);
			if (dwSpeed != 0)
			{
				g_eMuleApp.m_pGlobPrefs->SetMaxDownloadWithCheck(dwSpeed);
				g_eMuleApp.m_pGlobPrefs->SetLimitlessDownload(false);	//SyruS disable limitless on setting a specific value
			}
			else
				g_eMuleApp.m_pGlobPrefs->SetLimitlessDownload(true);	//SyruS enable limitless on setting to 0
		}
		strTmp = _ParseURL(Data.sURL, _T("maxup"));
		if (!strTmp.IsEmpty())
		{
			dwSpeed = String2FranctionalRate(strTmp);
			if (dwSpeed != 0)
				g_eMuleApp.m_pGlobPrefs->SetMaxUploadWithCheck(dwSpeed);
		}

		if(!_ParseURL(Data.sURL, _T("maxsources")).IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetMaxSourcePerFile(_tstoi(_ParseURL(Data.sURL, _T("maxsources"))));
		if(!_ParseURL(Data.sURL, _T("maxconnections")).IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetMaxConnections(_tstoi(_ParseURL(Data.sURL, _T("maxconnections"))));
		if(!_ParseURL(Data.sURL, _T("maxconnectionsperfive")).IsEmpty())
			g_eMuleApp.m_pGlobPrefs->SetMaxDownloadConperFive(_tstoi(_ParseURL(Data.sURL, _T("maxconnectionsperfive"))));
	}

	// Fill form
	if(g_eMuleApp.m_pGlobPrefs->GetWebUseGzip())
		Out.Replace(_T("[UseGzipVal]"), _T("checked"));
	else
		Out.Replace(_T("[UseGzipVal]"), _T(""));
	if(pThis->m_Params.bShowUploadQueue)
		Out.Replace(_T("[ShowUploadQueueVal]"), _T("checked"));
	else
		Out.Replace(_T("[ShowUploadQueueVal]"), _T(""));
	if(pThis->m_Params.bShowUploadQueueBanned)
		Out.Replace(_T("[ShowUploadQueueBannedVal]"), _T("checked"));
	else
		Out.Replace(_T("[ShowUploadQueueBannedVal]"), _T(""));
	if(pThis->m_Params.bShowUploadQueueFriend)
		Out.Replace(_T("[ShowUploadQueueFriendVal]"), _T("checked"));
	else
		Out.Replace(_T("[ShowUploadQueueFriendVal]"), _T(""));
	if(pThis->m_Params.bShowUploadQueueCredit)
		Out.Replace(_T("[ShowUploadQueueCreditVal]"), _T("checked"));
	else
		Out.Replace(_T("[ShowUploadQueueCreditVal]"), _T(""));
	CString sRefresh;

	sRefresh.Format(_T("%d"), g_eMuleApp.m_pGlobPrefs->GetWebPageRefresh());
	Out.Replace(_T("[RefreshVal]"), sRefresh);

	sRefresh.Format(_T("%d"), g_eMuleApp.m_pGlobPrefs->GetMaxSourcePerFile());
	Out.Replace(_T("[MaxSourcesVal]"), sRefresh);

	sRefresh.Format(_T("%d"), g_eMuleApp.m_pGlobPrefs->GetMaxConnections());
	Out.Replace(_T("[MaxConnectionsVal]"), sRefresh);

	sRefresh.Format(_T("%d"), g_eMuleApp.m_pGlobPrefs->GetMaxConPerFive());
	Out.Replace(_T("[MaxConnectionsPer5Val]"), sRefresh);

	Out.Replace(_T("[KBS]"), _GetPlainResString(IDS_KBYTESEC)+_T(":"));
	Out.Replace(_T("[LimitForm]"), _GetPlainResString(IDS_WEB_CONLIMITS)+_T(":"));
	Out.Replace(_T("[MaxSources]"), _GetPlainResString(IDS_PW_MAXSOURCES)+_T(":"));
	Out.Replace(_T("[MaxConnections]"), _GetPlainResString(IDS_PW_MAXC)+_T(":"));
	Out.Replace(_T("[MaxConnectionsPer5]"), _GetPlainResString(IDS_MAXCON5_TEXT)+_T(":"));
	Out.Replace(_T("[UseGzipForm]"), _GetPlainResString(IDS_WEB_GZIP_COMPRESSION));
	Out.Replace(_T("[UseGzipComment]"), _GetPlainResString(IDS_WEB_GZIP_COMMENT));
	Out.Replace(_T("[ShowUploadQueueForm]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE));
	Out.Replace(_T("[ShowUploadQueueBannedForm]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_BANNED));
	Out.Replace(_T("[ShowUploadQueueFriendForm]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_FRIEND));
	Out.Replace(_T("[ShowUploadQueueCreditForm]"), _GetPlainResString(IDS_WEB_SHOW_UPLOAD_QUEUE_CREDIT));
	Out.Replace(_T("[ShowUploadQueueComment]"), _GetPlainResString(IDS_WEB_UPLOAD_QUEUE_COMMENT));
	Out.Replace(_T("[ShowUploadQueueBannedComment]"), _GetPlainResString(IDS_WEB_UPLOAD_QUEUE_BANNED_COMMENT));
	Out.Replace(_T("[ShowUploadQueueFriendComment]"), _GetPlainResString(IDS_WEB_UPLOAD_QUEUE_FRIEND_COMMENT));
	Out.Replace(_T("[ShowUploadQueueCreditComment]"), _GetPlainResString(IDS_WEB_UPLOAD_QUEUE_CREDIT_COMMENT));
	Out.Replace(_T("[ShowQueue]"), _GetPlainResString(IDS_SHOW));
	Out.Replace(_T("[HideQueue]"), _GetPlainResString(IDS_HIDE));
	Out.Replace(_T("[ShowQueueBanned]"), _GetPlainResString(IDS_SHOW));
	Out.Replace(_T("[HideQueueBanned]"), _GetPlainResString(IDS_HIDE));
	Out.Replace(_T("[ShowQueueFriend]"), _GetPlainResString(IDS_SHOW));
	Out.Replace(_T("[HideQueueFriend]"), _GetPlainResString(IDS_HIDE));
	Out.Replace(_T("[ShowQueueCredit]"), _GetPlainResString(IDS_SHOW));
	Out.Replace(_T("[HideQueueCredit]"), _GetPlainResString(IDS_HIDE));
	Out.Replace(_T("[RefreshTimeForm]"), _GetPlainResString(IDS_WEB_REFRESH_TIME));
	Out.Replace(_T("[RefreshTimeComment]"), _GetPlainResString(IDS_WEB_REFRESH_COMMENT));
	Out.Replace(_T("[SpeedForm]"), _GetPlainResString(IDS_SPEED_LIMITS));
	Out.Replace(_T("[MaxDown]"), _GetPlainResString(IDS_ST_ACTIVEDOWNLOAD));
	Out.Replace(_T("[MaxUp]"), _GetPlainResString(IDS_ST_ACTIVEUPLOAD));
	Out.Replace(_T("[SpeedCapForm]"), _GetPlainResString(IDS_CAPACITY_LIMITS));
	Out.Replace(_T("[MaxCapDown]"), _GetPlainResString(IDS_ST_ACTIVEDOWNLOAD));
	Out.Replace(_T("[MaxCapUp]"), _GetPlainResString(IDS_ST_ACTIVEUPLOAD));
	Out.Replace(_T("[WebControl]"), _GetPlainResString(IDS_WEB_CONTROL));
	Out.Replace(_T("[eMuleAppName]"), CLIENT_NAME);
	Out.Replace(_T("[Apply]"), _GetPlainResString(IDS_PW_APPLY));

	CString	sT;
//	Show always 0 when limitless is enabled otherwise it can be disabled on apply
	uint32	dwNum = (g_eMuleApp.m_pGlobPrefs->LimitlessDownload()) ? UNLIMITED : g_eMuleApp.m_pGlobPrefs->GetMaxDownload();

	FractionalRate2String(&sT, (dwNum == UNLIMITED) ? 0 : dwNum);
	Out.Replace(_T("[MaxDownVal]"), sT);
	dwNum = g_eMuleApp.m_pGlobPrefs->GetMaxUpload();
	FractionalRate2String(&sT, (dwNum == UNLIMITED) ? 0 : dwNum);
	Out.Replace(_T("[MaxUpVal]"), sT);
	sT.Format(_T("%u"), g_eMuleApp.m_pGlobPrefs->GetMaxGraphDownloadRate() / 10);
	Out.Replace(_T("[MaxCapDownVal]"), sT);
	sT.Format(_T("%u"), g_eMuleApp.m_pGlobPrefs->GetMaxGraphUploadRate() / 10);
	Out.Replace(_T("[MaxCapUpVal]"), sT);

	Out.Replace(_T("[CatSel]"), sCat);
	
	return Out;

	EMULE_CATCH

	return _T("");
}

CString CWebServer::_GetLoginScreen(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	CString sSession = _ParseURL(Data.sURL, _T("ses"));

	CString Out;

	Out += pThis->m_Templates.sLogin;

	Out.Replace(_T("[CharSet]"), _GetWebCharSet());
	Out.Replace(_T("[eMuleAppName]"), CLIENT_NAME);
	Out.Replace(_T("[version]"), CURRENT_VERSION_LONG);
	Out.Replace(_T("[Login]"), _GetPlainResString(IDS_WEB_LOGIN));
	Out.Replace(_T("[EnterPassword]"), _GetPlainResString(IDS_WEB_ENTER_PASSWORD));
	Out.Replace(_T("[LoginNow]"), _GetPlainResString(IDS_WEB_LOGIN_NOW));
	Out.Replace(_T("[WebControl]"), _GetPlainResString(IDS_WEB_CONTROL));

	if(pThis->m_nIntruderDetect >= 1)
		Out.Replace(_T("[FailedLogin]"), _T("<p class=\"failed\">") + _GetPlainResString(IDS_WEB_BADLOGINATTEMPT) + _T("</p>"));
	else
		Out.Replace(_T("[FailedLogin]"), "&nbsp;");

	return Out;

	EMULE_CATCH

	return _T("");
}

// We have to add gz-header and some other stuff
// to standard zlib functions
// in order to use gzip in web pages
int CWebServer::_GzipCompress(Bytef *dest, uLongf *destLen, const Bytef *source, uLong sourceLen, int level)
{
	EMULE_TRY

	const static int gz_magic[2] = {0x1f, 0x8b}; // gzip magic header
	int err;
	uLong crc;
	z_stream stream = {0};
	stream.zalloc = (alloc_func)0;
	stream.zfree = (free_func)0;
	stream.opaque = (voidpf)0;
	crc = crc32(0L, Z_NULL, 0);
	// init Zlib stream
	// NOTE windowBits is passed < 0 to suppress zlib header
	err = deflateInit2(&stream, level, Z_DEFLATED, -MAX_WBITS, MAX_MEM_LEVEL, Z_DEFAULT_STRATEGY);
	if (err != Z_OK)
		return err;

	sprintf((char*)dest , "%c%c%c%c%c%c%c%c%c%c", gz_magic[0], gz_magic[1],
		Z_DEFLATED, 0 /*flags*/, 0,0,0,0 /*time*/, 0 /*xflags*/, 255);
	// wire buffers
	stream.next_in = (Bytef*) source ;
	stream.avail_in = (uInt)sourceLen;
	stream.next_out = ((Bytef*) dest) + 10;
	stream.avail_out = *destLen - 18;
	// doit
	err = deflate(&stream, Z_FINISH);
	if (err != Z_STREAM_END)
	{
		deflateEnd(&stream);
		return err;
	}
	err = deflateEnd(&stream);
	crc = crc32(crc, (const Bytef *) source ,  sourceLen );
	//CRC
	*(((Bytef*) dest)+10+stream.total_out) = (Bytef)(crc & 0xFF);
	*(((Bytef*) dest)+10+stream.total_out+1) = (Bytef)((crc>>8) & 0xFF);
	*(((Bytef*) dest)+10+stream.total_out+2) = (Bytef)((crc>>16) & 0xFF);
	*(((Bytef*) dest)+10+stream.total_out+3) = (Bytef)((crc>>24) & 0xFF);
	// Length
	*(((Bytef*) dest)+10+stream.total_out+4) = (Bytef)( sourceLen  & 0xFF);
	*(((Bytef*) dest)+10+stream.total_out+5) = (Bytef)(( sourceLen >>8) & 0xFF);
	*(((Bytef*) dest)+10+stream.total_out+6) = (Bytef)(( sourceLen >>16) &	0xFF);
	*(((Bytef*) dest)+10+stream.total_out+7) = (Bytef)(( sourceLen >>24) &	0xFF);
	// return  destLength
	*destLen = 10 + stream.total_out + 8;
	return err;

	EMULE_CATCH

	return -1;
}

bool CWebServer::_IsLoggedIn(ThreadData Data, long lSession)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	_RemoveTimeOuts(Data,lSession);

	// find our session
	// i should have used CMap there, but i like CArray more ;-)
	for(int i = 0; i < pThis->m_Params.Sessions.GetSize(); i++)
	{
		if(pThis->m_Params.Sessions[i].lSession == lSession && lSession != 0)
		{
			// if found, also reset expiration time
			pThis->m_Params.Sessions[i].startTime = CTime::GetCurrentTime();
			return true;
		}
	}

	EMULE_CATCH

	return false;
}

void CWebServer::_RemoveTimeOuts(ThreadData Data, long lSession)
{
	EMULE_TRY

	// remove expired sessions
	CWebServer *pThis = (CWebServer *)Data.pThis;
	pThis->UpdateSessionCount();

	EMULE_CATCH
}

bool CWebServer::_RemoveSession(ThreadData Data, long lSession)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	// find our session
	for(int i = 0; i < pThis->m_Params.Sessions.GetSize(); i++)
	{
		if(pThis->m_Params.Sessions[i].lSession == lSession && lSession != 0)
		{
			pThis->m_Params.Sessions.RemoveAt(i);
			CString t_ulCurIP;
			t_ulCurIP.Format(_T("%u.%u.%u.%u"),(byte)pThis->m_ulCurIP,(byte)(pThis->m_ulCurIP>>8),(byte)(pThis->m_ulCurIP>>16),(byte)(pThis->m_ulCurIP>>24));
			g_eMuleApp.m_pdlgEmule->AddLogLine(true, RGB_LOG_NOTICE + GetResString(IDS_WEB_SESSIONEND),t_ulCurIP);
			return true;
		}
	}

	EMULE_CATCH

	return false;
}

Session CWebServer::GetSessionByID(ThreadData Data,long sessionID)
{
	EMULE_TRY
	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis != NULL) {
		for(int i = 0; i < pThis->m_Params.Sessions.GetSize(); i++)
		{
			if(pThis->m_Params.Sessions[i].lSession == sessionID && sessionID != 0)
				return pThis->m_Params.Sessions.GetAt(i);
		}
	}

	EMULE_CATCH

	Session ses;
	ses.admin=false;
	ses.startTime = 0;

	return ses;
}

bool CWebServer::IsSessionAdmin(ThreadData Data, const CString &strSsessionID)
{
	EMULE_TRY

	long sessionID = _tstoi64(strSsessionID);
	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis != NULL)
	{
		for(int i = 0; i < pThis->m_Params.Sessions.GetSize(); i++)
		{
			if(pThis->m_Params.Sessions[i].lSession == sessionID && sessionID != 0)
				return pThis->m_Params.Sessions[i].admin;
		}
	}
	EMULE_CATCH
	return false;
}

CString CWebServer::GetPermissionDenied()
{
	return _T("javascript:alert(\'")+_GetPlainResString(IDS_ACCESSDENIED)+_T("\')");
}

CString CWebServer::_GetPlainResString(UINT nID, bool noquote)
{
	EMULE_TRY

	CString sRet = GetResString(nID);
	sRet.Remove(_T('&'));
	if(noquote)
	{
		sRet.Replace(_T("'"), _T("&#8217;"));
		sRet.Replace(_T("\n"), _T("\\n"));
	}
	return sRet;

	EMULE_CATCH

	return _T("");
}

void CWebServer::_GetPlainResString(CString *pstrOut, UINT nID, bool noquote /*=false*/)
{
	GetResString(pstrOut, nID);
	pstrOut->Remove(_T('&'));
	if(noquote)
	{
		pstrOut->Replace(_T("'"), _T("&#8217;"));
		pstrOut->Replace(_T("\n"), _T("\\n"));
	}
}

CString	CWebServer::_GetWebCharSet()
{
	EMULE_TRY

	switch (g_eMuleApp.m_pGlobPrefs->GetLanguageID())
	{
		case MAKELANGID(LANG_POLISH,SUBLANG_DEFAULT):				return _T("windows-1250");
		case MAKELANGID(LANG_RUSSIAN,SUBLANG_DEFAULT):				return _T("windows-1251");
		case MAKELANGID(LANG_GREEK,SUBLANG_DEFAULT):				return _T("ISO-8859-7");
		case MAKELANGID(LANG_HEBREW,SUBLANG_DEFAULT):				return _T("ISO-8859-8-i");
		case MAKELANGID(LANG_KOREAN,SUBLANG_DEFAULT):				return _T("EUC-KR");
		case MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_SIMPLIFIED):	return _T("GB2312");
		case MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_TRADITIONAL):	return _T("Big5");
		case MAKELANGID(LANG_LITHUANIAN,SUBLANG_DEFAULT):			return _T("windows-1257");
		case MAKELANGID(LANG_ROMANIAN,SUBLANG_DEFAULT):				return _T("windows-1250");
		case MAKELANGID(LANG_TURKISH,SUBLANG_DEFAULT):				return _T("windows-1254");
	}

	EMULE_CATCH

	// Western (Latin) includes Catalan, Danish, Dutch, English, Faeroese, Finnish, French,
	// German, Galician, Irish, Icelandic, Italian, Norwegian, Portuguese, Spanish and Swedish
	return _T("ISO-8859-1");
}

// Ornis: creating the progressbar. colored if ressources are given/available
CString CWebServer::_GetDownloadGraph(ThreadData Data, CString filehash)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	CPartFile* pPartFile;
	uchar fileid[16];
	if (filehash.GetLength()!=32 || !DecodeBase16(filehash.GetBuffer(), filehash.GetLength(), fileid,ARRSIZE(fileid)))
		return _T("");

	CString Out;
	CString progresscolor[12];

	pPartFile = g_eMuleApp.m_pDownloadQueue->GetFileByID(fileid);

	if (pPartFile != NULL && (pPartFile->GetStatus() == PS_PAUSED || pPartFile->GetStatus() == PS_STOPPED))
	{
	//	Color style (paused files)
		progresscolor[0]=_T("p_green.gif");
		progresscolor[1]=_T("p_black.gif");
		progresscolor[2]=_T("p_yellow.gif");
		progresscolor[3]=_T("p_red.gif");
		progresscolor[4]=_T("p_blue1.gif");
		progresscolor[5]=_T("p_blue2.gif");
		progresscolor[6]=_T("p_blue3.gif");
		progresscolor[7]=_T("p_blue4.gif");
		progresscolor[8]=_T("p_blue5.gif");
		progresscolor[9]=_T("p_blue6.gif");
		progresscolor[10]=_T("p_greenpercent.gif");
		progresscolor[11]=_T("transparent.gif");
	}
	else
	{
	//	Color style (active files)
		progresscolor[0]=_T("green.gif");
		progresscolor[1]=_T("black.gif");
		progresscolor[2]=_T("yellow.gif");
		progresscolor[3]=_T("red.gif");
		progresscolor[4]=_T("blue1.gif");
		progresscolor[5]=_T("blue2.gif");
		progresscolor[6]=_T("blue3.gif");
		progresscolor[7]=_T("blue4.gif");
		progresscolor[8]=_T("blue5.gif");
		progresscolor[9]=_T("blue6.gif");
		progresscolor[10]=_T("greenpercent.gif");
		progresscolor[11]=_T("transparent.gif");
	}

	if (pPartFile == NULL || !pPartFile->IsPartFile())
	{
		Out.AppendFormat(pThis->m_Templates.sProgressbarImgsPercent+_T("<br>"), progresscolor[10], pThis->m_Templates.iProgressbarWidth);
		Out.AppendFormat(pThis->m_Templates.sProgressbarImgs,progresscolor[0], pThis->m_Templates.iProgressbarWidth);
	}
	else
	{
		CString s_ChunkBar=pPartFile->GetProgressString(pThis->m_Templates.iProgressbarWidth);

		// and now make a graph out of the array - need to be in a progressive way
		byte lastcolor=1;
		uint16 lastindex=0;

		int		compl = static_cast<int>((pThis->m_Templates.iProgressbarWidth / 100.0) * pPartFile->GetPercentCompleted());

		Out.AppendFormat(pThis->m_Templates.sProgressbarImgsPercent+_T("<br>"),
			progresscolor[(compl > 0) ? 10 : 11], (compl > 0) ? compl : 5);

		for (uint16 i=0;i<pThis->m_Templates.iProgressbarWidth;i++)
		{
			if (lastcolor!= _tstoi(s_ChunkBar.Mid(i,1)))
			{
				if (i>lastindex)
				{
					Out.AppendFormat(pThis->m_Templates.sProgressbarImgs, progresscolor[lastcolor], i-lastindex);
				}
				lastcolor=_tstoi(s_ChunkBar.Mid(i,1));
				lastindex=i;
			}
		}
		Out.AppendFormat(pThis->m_Templates.sProgressbarImgs, progresscolor[lastcolor], pThis->m_Templates.iProgressbarWidth-lastindex);
	}
	return Out;

	EMULE_CATCH

	return _T("");
}

CString	CWebServer::_GetSearch(ThreadData Data)
{
	EMULE_TRY

	CWebServer *pThis = (CWebServer *)Data.pThis;
	if(pThis == NULL)
		return _T("");

	byte cat=atoi(_ParseURL(Data.sURL, "cat"));
	CString sSession = _ParseURL(Data.sURL, _T("ses"));
	CString Out = pThis->m_Templates.sSearch;

	if (!_ParseURL(Data.sURL, _T("downloads")).IsEmpty() && IsSessionAdmin(Data,sSession))
	{
		CString downloads=_ParseURLArray(Data.sURL,_T("downloads"));

		EnumCategories	eCatID = cat == 0 ? CAT_NONE : CCat::GetCatIDByUserIndex(cat);

		CString resToken;
		int curPos=0;
		resToken= downloads.Tokenize(_T("|"),curPos);

		while (!resToken.IsEmpty())
		{
			uchar fileid[16];
			if (resToken.GetLength()==32 && DecodeBase16(resToken.GetBuffer(),resToken.GetLength(),fileid,ARRSIZE(fileid)))
				g_eMuleApp.m_pSearchList->AddFileToDownloadByHash(fileid,eCatID);
			resToken= downloads.Tokenize(_T("|"),curPos);
		}

		cat = cat == 0 ? 0 : CCat::UserCatIndexToCatIndex(cat);
	}

	CString sCat;
	
	if (cat != 0)
		sCat.Format("%i", cat);

	CString sCmd = _ParseURL(Data.sURL, _T("c"));

	if (sCmd.CompareNoCase(_T("update")) == 0 && IsSessionAdmin(Data,sSession))
	{
		g_eMuleApp.m_pGlobPrefs->SetFakeListURL(_ParseURL(Data.sURL, _T("url")));
		g_eMuleApp.m_pFakeCheck->UpdateFakeList();
	}

	if(!_ParseURL(Data.sURL, _T("tosearch")).IsEmpty() && IsSessionAdmin(Data,sSession) )
	{
		// perform search
		g_eMuleApp.m_pdlgEmule->m_dlgSearch.DeleteAllSearchs();
		g_eMuleApp.m_pdlgEmule->m_dlgSearch.DoNewSearch(
			_ParseURL(Data.sURL, _T("tosearch")),
			_ParseURL(Data.sURL, _T("type")),
			_tstol(_ParseURL(Data.sURL, _T("min")))*1048576,
			_tstol(_ParseURL(Data.sURL, _T("max")))*1048576,
		//	Because the availability is used with the 'Min' operator, we decrement the entered value by one to get
		//	more 'useable' results from the server (from a user's POV).
			_tstoi(_ParseURL(Data.sURL, _T("avail"))) - 1,
			_ParseURL(Data.sURL, _T("ext")),
			(_ParseURL(Data.sURL, _T("global"))=="on"),	_T(""));
		Out.Replace(_T("[Message]"),_GetPlainResString(IDS_SW_SEARCHINGINFO));
	}
	else if(!_ParseURL(Data.sURL, _T("tosearch")).IsEmpty() && !IsSessionAdmin(Data,sSession))
		Out.Replace(_T("[Message]"),_GetPlainResString(IDS_ACCESSDENIED));
	else
		Out.Replace(_T("[Message]"), _GetPlainResString(IDS_SW_REFETCHRES));

	CString strTmp = _ParseURL(Data.sURL, "sort");
	
	if (!strTmp.IsEmpty())
		pThis->m_iSearchSortby = atoi(strTmp);
	strTmp = _ParseURL(Data.sURL, "sortAsc");
	if (!strTmp.IsEmpty())
		pThis->m_bSearchAsc = atoi(strTmp);

	sCmd = _ParseURL(Data.sURL, _T("c"));
	if (sCmd.CompareNoCase(_T("menu")) == 0)
	{
		int iMenu = atoi(_ParseURL(Data.sURL, _T("m")));
		bool bValue = atoi(_ParseURL(Data.sURL, _T("v")));
		WSsearchColumnHidden[iMenu] = bValue;
		CString fullpath;
		fullpath.Format(_T("%spreferences.ini"),g_eMuleApp.m_pGlobPrefs->GetConfigDir());
		CIni ini(fullpath);

		ini.SetDefaultCategory(_T("WebServer"));
		ini.SetArray(WSsearchColumnHidden, ELEMENT_COUNT(WSsearchColumnHidden), _T("searchColumnHidden"));
		ini.SaveAndClose();
	}

	CString strResultList = pThis->m_Templates.sSearchHeader;

	strResultList += g_eMuleApp.m_pSearchList->GetWebList(pThis->m_Templates.sSearchResultLine,pThis->m_iSearchSortby,pThis->m_bSearchAsc,!WSsearchColumnHidden[0],!WSsearchColumnHidden[1],!WSsearchColumnHidden[2],!WSsearchColumnHidden[3],!WSsearchColumnHidden[4]);
	if (CCat::GetNumCats()>1)
		InsertCatBox(Out,0,pThis->m_Templates.sCatArrow,false,false,sSession,_T(""));
	else
		Out.Replace("[CATBOX]",_T(""));

	Out.Replace(_T("[SEARCHINFOMSG]"),_T(""));
	Out.Replace(_T("[RESULTLIST]"), strResultList);
	Out.Replace(_T("[Result]"), GetResString(IDS_SW_RESULT));
	Out.Replace(_T("[Session]"), sSession);
	Out.Replace(_T("[Name]"), _GetPlainResString(IDS_SW_NAME));
	Out.Replace(_T("[Type]"), _GetPlainResString(IDS_TYPE));
	Out.Replace(_T("[Any]"), _GetPlainResString(IDS_SEARCH_ANY));
	Out.Replace(_T("[Audio]"), _GetPlainResString(IDS_SEARCH_AUDIO));
	Out.Replace(_T("[Image]"), _GetPlainResString(IDS_SEARCH_PICS));
	Out.Replace(_T("[Video]"), _GetPlainResString(IDS_SEARCH_VIDEO));
	Out.Replace(_T("[Document]"), _GetPlainResString(IDS_SEARCH_DOC));
	Out.Replace(_T("[CDImage]"), _GetPlainResString(IDS_SEARCH_CDIMG));
	Out.Replace(_T("[Program]"), _GetPlainResString(IDS_SEARCH_PRG));
	Out.Replace(_T("[Archive]"), _GetPlainResString(IDS_SEARCH_ARC));
	Out.Replace(_T("[Search]"), _GetPlainResString(IDS_SW_SEARCHBOX));
	Out.Replace(_T("[Show]"), _GetPlainResString(IDS_SHOW));
	Out.Replace(_T("[Size]"), _GetPlainResString(IDS_DL_SIZE));
	Out.Replace(_T("[Sort]"), _GetPlainResString(IDS_PW_SORTING));
	Out.Replace(_T("[Collection]"), _GetPlainResString(IDS_COLLECTION));
	Out.Replace(_T("[Ascending]"), _GetPlainResString(IDS_ASCENDING));
	Out.Replace(_T("[Relevance]"), _GetPlainResString(IDS_RELEVANCE));
	Out.Replace(_T("[Match]"), _GetPlainResString(IDS_MATCH));
	Out.Replace(_T("[SizeMin]"), _GetPlainResString(IDS_SEARCHMINSIZE));
	Out.Replace(_T("[SizeMax]"), _GetPlainResString(IDS_SEARCHMAXSIZE));
	Out.Replace(_T("[Availabl]"), _GetPlainResString(IDS_SEARCHAVAIL));
	Out.Replace(_T("[Extention]"), _GetPlainResString(IDS_SEARCHEXTENSION_LBL));
	Out.Replace(_T("[Global]"), _GetPlainResString(IDS_SW_GLOBAL));
	Out.Replace(_T("[MB]"), _GetPlainResString(IDS_MBYTES));
	Out.Replace(_T("[FakeListHeader]"), _GetPlainResString(IDS_FAKE_UPDATE));
	Out.Replace(_T("[FakeListText]"), _GetPlainResString(IDS_SV_ADDRESS));
	Out.Replace(_T("[FakeListUrl]"), g_eMuleApp.m_pGlobPrefs->GetFakeListURL());
	Out.Replace(_T("[Apply]"), _GetPlainResString(IDS_PW_APPLY));
	Out.Replace(_T("[CatSel]"), sCat);

	CString checked;
	if(g_eMuleApp.m_pGlobPrefs->GetMethod()==1)
		checked = "checked";
	Out.Replace(_T("[checked]"), checked);

	const TCHAR *pcSortIcon = (pThis->m_bSearchAsc) ? pThis->m_Templates.sUpArrow : pThis->m_Templates.sDownArrow;

	_GetPlainResString(&strTmp, IDS_DL_FILENAME);
	if (!WSsearchColumnHidden[0])
	{
		Out.Replace(_T("[FilenameI]"), (pThis->m_iSearchSortby == 0) ? pcSortIcon : "");
		Out.Replace(_T("[FilenameH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FilenameI]"), _T(""));
		Out.Replace(_T("[FilenameH]"), _T(""));
	}
	Out.Replace(_T("[FilenameM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SIZE);
	if (!WSsearchColumnHidden[1])
	{
		Out.Replace(_T("[FilesizeI]"), (pThis->m_iSearchSortby == 1) ? pcSortIcon : "");
		Out.Replace(_T("[FilesizeH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FilesizeI]"), _T(""));
		Out.Replace(_T("[FilesizeH]"), _T(""));
	}
	Out.Replace(_T("[FilesizeM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_FILEHASH);
	if (!WSsearchColumnHidden[2])
	{
		Out.Replace(_T("[FilehashI]"), (pThis->m_iSearchSortby == 2) ? pcSortIcon : "");
		Out.Replace(_T("[FilehashH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FilehashI]"), _T(""));
		Out.Replace(_T("[FilehashH]"), _T(""));
	}
	Out.Replace(_T("[FilehashM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_DL_SOURCES);
	if (!WSsearchColumnHidden[3])
	{
		Out.Replace(_T("[SourcesI]"), (pThis->m_iSearchSortby == 3) ? pcSortIcon : "");
		Out.Replace(_T("[SourcesH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[SourcesI]"), _T(""));
		Out.Replace(_T("[SourcesH]"), _T(""));
	}
	Out.Replace(_T("[SourcesM]"), strTmp);

	_GetPlainResString(&strTmp, IDS_FAKE_CHECK_HEADER);
	if (!WSsearchColumnHidden[4])
	{
		Out.Replace(_T("[FakeCheckI]"), (pThis->m_iSearchSortby == 4) ? pcSortIcon : "");
		Out.Replace(_T("[FakeCheckH]"), strTmp);
	}
	else
	{
		Out.Replace(_T("[FakeCheckI]"), _T(""));
		Out.Replace(_T("[FakeCheckH]"), _T(""));
	}
	Out.Replace(_T("[FakeCheckM]"), strTmp);

	Out.Replace(_T("[Download]"), _GetPlainResString(IDS_DOWNLOAD_VERB));

	strTmp.Format("%i",(pThis->m_iSearchSortby!=0 || (pThis->m_iSearchSortby==0 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE0]", strTmp);
	strTmp.Format("%i",(pThis->m_iSearchSortby!=1 || (pThis->m_iSearchSortby==1 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE1]", strTmp);
	strTmp.Format("%i",(pThis->m_iSearchSortby!=2 || (pThis->m_iSearchSortby==2 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE2]", strTmp);
	strTmp.Format("%i",(pThis->m_iSearchSortby!=3 || (pThis->m_iSearchSortby==3 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE3]", strTmp);
	strTmp.Format("%i",(pThis->m_iSearchSortby!=4 || (pThis->m_iSearchSortby==4 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE4]", strTmp);
	strTmp.Format("%i",(pThis->m_iSearchSortby!=5 || (pThis->m_iSearchSortby==5 && pThis->m_bSearchAsc==0 ))?1:0 );
	Out.Replace("[SORTASCVALUE5]", strTmp);

	return Out;

	EMULE_CATCH
	return _T("");
}

int CWebServer::UpdateSessionCount()
{
	EMULE_TRY

	int oldvalue=m_Params.Sessions.GetSize();
	for(int i = 0; i < m_Params.Sessions.GetSize();)
	{
		CTimeSpan ts = CTime::GetCurrentTime() - m_Params.Sessions[i].startTime;
		if(ts.GetTotalSeconds() > SESSION_TIMEOUT_SECS)
			m_Params.Sessions.RemoveAt(i);
		else
			i++;
	}

	return m_Params.Sessions.GetCount();

	EMULE_CATCH
	return 0;
}

void CWebServer::InsertCatBox(CString &Out,int preselect,CString boxlabel,bool jump,bool extraCats,CString sSession,CString sFileHash)
{
	EMULE_TRY

	CString tempBuf = "<form><select name=\"cat\" size=\"1\"";

	if (jump)
		tempBuf += "onchange=GotoCat(this.form.cat.options[this.form.cat.selectedIndex].value)>";
	else
		tempBuf += ">";

	for (int i = 0; i-1 < CCat::GetNumUserCats(); i++)
	{
		CString strCategory = (i==0)?_GetPlainResString(IDS_CAT_UNCATEGORIZED):CCat::GetUserCatByIndex(i)->GetTitle();
		strCategory.Replace(_T("'"),_T("\'"));
		tempBuf.AppendFormat("<option%s value=\"%i\">%s</option>", (i == preselect) ? " selected" : "", i, strCategory);
	}
	if (extraCats)
	{
		if (CCat::GetNumCats() > 1)
		{
			tempBuf += "<option>------------</option>";
		}

		for (int i = ((CCat::GetNumCats() > 1) ? 1 : 2); i <= 14; i++)
		{
			tempBuf.AppendFormat("<option%s value=\"%i\">%s</option>", (i == preselect) ? " selected" : "", i+100, GetSubCatLabel(i));
		}
	}
	tempBuf.Append("</select></form>");
	Out.Replace("[CATBOX]",boxlabel+tempBuf);

	CString tempBuff3, tempBuff4;
	CString tempBuff;
	CString		strCategory;

	for (int i = 0; i < CCat::GetNumCats(); i++)
	{
		if (i==preselect)
		{
			tempBuff3 = "checked.gif";
			if (i < CCat::GetNumPredefinedCats())
				tempBuff4 = CCat::GetPredefinedCatTitle(CCat::GetCatIDByIndex(i));
			else
				tempBuff4 = CCat::GetCatByIndex(i)->GetTitle();
		}
		else
			tempBuff3 = "checked_no.gif";

		strCategory = (i < CCat::GetNumPredefinedCats()) ? CCat::GetPredefinedCatTitle(CCat::GetCatIDByIndex(i)) : CCat::GetCatByIndex(i)->GetTitle();
		strCategory.Replace(_T("'"),_T("\\'"));

		tempBuff.AppendFormat("<a href=&quot;/?ses=%s&w=transfer&cat=%d&quot;>"
			"<div class=menuitems><img class=menuchecked src=%s>%s&nbsp;</div></a>",
			sSession, i, tempBuff3, strCategory);
	}
	if (extraCats)
	{
		for (int i = ((CCat::GetNumCats() > 1) ? 1 : 2); i <= 14; i++)
		{
			if ((i+CAT_PREDEFINED)==preselect)
			{
				tempBuff3= "checked.gif";
				tempBuff4 = GetSubCatLabel(i);
			}
			else
				tempBuff3 = "checked_no.gif";

			tempBuff.AppendFormat("<a href=&quot;/?ses=%s&w=transfer&cat=%d&quot;>"
				"<div class=menuitems><img class=menuchecked src=%s>%s&nbsp;</div></a>",
				sSession, i + CAT_PREDEFINED, tempBuff3, GetSubCatLabel(i));
		}
	}
	Out.Replace("[CatBox]",tempBuff);
	Out.Replace("[Category]",tempBuff4);

	tempBuff.Empty();

//	For each user category index...
	for (int i = 0; i <= CCat::GetNumUserCats(); i++)
	{
		uchar FileHash[16];

		CPartFile *found_file = g_eMuleApp.m_pDownloadQueue->GetFileByID(StringToHash(sFileHash, FileHash));
	//	Get the user category index of 'found_file' in 'preselect'.
		if (found_file)
			preselect = CCat::GetUserCatIndexByID(found_file->GetCatID());
			//preselect = (CCat::GetUserCatIndexByID(found_file->GetCatID()) == 255)? 0 : CCat::GetUserCatIndexByID(found_file->GetCatID());
		if (i==preselect)
		{
			tempBuff3 = "checked.gif";
			tempBuff4 = CCat::GetCatByUserIndex(i)->GetTitle();
		}
		else
			tempBuff3 = "checked_no.gif";

		strCategory = (i == 0)? GetResString(IDS_CAT_UNASSIGN) : CCat::GetCatByUserIndex(i)->GetTitle();
		strCategory.Replace(_T("'"),_T("\\'"));

		tempBuff.AppendFormat("<a href=&quot;/?ses=%s&w=transfer[CatSel]&op=setcat&file=%s&filecat=%d&quot;>"
			"<div class=menuitems><img class=menuchecked src=%s>%s&nbsp;</div></a>",
			sSession, sFileHash, i, tempBuff3, strCategory);
	}
	Out.Replace("[SetCatBox]",tempBuff);

	EMULE_CATCH
}

CString CWebServer::GetSubCatLabel(byte iCat)
{
	EMULE_TRY

	CString sPlain = CCat::GetPredefinedCatTitle(static_cast<_EnumCategories>(iCat+CAT_PREDEFINED));

	sPlain.Remove(_T('&'));
	sPlain.Replace(_T("'"), _T("&#8217;"));

	return sPlain;

	EMULE_CATCH
	return _T("");
}
